
CMEntity subclass: #PassiveObject
	instanceVariableNames: 'destroyed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!PassiveObject commentStamp: '<historical>' prior: 0!
PassiveObject is an empty class.
An instance of this class or its subclass should be a simple entity of the model, but should belong to the 'world' (it should have a sense in term of the model).!

!PassiveObject methodsFor: 'star control' stamp: 'SergeStinckwich 6/3/2015 09:25'!
delete
"Purpose: gets rid of this object. The collectGarbage is IMMEDIATELY performed  (ie. the receiver of class X is removed from 'theXXXs' collection)"
	self destroyed: true.
	self collector isNil ifFalse:[self collector removeEntity: self]! !

!PassiveObject methodsFor: '- initialize-release' stamp: ' 31/3/15 09:35'!
destroyed
	"Answer if the entity is destroyed or not"
	
	^destroyed ifNil: [destroyed := false]! !

!PassiveObject methodsFor: '- initialize-release' stamp: ' 31/3/15 09:35'!
destroyed: aBoolean
	
	destroyed := aBoolean.
	(aBoolean and: [self isSituated]) ifTrue: [self leave]! !

!PassiveObject methodsFor: '+ testing' stamp: ' 31/3/15 09:35'!
isPassiveObject
	
	^true! !

UIApplicationModel subclass: #CormasLauncher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

CormasLauncher class
	instanceVariableNames: 'theVisualLauncher'!

CormasLauncher class
	instanceVariableNames: 'theVisualLauncher'!

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
adaptSettings
	"self adaptSettings   (called from the ''postLoadActions'') "
	
	self checkVwHomeDirectory.
	self setMessagesPath.
	self setSourceFilePath.
	self setCormasParcelPath.
	self setParcelPathForModels! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
checkVwHomeDirectory
	"Set VISUALWORKS home to DISK/vw/"
	
	| VISUALWORKSpath |
	VISUALWORKSpath := (SystemUtils
		getEnvironmentVariable: 'VISUALWORKS'
		ifAbsent: [Filename defaultDirectoryName]) asFilename.
	VISUALWORKSpath tail = 'cormas'
		ifTrue:
			[SystemUtils
				setEnvironmentVariable: 'VISUALWORKS'
				value: VISUALWORKSpath directory asString.
			VISUALWORKSpath := (SystemUtils getEnvironmentVariable: 'VISUALWORKS')
				asFilename].
	^VISUALWORKSpath	"	| whatIsSet directories newSetting |
	whatIsSet := SystemUtils getEnvironmentVariable: 'VISUALWORKS'
				ifAbsent: [nil].
	whatIsSet notNil 
		ifTrue: 
			[directories := whatIsSet tokensBasedOn: Filename separator.
			('cormas' match: directories last) 
				ifTrue: 
					[directories remove: directories last.
					newSetting := directories first.
					2 to: directories size
						do: 
							[:i | 
							newSetting := newSetting , Filename separator asSymbol asString 
										, (directories at: i)].
					(newSetting asFilename definitelyExists 
						and: [newSetting asFilename isDirectory]) 
							ifTrue: 
								[SourceFileManager default close.
								SystemUtils setEnvironmentVariable: 'VISUALWORKS' value: newSetting.
								ObjectMemory snapshot]]] "! !

!CormasLauncher class methodsFor: 'resources' stamp: ' 26/3/15 16:37'!
cormasEn
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 13 @ 11
				depth: 2
				bitsPerPixel: 2
				palette:
					(MappedPalette
						withColors:
							((Array new: 3)
								at: 1
									put: ColorValue red;
								at: 2
									put: ColorValue blue;
								at: 3
									put: ColorValue white;
								yourself))
				usingBits:
					#[37 98 85 0 73 98 84 128 82 98 82 64 84 162 73 64 85 34 42 128 0 0 0 0 170 2 21 64 88 98 133 64 97 98 97 64 133 98 88 64 21 98 86 0])! !

!CormasLauncher class methodsFor: 'resources' stamp: ' 26/3/15 16:37'!
cormasFr
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 11 @ 8
				depth: 2
				bitsPerPixel: 2
				palette:
					(MappedPalette
						withColors:
							((Array new: 3)
								at: 1
									put: ColorValue blue;
								at: 2
									put: ColorValue red;
								at: 3
									put: ColorValue white;
								yourself))
				usingBits:
					#[0 169 84 0 0 169 84 0 0 169 84 0 0 169 84 0 0 169 84 0 0 169 84 0 0 169 84 0 0 169 84 0])! !

!CormasLauncher class methodsFor: 'init' stamp: 'SergeStinckwich 4/21/2015 16:17'!
launchCormas
	"self launchCormas"
	
	Cormas openEn! !

!CormasLauncher class methodsFor: 'init' stamp: ' 26/3/15 16:37'!
loadLocaleFile
	"FILE_IN de Locale.st, car la parcellisation de Locale provoque au chargement un plantage complet de VW5 !! (???)"
	
	| stFileName |
	stFileName := Cormas cormasPath construct: 'Kernel'.
	stFileName := stFileName construct: 'Locale.st'.
	(stFileName asFilename withEncoding: #Source) fileIn! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setCormasParcelPath
	"Add the Parcel paths : $(VISUALWORKS)/cormas/ "
	
	| parcelPath fileSeparator |
	fileSeparator := String with: Filename separator.
	parcelPath := ('$(VISUALWORKS)' , fileSeparator , 'cormas') asFilename.	"ex: a NTFSFilename('$(VISUALWORKS)\cormas')"	"parcelPath := (SystemUtils getEnvironmentVariable: 'VISUALWORKS') asFilename construct: 'cormas'.   ex: a NTFSFilename('d:\vw7.3nc\cormas')"
	self setParcelPath: parcelPath! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setMessagesPath
	"Add Messages path"
	
	| messagePath fileSeparator |
	fileSeparator := String with: Filename separator.
	messagePath := '$(VISUALWORKS)' , fileSeparator , 'cormas' , fileSeparator
		, 'Messages'.
	((UISettings preferenceModelFor: #messagesListEditing) value includes:
			messagePath)
		ifFalse:
			[(UISettings preferenceModelFor: #messagesListEditing) value
				add: messagePath asString.
			UISettings messagesAccept]! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setParcelPath: aDirectory
	"Add aDirectory to the Parcel paths
	aDirectory = <Filename> "
	
	| list |
	"((UISettings preferenceModelFor: #parcelPathEditing) value "
	((UISettings preferenceModelFor: #parcelPath) value includes: aDirectory)
		ifFalse:
			[(UISettings preferenceModelFor: #parcelPath) value add: aDirectory.	"UISettings parcelPathAccept"	"ne marche pas..."
			list := (UISettings preferenceModelFor: #parcelPath) value.
			(UISettings preferenceModelFor: #parcelPath) value: list.
			SequenceSettingPage new accept]! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setParcelPathForModel: aModelAsString
	"Add Parcel path"
	
	| aPath |
	aPath := Cormas modelPath: aModelAsString.
	self setParcelPath: aPath! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setParcelPathForModels
	"Add the Parcel paths :  $(VISUALWORKS)\cormas\Models\*"
	
	| parcelPath fileSeparator |
	fileSeparator := String with: Filename separator.
	parcelPath := '$(VISUALWORKS)' , fileSeparator , 'cormas' , fileSeparator
		, 'Models' , fileSeparator , '*' , fileSeparator.	"pourquoi le parcelManager (touche F3) ne les voit pas ???"
	parcelPath := (((SystemUtils getEnvironmentVariable: 'VISUALWORKS')
		asFilename construct: 'cormas') construct: 'Models') construct: '*'.	"le pb de cette ligne c est qu'elle met le chemin en dur = d:\vw7.3nc\cormas\Models\* "
	self setParcelPath: parcelPath asFilename! !

!CormasLauncher class methodsFor: 'settings' stamp: ' 26/3/15 16:37'!
setSourceFilePath
	"Add the Source paths : $(VISUALWORKS)/cormas/cormas.cha "
	
	| sourcePath fileSeparator |
	fileSeparator := String with: Filename separator.
	sourcePath := '$(VISUALWORKS)' , fileSeparator , 'cormas' , fileSeparator
		, Cormas cormasName , '.cha'.
	((UISettings preferenceModelFor: #sourcesEditing) value includes:
			sourcePath)
		ifFalse:
			[(UISettings preferenceModelFor: #sourcesEditing) value
				add: sourcePath asString]! !

!CormasLauncher class methodsFor: 'acces' stamp: ' 26/3/15 16:37'!
theVisualLauncher
	
	^theVisualLauncher! !

!CormasLauncher class methodsFor: 'acces' stamp: ' 26/3/15 16:37'!
theVisualLauncher: aVisualLauncher
	
	theVisualLauncher := aVisualLauncher! !

!CormasLauncher class methodsFor: 'interface specs' stamp: ' 26/3/15 16:37'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Cormas Launcher' 
			#min: #(Point 185 126) 
			#max: #(Point 185 126) 
			#bounds: #(Rectangle 640 427 825 553)) 
		#component: #(SpecCollection 
			#collection: #(#(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 106 84 143 113) 
				#name: #ActionButton1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #launchCormasInFrench 
				#helpText: 'Ouvrir Cormas en Francais' 
				#label: #cormasFr 
				#hasCharacterOrientedLabel: false 
				#style: #small) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 106 42 143 71) 
				#name: #ActionButton2 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #launchCormasInEnglish 
				#helpText: 'Open Cormas in English' 
				#label: #cormasEn 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 8 2) 
				#name: #Label1 
				#label: 'Open Cormas' 
				#style: #large) #(LabelSpec 
				#layout: #(Point 19 47) 
				#name: #Label2 
				#label: 'in English') #(LabelSpec 
				#layout: #(Point 19 89) 
				#name: #Label3 
				#label: 'en Francais'))))! !

!CormasLauncher methodsFor: 'actions' stamp: 'SergeStinckwich 4/21/2015 16:09'!
launchCormas
	
	Cormas openEn! !

!CormasLauncher methodsFor: 'actions' stamp: 'SergeStinckwich 4/21/2015 16:10'!
launchCormasInEnglish
	
	Cormas openCormasEn.
	self closeRequest! !

!CormasLauncher methodsFor: 'actions' stamp: 'SergeStinckwich 4/21/2015 16:10'!
launchCormasInFrench
	
	Cormas openCormasFr.
	self closeRequest! !

UIApplicationModel subclass: #ManipulationSetter
	instanceVariableNames: 'cormasModel classAttribValue_List selectedRow methodsForManip_List entity entityChoices applyToSubclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ManipulationSetter class methodsFor: 'interface specs' stamp: ' 30/3/15 16:19'!
labelControl
	
	^'Use for
control' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!ManipulationSetter class methodsFor: 'interface specs' stamp: ' 30/3/15 16:19'!
labelInit
	
	^'Use for
init' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!ManipulationSetter class methodsFor: 'interface specs' stamp: ' 30/3/15 16:19'!
labelTesting
	
	^'Use for
testing' asText asComposedText	"^('Employee
Number' asText emphasizeAllWith: (Array with: #bold with: #color->ColorValue red)) asComposedText"! !

!ManipulationSetter class methodsFor: 'interface specs' stamp: ' 30/3/15 16:19'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #sizeType #specifiedSize #positionType #positionSystemDefault #openType #advanced) 
			#label: 'Manipulation Methods Setter' 
			#min: #(Point 427 371) 
			#max: #(Point 2200 2200) 
			#bounds: #(Rectangle 840 525 1267 896) 
			#flags: 8 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 6655 8191 5119))) 
		#component: #(SpecCollection 
			#collection: #(#(DataSetSpec 
				#properties: #(PropertyListDictionary #showVerticalLines true #allowColumnReordering true #showLineNumbers true #allowColumnResizing true #rowLabelsAsButtons false #showHorizontalLines true) 
				#layout: #(LayoutFrame 0 0 65 0 0 1.0 0 1.00563) 
				#name: #Dataset1 
				#model: #methodsForManip_List 
				#columns: #(#(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication false #allowSorting false #allowResizing false) 
					#label: ' N¬∞' 
					#labelIsImage: false 
					#width: 30 
					#rendererType: #rowSelector 
					#editorType: #rowSelector 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication false #allowSorting true #allowResizing true) 
					#model: #'selectedRow methodAsString' 
					#label: 'Method' 
					#labelIsImage: false 
					#width: 160 
					#rendererType: #Text 
					#editorType: #Label 
					#noScroll: true) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isInit' 
					#label: #labelInit 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isControl' 
					#label: #labelControl 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication true #allowSorting true #allowResizing true) 
					#model: #'selectedRow isTesting' 
					#label: #labelTesting 
					#labelIsImage: true 
					#width: 70 
					#rendererType: #CheckBox 
					#editorType: #CheckBox 
					#noScroll: false)) 
				#labelsAsButtons: true) #(ActionButtonSpec 
				#layout: #(Rectangle 309 35 384 58) 
				#name: #applyClose 
				#model: #finalize 
				#label: 'Apply - Close' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 241 35 296 58) 
				#name: #Apply 
				#model: #saveValues 
				#label: 'Apply' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 140 35 228 58) 
				#name: #SetDefaultValues 
				#model: #setDefaultValues 
				#label: 'Default settings' 
				#defaultable: true) #(ComboBoxSpec 
				#layout: #(Rectangle 246 5 384 27) 
				#name: #ComboBox1 
				#model: #entity 
				#comboList: #entityChoices) #(LabelSpec 
				#layout: #(Point 9 3) 
				#name: #Label1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7679 8191 7167)) 
				#label: 'Set manipulation methods of Entity' 
				#style: #systemDefault) #(CheckBoxSpec 
				#layout: #(Point 15 35) 
				#name: #applyToSubclasses 
				#flags: 16 
				#model: #applyToSubclasses) #(LabelSpec 
				#layout: #(Point 34 28) 
				#name: #labelapplyToSubclasses1 
				#flags: 16 
				#label: 'Apply to') #(LabelSpec 
				#layout: #(Point 34 41) 
				#name: #labelapplyToSubclasses2 
				#flags: 16 
				#label: 'subclasses'))))! !

!ManipulationSetter methodsFor: 'aspects' stamp: ' 30/3/15 16:19'!
applyToSubclasses
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^applyToSubclasses isNil
		ifTrue: [applyToSubclasses := false asValue]
		ifFalse: [applyToSubclasses]! !

!ManipulationSetter methodsFor: 'initialize-release' stamp: ' 30/3/15 16:19'!
changeEntity
	
	| aList aMS |
	"collect all methods by using the setDefaultValues method, put them in the dataset, and then set back all the settings to false"
	self setDefaultValues.
	aList := self methodsForManip_List list copy.
	aList
		do:
			[:i | 
			i isInit: false.
			i isControl: false.
			i isTesting: false].	"read user defined preferences. If the preferences exists, set default value to fasle and then overwrite the preferences in the dataset"
	(self entityClass class selectors includes: #methodsForInit_UserDefined)
		ifTrue:
			[self entityClass methodsForInit_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isInit: true]]].
	(self entityClass class selectors includes: #methodsForControl_UserDefined)
		ifTrue:
			[self entityClass methodsForControl_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isControl: true]]].
	(self entityClass class selectors includes: #methodsForTesting_UserDefined)
		ifTrue:
			[self entityClass methodsForTesting_UserDefined
				do:
					[:m | 
					aMS := aList
						detect: [:i | i methodName = m asString]
						ifNone: [nil].
					aMS ifNotNil: [aMS isTesting: true]]].
	self methodsForManip_List list: aList.
	self entityClass subclasses isEmpty
		ifFalse:
			[self applyToSubclasses value: true.
			(self builder componentAt: #applyToSubclasses) isVisible: true.
			(self builder componentAt: #labelapplyToSubclasses1) isVisible: true.
			(self builder componentAt: #labelapplyToSubclasses2) isVisible: true]
		ifTrue:
			[self applyToSubclasses value: false.
			(self builder componentAt: #applyToSubclasses) isVisible: false.
			(self builder componentAt: #labelapplyToSubclasses1) isVisible: false.
			(self builder componentAt: #labelapplyToSubclasses2) isVisible: false]! !

!ManipulationSetter methodsFor: 'accessing' stamp: ' 30/3/15 16:19'!
cormasModel
	
	^cormasModel! !

!ManipulationSetter methodsFor: 'accessing' stamp: ' 30/3/15 16:19'!
cormasModel: anObject
	
	cormasModel := anObject! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
defaultValuesForClass: aClass category: aSymbol
	
	| aList i cat |
	aList := List new.
	cat := aSymbol asString.
	cat
		at: 1
		put: cat first asUppercase.
	(aClass perform: ('methodsFor' , cat) asSymbol)
		do:
			[:m | 
			i := ClassManipulationMethod new.
			i
				targetClass: aClass;
				methodName: m;
				isInit: cat = 'Init';
				isControl: cat = 'Control';
				isTesting: cat = 'Testing'.
			aList add: i].
	^aList! !

!ManipulationSetter methodsFor: 'aspects' stamp: ' 30/3/15 16:19'!
entity
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entity isNil
		ifTrue: [entity := String new asValue]
		ifFalse: [entity]! !

!ManipulationSetter methodsFor: 'aspects' stamp: ' 30/3/15 16:19'!
entityChoices
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entityChoices isNil
		ifTrue: [entityChoices := List new asValue]
		ifFalse: [entityChoices]! !

!ManipulationSetter methodsFor: 'accessing' stamp: 'SergeStinckwich 5/29/2015 14:29'!
entityClass
	
	^self entity value class! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
finalize
	
	self saveValues.
	self closeAndUnschedule! !

!ManipulationSetter methodsFor: 'aspects' stamp: ' 30/3/15 16:19'!
methodsForManip_List
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^methodsForManip_List isNil
		ifTrue:
			[methodsForManip_List := SelectionInListSortAware new.
			methodsForManip_List selectionIndexHolder
				compute: [:v | self selectedRow value: methodsForManip_List selection].
			methodsForManip_List]
		ifFalse: [methodsForManip_List]! !

!ManipulationSetter methodsFor: 'initialize-release' stamp: ' 30/3/15 16:19'!
openOn: aModel
	
	| win |
	cormasModel := aModel.
	self prepareTable.
	win := (self allButOpenInterface: #windowSpec) window.
	win open.
	entity value: entityChoices value first! !

!ManipulationSetter methodsFor: 'initialize-release' stamp: ' 30/3/15 16:19'!
prepareTable
	
	| modelClasses |
	modelClasses := OrderedCollection new.
	modelClasses addAll: (cormasModel spatialClasses collect: [:cl | cl name]).
	modelClasses addAll: (cormasModel socialClasses collect: [:cl | cl name]).
	modelClasses
		addAll: (cormasModel passiveObjectClasses collect: [:cl | cl name]).
	entityChoices := (List withAll: modelClasses) asValue.
	self entity onChangeSend: #changeEntity to: self.	"self setDefaultValues."
	super initialize! !

!ManipulationSetter methodsFor: 'initialize-release' stamp: ' 30/3/15 16:19'!
requestForWindowClose
	
	cormasModel := nil.
	^super requestForWindowClose! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
saveValues
	
	| methodsName |
	"collect user define Init methods for a class"
	methodsName := (self methodsForManip_List list
		select: [:i | i isInit = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForInit_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForInit_UserDefined inClass: c]].	"collect user define Control methods for a self entityClasslass"
	methodsName := (self methodsForManip_List list
		select: [:i | i isControl = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForControl_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForControl_UserDefined inClass: c]].	"collect user define Testing methods for a self entityClasslass"
	methodsName := (self methodsForManip_List list
		select: [:i | i isTesting = true]) collect: [:i | i methodName].
	self
		write: methodsName
		inMethod: #methodsForTesting_UserDefined
		inClass: self entityClass.
	self applyToSubclasses value
		ifTrue:
			[self entityClass subclasses
				do:
					[:c | self write: methodsName inMethod: #methodsForTesting_UserDefined inClass: c]]! !

!ManipulationSetter methodsFor: 'aspects' stamp: ' 30/3/15 16:19'!
selectedRow
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^selectedRow isNil
		ifTrue: [selectedRow := nil asValue]
		ifFalse: [selectedRow]! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
selectedRowClassNameAsStringLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x classNameAsString displayString <= y classNameAsString displayString].
	dscSortBlock := [:x :y | x classNameAsString displayString >= y classNameAsString displayString].
	sortBlock := self methodsForManip_List sortAspect ==
			#selectedRowClassNameAsString
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowClassNameAsString.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
selectedRowIsControlLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isControl displayString <= y isControl displayString].
	dscSortBlock := [:x :y | x isControl displayString >= y isControl displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsControl
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsControl.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
selectedRowIsInitLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isInit displayString <= y isInit displayString].
	dscSortBlock := [:x :y | x isInit displayString >= y isInit displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsInit
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsInit.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
selectedRowIsTestingLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x isTesting displayString <= y isTesting displayString].
	dscSortBlock := [:x :y | x isTesting displayString >= y isTesting displayString].
	sortBlock := self methodsForManip_List sortAspect == #selectedRowIsTesting
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowIsTesting.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
selectedRowMethodAsStringLabelPressed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."
	
	| ascSortBlock dscSortBlock sortBlock |
	ascSortBlock := [:x :y | x methodAsString displayString <= y methodAsString displayString].
	dscSortBlock := [:x :y | x methodAsString displayString >= y methodAsString displayString].
	sortBlock := self methodsForManip_List sortAspect ==
			#selectedRowMethodAsString
		ifTrue:
			[self methodsForManip_List sortDirection == #asc
				ifTrue:
					[self methodsForManip_List sortDirection: #dsc.
					ascSortBlock]
				ifFalse:
					[self methodsForManip_List sortDirection: #asc.
					dscSortBlock]]
		ifFalse:
			[self methodsForManip_List sortAspect: #selectedRowMethodAsString.
			self methodsForManip_List sortDirection: #dsc.
			ascSortBlock].
	self methodsForManip_List
		refreshList:
			(SortedCollection
				withAll: self methodsForManip_List list
				sortBlock: sortBlock) asList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
setDefaultValues
	
	| aList |
	aList := List new.
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #init).
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #control).
	aList
		addAll:
			(self
				defaultValuesForClass: self entityClass
				category: #testing).
	self methodsForManip_List list: aList! !

!ManipulationSetter methodsFor: 'actions' stamp: ' 30/3/15 16:19'!
setDefaultValuesAndApply
	
	self setDefaultValues.
	self saveValues! !

!ManipulationSetter methodsFor: 'write in class' stamp: ' 30/3/15 16:19'!
write: stringArray inMethod: selector inClass: aClass
	
	| class s |
	class := aClass class.
	s := WriteStream on: String new.
	s
		nextPutAll: selector;
		cr.
	s
		tab;
		crtab;
		nextPutAll: '^#('.
	stringArray do: [:mn | s nextPutAll: '#' , mn , ' '].
	s nextPutAll: ')'.
	class
		compile: s contents
		classified: #manipulation! !

UIApplicationModel subclass: #PovSetterNotebook
	instanceVariableNames: 'majorKeys cormasModel cormas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!PovSetterNotebook commentStamp: '<historical>' prior: 0!
Notebook4Example demonstrates the use of a subcanvas within a notebook widget, making each page of the notebook a different application. !

!PovSetterNotebook class methodsFor: 'interface specs' stamp: ' 31/3/15 09:48'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #sizeType #specifiedSize #positionType #screenCenter #openType #advanced) 
			#label: 'PoV Setter' 
			#min: #(Point 765 440) 
			#max: #(Point 0 0) 
			#bounds: #(Rectangle 674 449 1439 889) 
			#colors: #(LookPreferences)) 
		#component: #(SpecCollection 
			#collection: #(#(NoteBookSpec 
				#layout: #(LayoutFrame 4 0 5 0 772 0 438 0) 
				#name: #pageHolder 
				#isOpaque: true 
				#model: #majorKeys 
				#tabable: true 
				#binderWidth: 10 
				#rightInset: 100 
				#bottomInset: 0))))! !

!PovSetterNotebook methodsFor: 'change messages' stamp: 'HernanMoralesDurand 1/25/2018 18:57'!
changedExample
	
	| sel modelClass povSetter |
	sel := self majorKeys selection.
	sel isNil ifTrue: [^self].
	modelClass := sel class.
	(modelClass inheritsFrom: CMArcEntity)
		ifTrue: [povSetter := PovSetter_Arc new]
		ifFalse:
			[modelClass isSpatialClass
				ifTrue: [povSetter := CMSpecPovSetter_SpatialEntity new]
				ifFalse: [povSetter := PovSetter_Agent new]].
	povSetter cormas: cormas.
	(self builder componentAt: #pageHolder) widget client: povSetter spec:
			#windowSpec.
	povSetter setModelClass: modelClass! !

!PovSetterNotebook methodsFor: 'accessing' stamp: ' 31/3/15 09:48'!
cormas
	
	^cormas! !

!PovSetterNotebook methodsFor: 'accessing' stamp: ' 31/3/15 09:48'!
cormas: anObject
	
	cormas := anObject! !

!PovSetterNotebook methodsFor: 'accessing' stamp: ' 31/3/15 09:48'!
cormasModel
	
	^cormasModel! !

!PovSetterNotebook methodsFor: 'accessing' stamp: ' 31/3/15 09:48'!
cormasModel: anObject
	
	cormasModel := anObject! !

!PovSetterNotebook methodsFor: 'aspects' stamp: ' 31/3/15 09:48'!
majorKeys
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^majorKeys isNil
		ifTrue: [majorKeys := SelectionInList new]
		ifFalse: [majorKeys]! !

!PovSetterNotebook methodsFor: 'initialize-release' stamp: ' 31/3/15 09:48'!
openOn: aModel
	
	| win |
	cormasModel := aModel.
	self prepareClasses.
	win := (self allButOpenInterface: #windowSpec) window.
	win open	"win openIn: (10 @ 20 extent: win maximumSize)"! !

!PovSetterNotebook methodsFor: 'initialize-release' stamp: ' 31/3/15 09:48'!
prepareClasses
	
	| modelClasses |
	modelClasses := OrderedCollection new.
	modelClasses add: cormasModel cellClass name.
	modelClasses
		addAll: (cormasModel compoundSpatialClasses collect: [:cl | cl name]).
	modelClasses
		addAll:
			((cormasModel socialClasses select: [:cl | cl isSituatedClass])
				collect: [:cl | cl name]).
	modelClasses
		addAll:
			((cormasModel passiveObjectClasses select: [:cl | cl isSituatedClass])
				collect: [:cl | cl name]).
	majorKeys := SelectionInList with: modelClasses.	"asSortedCollection"
	majorKeys selectionIndexHolder onChangeSend: #changedExample to: self! !

!PovSetterNotebook methodsFor: 'initialize-release' stamp: ' 31/3/15 09:48'!
requestForWindowClose
	
	cormas visualStateWin: nil.
	cormasModel := nil.
	^super requestForWindowClose! !

UIApplicationModel subclass: #SimManager
	instanceVariableNames: 'cormasModel simNumero randomSeed simName enableBackward dontAsk simFolder nextStep buttonsForwardAreOn deviationChoice listControle releaseRandomSeed listProbes fixRandomSeed listInit finalStep enableBackwardValue traceSize processRun processReplayBackward processReplayForward undoList redoList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

SimManager class
	instanceVariableNames: 'newFolder'!

!SimManager commentStamp: '<historical>' prior: 0!
SimManager is an auxiliary class of CormasModel. Its purpose is to support CormasModel in the management of ONE simulation.
Thus, it is a crucial for triggering: 1 step, 1 run or 1 complete analysis.
SimManager is also responsible of the the Replays (forward or backward).
(1 instance of CormasModel is always linked with 1 instance of SimManager)

Instance Variables:
	buttonsForwardAreOn	<Boolean>	description of buttonsForwardAreOn
	cormasModel	<CormasModel>	description of cormasModel
	deviationChoice	<ValueModel>	description of deviationChoice
	dontAsk	<ValueHolder>	description of dontAsk
	enableBackward	<Boolean>	description of enableBackward
	enableBackwardValue	<ValueModel>	description of enableBackwardValue
	finalStep	<ValueModel>	description of finalStep
	fixRandomSeed	<ValueModel>	description of fixRandomSeed
	listControle	<SelectionInList>	description of listControle
	listInit	<SelectionInList>	description of listInit
	listProbes	<MultiSelectionInList>	description of listProbes
	nextStep	<ValueHolder>	description of nextStep
	process	<Process>	description of process
	randomSeed	<ValueModel>	description of randomSeed
	releaseRandomSeed	<ValueModel>	description of releaseRandomSeed
	simFolder	<Filename>	description of simFolder
	simName	<String>	description of simName
	simNumero	<SmallInteger>	description of simNumero
	traceSize	<SmallInteger>	description of traceSize

!

SimManager class
	instanceVariableNames: 'newFolder'!

!SimManager class methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
bosExtension
	
	^'.bos'! !

!SimManager class methodsFor: 'interface specs' stamp: ' 31/3/15 09:57'!
changeStepInterface
	"Tools.UIPainter new openOnClass: self andSelector: #changeStepInterface"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #sizeAutoSave false #openType #advanced #sizeType #lastSavedSize #positionType #lastSavedPosition #labelFromApplication false #positionAutoSave true) 
			#label: '#step method choice' 
			#min: #(Point 265 305) 
			#max: #(Point 265 305) 
			#bounds: #(Rectangle 960 540 1225 845) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(SequenceViewSpec 
				#layout: #(LayoutSizedOrigin 12 0 27 0 236 154) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 8191 7679 7167)) 
				#model: #listControle 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #actionModifierControle) 
				#helpText: 'select a control method. Ctrl click for several selections') #(ActionButtonSpec 
				#layout: #(Rectangle 146 266 209 298) 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #accept 
				#label: 'Apply' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 51 266 113 298) 
				#name: #cancel 
				#model: #cancel 
				#label: 'Cancel' 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 12 6) 
				#label: 'Select a method of' 
				#style: #systemDefault 
				#mnemonic: #'22') #(LabelSpec 
				#layout: #(Point 127 6) 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red)) 
				#label: 'control' 
				#style: #systemDefault) #(CheckBoxSpec 
				#layout: #(Point 13 215) 
				#name: #releaseRandomSeed 
				#model: #releaseRandomSeed 
				#label: 'Initialize  randomness') #(CheckBoxSpec 
				#layout: #(Point 13 238) 
				#name: #CheckBox2 
				#model: #enableBackwardValue 
				#helpText: 'Backward option will store each step of the model' 
				#label: 'Enable stepping back') #(LabelSpec 
				#layout: #(Point 12 190) 
				#name: #Label1 
				#label: 'Final step:') #(InputFieldSpec 
				#layout: #(Rectangle 74 189 145 211) 
				#name: #InputField1 
				#model: #finalStep 
				#type: #number 
				#formatString: '0'))))! !

!SimManager class methodsFor: 'resources' stamp: ' 31/3/15 09:57'!
deviation2image
	"Tools.UIMaskEditor new openOnClass: self andSelector: #deviation2image"
	
	<resource: #image>
	^Image
		extent: 198 @ 64
		depth: 11
		bitsPerPixel: 16
		palette:
			(MappedPalette
				withColors:
					(#(#(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(0 0 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6809 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6295 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4175 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4400 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 4978 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2826)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2537 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1830 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5010 1156 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4978 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1349 2858 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 4561 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2473 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5492 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 5910 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6103 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4368 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 5332 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2858)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4432 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3950 4432 2858)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3950 4336 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5043 1156 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 3983 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 4625 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5589 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2505 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 3950 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7130 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 7484 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 6199 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7034 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5524 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 4047 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2890 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2923 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2344 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1798 1381)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3758 3758 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3115 3693 1670)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1863 1349)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 1927 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1895 1895 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5846 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7066 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4400 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 5621 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2890 4689 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 3276 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2312 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1863 1349)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2890 1477 4143)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1606 2826 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 1156 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5749 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 3983 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4015 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6584 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 4818 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3886 4721 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3147 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 1734 3051)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 1156 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3918 4272 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 3372 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 3501 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2537 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7516 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7195 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 5942 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2633 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 5171 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5075 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1830 1445)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 1156 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 5910 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4079 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7098 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2569 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4015 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(64 64 64)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 6167 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5589 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 5107 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 3308 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3180 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 3147 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1895 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1927 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 1124 770)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 3404 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2409 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7291 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7130 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5653 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 5621 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 4818 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3147 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3115 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 3469 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1863 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1927 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2826 3822 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4015 4721 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7195 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5621 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4111 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4753 4753 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2601 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1863 1509)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2890 2890 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3822 3822 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 2087 1702)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 1316 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 1188 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 1959 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7259 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7163 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5878 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 4753 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 4657 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2794 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3180 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3212 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 1188 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2537 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2473 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 5107 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 4689 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 5685 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 5974 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2666 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5910 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5685 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4529 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5653 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4400 4689 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4143 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 1188 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 6295 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 6263 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5428 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4529 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 5685 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 3372 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 4786 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1927 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1509)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2216 3822 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 1991 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2923 2923 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 2505 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 4593 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5910 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2666 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7195 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5717 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2666 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5942 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 4978 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4561 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 4753 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3212 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2987 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 1188 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1991 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2698 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4175 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7227 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 5717 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 5235 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 5364 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5171 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2923 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 3212 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1573)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 4657 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4753 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 5749 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7612 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7259 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6520 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4593 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 5043 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3244 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 3372 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 1188 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1606)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3276 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1702 2955 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2955 2955 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2923 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 4464 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6199 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 6617 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 4207 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 6295 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3244 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3308 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4946 1766 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 1284 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2698 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2794 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 3212 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2730 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7291 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5749 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4625 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 5749 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4464 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2762 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5781 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6231 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 6713 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4368 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4689 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6360 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3276 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3918 3918 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 1220 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 4850 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2858 1798 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2055 2055 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(192 192 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7387 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7452 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7355 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5814 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6392 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4657 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4400 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 3565 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4111 4882 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2730 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 2152 1766)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 1220 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4914 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 1124 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4272 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7323 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7387 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6199 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 4721 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4946 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3372 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3308 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 3051 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2023 1702)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 1220 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 1381 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 1124 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2698 3950 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 3212 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4497 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2794 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4304 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7420 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6070 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6745 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6103 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4721 4625)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 5075 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4978 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3051 4882 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2890 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4529 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 1220 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 5814 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3019 3019 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3276 3822 1959)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7420 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6103 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4689 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4721 4625)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 4946 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3340 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 3758 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2055 1734)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 1477 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 3180 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7387 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7452 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4818 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 5139 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2858 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2858 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1220 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4143 4497 3276)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 6777 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 6263 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4721 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 4850 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 3693 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3404 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6520 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 5878 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2120 1734)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3983 3983 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3051 3051 3051)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1220 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2890 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 2120 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7420 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7709 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6135 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5010 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4786 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4753 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2087 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 2376 2087)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 2184 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7420 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6327 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 6263 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4753 4721)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 5524 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4400 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3404 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3469 3276)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 1541 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1252 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 1798 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1670 3115 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 3372 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7516 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 6809 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 5235 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 5203 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4946 4946 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 4946 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3469 3276)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2120 1830)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 2248 1863)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 1606 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1188 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5010 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4464 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2955 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7452 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4432 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7484 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6488 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4786 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 5460 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 4914 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3437 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3115 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4818 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2923 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1188 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7548 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7484 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6199 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6584 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4818 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 5396 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6552 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3469 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3501 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 1252 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2152 1863)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 3533 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1188 32)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1220 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3115 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3244 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 5910 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4497 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7516 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6552 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6777 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 5492 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 5910 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5171 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4978 4978 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 3822 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4464 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5043 2023 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3115 3115 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1252 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2698 4047 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2987 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2184 2184 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1252 1252 1252)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7516 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7612 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7516 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 6006 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4882 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 2890 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 3918 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2376 4079 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2216 1863)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1252 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 2280 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 1477 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 3147 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 2955 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4497 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 2987 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 1509 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7548 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6263 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6295 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5171 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4882 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 5460 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 3886 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 5107 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2376 4047 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1284 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 995 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 1060 931)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3404 3886 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1509 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7805 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7869 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7580 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4625 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3533 3404)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 3886 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 3983 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 1252 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3147 3147 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1252 96)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2216 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2248 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 2087 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4657 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4593 3372)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7612 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 6552 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6038 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7580 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4882 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5075 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 3822 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 3501 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 2344 2023)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 2312 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 3854 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3372 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 96)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 6520 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6070 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4561 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 3918 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 3886 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 3469 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 3083 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3051 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7837 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7612 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6327 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6906 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4914 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4946 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 5974 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3597 3437)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 1284 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2248 1991)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 1959 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 160)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 2344 2023)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3180 3180 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4240 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 5621 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1316 1316 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4561 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3083 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(385 385 385)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7612 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6938 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 5685 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 6103 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 3950 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2473 4111 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1477 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7644 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6777 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5428 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3597 3501)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3212 5043 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2280 2023)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 1284 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 995 1766)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1316 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3629 3469)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3180 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7869 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6392 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6006 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5010 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 5589 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3115 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 6006 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1541 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 1766 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3565 3822 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1959 3244 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3212 3212 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3469 3950 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1638 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7677 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1349 1349 1349)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(417 417 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 6584 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 6135 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4978 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5492 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 4464 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3212 5075 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2312 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 2376 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 1573 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2505 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 2537 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(899 2312 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4850 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4657 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1638 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7677 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6360 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 6167 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4914 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5043 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 3822 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3212 5075 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3147 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1606 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 3469 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 321)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4368 963 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1316 289)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3597 3918 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 3693 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4753 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7901 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7934 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7709 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6424 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5010 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 6038 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 3726 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2344 2087)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4175 4175 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3180 4207 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1670 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3244 3244 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1349 289)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2376 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 5107 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3180 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1381 1381 1381)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 7002 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5075 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 5300 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3212 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3212 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2409 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 1316 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 1381 513)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1349 321)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1702 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1702 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7837 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7773 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 5781 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 5460 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5396 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 4111 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 3533 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 2152 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 2312 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 1895 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2216 3244 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3501 4207 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 4143 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5396 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 4721 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7837 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 6745 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 6070 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 6103 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 5942 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3693 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 3886 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 4207 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2376 2152)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 2441 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 2537 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2344 2344 2344)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 6649 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1413 1413 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7805 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7773 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 6552 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4753 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5075 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5460 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3501 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3726 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4850 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3244 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 6263 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4529 995 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1349 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7869 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3726 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 4175 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 3758 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2409 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 3790 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1381 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2505 4240 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 2537 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 2473 2152)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1927 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1766 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3276 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7837 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7966 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 7034 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6520 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5107 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 5300 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3308 5139 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 4207 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 2633 2376)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 1413 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 5171 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 1316 1092)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4497 995 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4400 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5043 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1445 1445 1445)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 6103 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7805 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4786 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3276 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7805 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7837 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 4914 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 5235 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3758 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 3983 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2633 2376)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2441 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4304 4464 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1381 481)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 3918 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 5589 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5300 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7901 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6520 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 5267 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5781 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3790 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3308 5171 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3533 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 3886 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 3758 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7869 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6584 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 6938 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 7066 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5749 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 5203 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 5203 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 3950 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3469 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2473 2248)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4272 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3340 3340 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1413 513)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2505 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 1670 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2409 2409 2409)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1477 1477 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4336 4593 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3308 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 6809 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 1830 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3340 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7901 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7901 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 5203 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5814 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 6199 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3372 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 4850 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 2858 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 2312 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 2087 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 1445 578)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7934 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6617 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5203 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5846 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 4175 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3918 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 4079 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2698 2441)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 1027 2280)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 3790 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3533 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1060 2441 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6584 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 7098 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6038 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 6167 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 5235 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3886 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 5139 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 4786 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 1606 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7934 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1445 578)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1895 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2441 2441 2441)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3372 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7934 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 6745 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5235 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6135 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 5653 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3276 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5717 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2537 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 2858 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 5621 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4882 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1927 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1092 2473 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7966 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6617 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7966 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6070 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 5557 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6070 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3886 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 4047 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2601 2280)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 2473 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 1606 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1413 674)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3437 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4946 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1060 2505 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1156 2473 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4914 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 7130 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6681 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 6199 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 5267 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 5846 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3533 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2601 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3501 4336 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 6456 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7998 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7998 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 6970 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5267 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5075 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5139 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3950 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 4368 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2633 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 2569 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3822 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1477 674)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 1541 835)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4946 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3469 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3469 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 1959 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7998 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6199 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6167 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 4304 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 3983 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 1959 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3661 4143 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8094 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8030 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6970 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6038 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6231 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3950 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3918 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4464 4721 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 6263 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 2923 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3661 4175 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 1060 2280)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3437 3437 3437)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2505 2505 2505)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 3180 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4978 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 6552 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(642 642 642)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8126 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8062 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 5428 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5910 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3533 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2826 2569)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 1895 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1509 738)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4657 1027 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8062 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 6552 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 5653 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5332 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3983 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3533 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2633 2441)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 2858 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 1573 1573)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1509 770)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3533 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8126 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8094 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8062 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6713 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 7066 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6777 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 5460 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 5332 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 4561 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 2923 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 5043 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1509 803)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2537 2537 2537)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1606 1606 1606)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8094 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8094 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6745 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6777 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6392 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 4143 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3565 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 2890 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 1895 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1477 867)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6745 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 6617 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5814 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5589 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 4529 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3758 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 2248 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2698 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 1734 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4721 5332 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8126 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 7227 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6295 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6295 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 7227 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 4464 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3854 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 4432 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 2923 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2087 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3790 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2473 3501 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4561 4818 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8158 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6777 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6070 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3597 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4047 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 2344 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2698 2537)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2730 2505)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1573 867)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2184 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 2666 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2120 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 6649 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5428 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5460 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 4111 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 4175 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3693 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2248 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 2312 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5428 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1188 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5717 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6874 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 7259 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6327 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 6327 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5492 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6103 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4464 4464 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2730 2569)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 2826 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 1316 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3533 3533 3533)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2601 2601 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1766 2376 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 2890 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 2376 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1670 1670 1670)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2152 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6681 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5460 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6006 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 5621 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 5781 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 4561 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 2473 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 6295 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3661 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3758 4207 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5171 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2087 2280 3469)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2152 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 7387 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 7259 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5524 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 4721 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 4336 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 6327 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 3083 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2762 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 6360 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1606 963)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 1092 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3790 4207 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 5171 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 7291 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5524 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6713 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 4207 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 5717 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3918 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1606 995)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(770 770 770)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6745 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 7291 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6103 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 4432 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 4753 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2794 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2826 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 3019 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1638 995)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4818 1092 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3726 4497 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 5428 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3726 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2216 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2216 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5524 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5557 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 5781 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5653 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3983 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 4657 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5621 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6520 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 1092 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2826 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 1991 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 3308 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5621 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6906 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5460 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 5621 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3758 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2376 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1670 1027)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 1670 1092)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3822 4272 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6777 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5235 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 4047 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 5781 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2858 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3758 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6809 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 4464 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4240 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4336 5428 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 2730 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 3019 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 2858 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 3115 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1638 1124)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 1092 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2280 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2312 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5589 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 4432 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 4625 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 4336 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2890 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2923 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 2794 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1702 1092)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 1092 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3822 4304 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2441 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2055 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1766 1766 1766)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6970 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6809 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5653 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5492 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 4497 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2890 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4721 5075 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 2312 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1670 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 3661 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1445 2666 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6841 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 5621 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5814 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3822 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 4850 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4689 4914 4143)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 2344 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5364 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1734 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 1124 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1413 2730 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 6456 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5364 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 3822 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 5910 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2923 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 1798 1284)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1734 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4593 4593 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2730 2730 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1798 1798 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6874 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 6295 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5396 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4272 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 4625 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 4818 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2826 4593 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2987 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1702 1220)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 1927 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1766 1188)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1413 2762 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4304 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2344 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7002 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 7420 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 7387 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 6006 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 4432 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 4432 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 4882 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2987 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3790 4593 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 3693 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4978 1124 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5910 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6906 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7420 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 5749 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 6488 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 4625 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 4175 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 3886 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2409 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5428 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1766 1220)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4978 1124 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2762 2762 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1445 2794 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(899 899 899)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7034 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6938 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 5814 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6263 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6970 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 4882 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5428 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2987 2826)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2601 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3051 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2794 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7066 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6970 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 4914 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 3950 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 3308 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2762 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1734 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4818 1413 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3886 4625 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3661 1895 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7002 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 7452 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5717 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5781 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 6520 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4336 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5814 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3019 2858)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4657 4657 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5010 1156 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2344 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3726 3726 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2794 2794 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4818 5139 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 6777 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5878 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 5139 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4015 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 3918 6488)))
						collect:
							[:each | 
							(each at: 1) value
								perform: (each at: 2)
								withArguments: (each at: 3)]))
		usingBits:
			(ByteArray fromPackedString:
					'@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCJ@LT@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:HCO@OQ@=DC4POQ@=DC4POQ@=DC4POQ@$HC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=D@LPD/@)HC4PO0@W4C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DB%0G8@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@#PAVPOQ@=DC4POQ@=DC4PN;AETC4PC*@:$C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCK J$@ADC4PNK@F(C4POQ@&TD[@M=@=DA  M=@=DBP K3@=DCJ@HI@=DC4POQ@2 DB I3@=DB+PJR@=DAX0NYAF0C_PN:AF0CE@OQ@74A*POQ@=DAM@OQ@#PAVPOQ@74DJ@C9@=DCQ Q<@NX@: C*@^(C4POQ@74D[@G*@=DC4PF)@:4@RPIB@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCK P2@EH@>PNK@F(C4PBO@<@B(PJ$@)HB5@P2@=DAC @Q@=DA>@E:@=DC4PJ-@,(D/PNA@=DBM@EY@=D@4@@4@KDCHPB1@W4AT MF@5 @P OQ@=DD POQ@#PAVPN:A@<C/ K#@4 C<@HW@*PA4PC2@!!\C4PAI@#$B5@H9@10C4PA*@F,A" A8AJHC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCK B:@+HBEPNK@F(C4PFM@VLCQ KG@>PAF E\@;(BV0J$@=DDC0R.@=DC4PA?@]\BP OQ@=DBM@EY@=DDPPD4@=D@0PLJ@=DD\PMX@5 @P OQ@=DD POQ@#PAVPOQ@=DC4PNK@CPC4PD*@)\C4PFB@_4C4PJ!!AD\C4PH^AE4C4PA*AK(C4PC>@^DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0CK B:@74AT OG@F(C+@L3@]DA4PGQ@$PCQ A-@7TCYPNC@A4A50OQ@=DC4POQ@<\A?PBQ@=DBM@EY@=DD-@OQ@=DB" DY@=DAKPI&@5 @P OQ@=DD POQ@#PAVPNY@6T@< R?AE(C4PD*@)\C4PFB@_4C4PO9@;,C4POQAHDCE@A*@30C4PK?@J<C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0CK B:@:0@ PB @F(C+@E-@K\C4POQ@=DC4PCM@DH@#0D*@F,D_@OQ@=DC4PN-@=DC&PB @&TBM@EY@=DD-@OQ@=DB" DY@=DAKPI&AJ8B)@OQ@B4C(POQ@#PAVPNK@=$C4PKQAE(C4PFG@S<C4PFB@_4C4PJG@8@C4PCY@Q@C4PA*@30C4PK?@L,C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@NH@8 C"@NH@8 CYPB-@:0C+@QK@R4C+@EN@_4AKPP#AH\C+@PY@$4B\0P(@X<CJPOQ@=DC4PLJ@<@@,PC\@=DBU0FG@=D@I0OQ@=DB2 D4@=DAW@JC@=DDM NC@M0AD@OQ@%\A!!0I3@]\@3PD-AGDC4PL)AKPCK F)@#$C4PAI@%,D* H9@^,C4PBE@7TC4PL\@NXC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@NH@8 C"@NH@8 C"PNH@:0C+@N,@;(C+@N,@;(A7@N-@:0C+@OQ@74C4POQ@74C4POQ@=DC4POQ@2 BP OQ@=DC. N:@=DC&POQ@=DC&POQ@=DC&POQ@=DC4PJ-@=DC+POQ@;(C. OQ@;(B\0OQ@:4C4POQ@1PCJ@OQ@9$C4POQ@=DBYPOQ@=DC4PNY@=DC4PN:@:4C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@8 C"@NH@8 C"@NH@8 C"@NH@8 C"@NH@8 C"@NH@8 C"@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@8 C"@NH@8 C"@NH@5<CW0M_@5<CW0NH@8 C"@NH@8 C"@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 C"@NH@5<CW0M_@5<CW0JP@)@B$@JP@)@B$@JP@5<CW0M_@5<CW0NH@8 C"@NH@:0C+@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 C"@M_@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@M_@8 C"@NH@:0C+@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@8 C"@M_@5<CW0JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@5<C"@NH@8 C"@N,@:0C+@N,@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@8 C"@M_@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@CW0NH@8 C"@N,@:0C+@N,@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@NH@5<CW0M_@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@M_@8 C"@NH@8 C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@M_@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@5<C"@NH@8 C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PCSAEPC\ K*AEPB;POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 CW0JP@)@B$@JP@)@B$@M/@#@BA0HG@ \BA0E%@%LBGPH]@!!4BT0IS@%LB$@JP@)@B$@JP@)@B$@JP@)@CW0NH@8 C"@NH@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN:@9(BDPM_@8 C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DDB@JP@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 CW0JP@)@B$@JP@)@B$@D''@=P@J@AY@.4D@0H]@!!4BGPG4@!!4BGPH]@%LB$@JP@)@B$@JP@)@B$@JP@)@B$@M_@8 C"@NH@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PNHA@@B[@R]AD0C/ PZ@=HCE M_@8 C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DAI0JP@=DDJPA:@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@0,C8POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@NH@8 CW0JP@)@B$@JP@)@B$@JP@%LBW0F&@!!4A=@D''@R\AI0D''@R\AI0D''@_PBGPH]@!!4B$@JP@)@B$@JP@)@B$@JP@5<C"@NH@:0C+@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@JP@R\D(0L/@ZHA PFA@XDA:PPG@X,D^ NH@=DC4POQ@=DC4POQ@=DC4POQ@=DD1@@_@=DAI0PK@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@9DB9POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@NH@:0C+@OQ@=DC4PN,@:0C+@N,@8 C"@NH@5<B$@JP@)@B$@JP@)@B$@JP@%LC8PSD@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0G4@!!4BT0JP@)@B$@JP@)@B$@JP@)@CW0NH@:0C+@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@JP@R\DB0CH@Y8B3@FA@XDA PFA@F8C<PJP@:0C4POQ@=DC4POQ@=DC4POQAGPBL@JN@1 B/ BZ@(PC[@M-@ZX@S LX@)D@% OQ@%0C% QT@GPC4POQ@=DC4POQ@=DC4POQ@G(@=POQ@=DC4PPKA@,C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@8 A7PN[AK,A>PRJ@5<A/@RO@4HA6@A @C\CD@M_@_XDD@@F@M4CR0F-@[4CW0M_@)@B$@JP@)@B$@JP@)@BT0IS@R\@>@OX@R\AI0D''@R\ASPD''@R\AI0D''@R\AI0D''@_PBGPIS@)@B$@JP@)@B$@JP@)@B$@M_@8 C"@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@8 CU KE@^PBN GV@XDA PFA@XDA PP/@>TDB0JP@8 C4POQ@=DC4POQ@=DC4POQ@R\C8POQ@=DB: G4@%0B:PJP@T\D]PM_AI<DJPI"ALLC+@SC@OTC4POQ@=DC4POQ@=DC4POQ@ZT@]@OQ@=DC$PJIAI<A=0OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PNH@8 AY D)@[0B$@R;@7,A PFA@XDA P@F@!!4C] FA@XDA PFA@XD@W D''@,XA PFA@XDA PFA@DDBT0P+AB8B"0FN@T@AV@E''@)@BGPG4AB$@@@H!!A@,AZ0H)@2XCB@R @%4@O D''@R\AI0D''@R\A=@H]@!!4B$@JP@)@B$@JP@)@B$@M_@8 C"@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@NH@5XB? D]AD0CEPFA@XDA PFA@+$C!!PFA@XDAT0F,@I(D%PJP@:0C4POQ@=DC4POQ@=DC4POQ@.4BW0OQ@)@B: OQ@9X@R OQ@T,A=0OQAEP@:0F%ALPBJ B_@8 C4POQ@=DC4POQ@=DC4POQAJDB$@OQ@=DAIPOQ@3<A> OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@LTAJ0BF@C\A PFA@3@A=@@O@XDB[0@*@(0@WPD,AITA&@@?AJ @W@FZ@-8@60PK@\L@+ O(@40A90@5@HH@1 RL@XDA PFA@XDA\@CN@R\AO BC@*T@>@OUAHPDW Q?@# B-@D @[DBO A@@R\AI0D''@R\AI0G4@!!4B$@JP@)@B$@JP@)@B$@M_@8 C"@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@L;@/8AT@R@@5@A PFA@XDA PQ(@2HB>PO[@$8A10FA@\XB'' I9@$XA=@M_@=DC4POQ@=DC4POQ@=DC4POQAGP@] OQAB$@40OQ@ZXC+@N,@ZXC4PJP@ZXC4PJ>AITC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@5<C4POQ@R\C7@OQ@TXC[0OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PNH@''HBU F?@TH@4PJP@)PA PFA@XDB[0G&@.DD%PLLA@0B]@BJ@;HB2@C=A@,DGPP=@''(A(@C^@_8DF0PK@;LDSPOZAC8APPQ=@XXDB0G7@4@DY@F0@9L@J0QYAITBR@D;@SH@X H>@*\B5PKU@-TB5PKU@-TBE @KAI@AI0D''@R\AI0G4@!!4B$@JP@)@B$@JP@)@B$@M_@8 C"@NH@8 C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@8 AY @/@;8CSPK&@XDA PFA@XDDS N5@+TAV H!!@L(BM0M)@<<A PHY@+(DP R+@80BT0N,@=DC4POQ@=DC4POQ@=DC4POQ@&HB/ NQ@OTD]@RU@O\C4PLK@.$C4PBZAI<C4PN4@>DAQ0Q4@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@IXAQ0D''@T\C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@8 @> OA@!!(A PFA@XDBX@B8AG\@'' M[@K0@" RX@TLDB0FQ@G0DS0QOAI8@_PP\A@,@8@D#@OP@=@C4@RLD)PRU@H AH0A=@EL@E0AD@>XDB0DO@/(C70D.@?TCX G7@6<AG O8AHHC; J''@-TB5PKU@-TB5PKU@-TB5PIIAE<@/PB,@R\AI0D''@_PBT0JP@)@B$@JP@)@B$@M_@8 C"@NH@8 C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@K/@-,BZ@E,@JDA PFA@XDA PFAAGLC''0J"@Z<B;PK-AB$AZ@@%@U8@,0B3@6,CAPM<AI8C:PO7A@,B$@NH@=DC4POQ@=DC4POQ@=DC4POQ@=DAI0N,@8 C4POQ@8 C4POQ@8 C4POQ@8 C4POQ@!!4AI0OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DBX K$AITC4POQ@=DC4POQ@=DC4POQ@=DC"@F(AE\BF0B!!@\,A]0NU@Y@@-@PQ@0DCY@P8AA<B(0L1AKTDD0@I@-<DB0IJ@X0BN0OC@HPB5 C-A@,DXPE<@Q<AZPH5@7<B7@PKAIXAMPRM@<$BS@D!!@X$DB0M:@L<@N R^AD<D'' O''@0,@,@Q>@ILAXPKU@-TB5PKU@-TB5PKU@-TB5PKU@ <D-0I.@#0B"@J3@)TAI0H]@)@B$@JP@)@B$@JP@5<C"@NH@8 C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@NH@*@B,@H"@_,A, G?@XDA PFA@XDB[0E.@DXC) H6@.4B;PHCA@4AEPMO@3(B=@F3@_0C(@@$@DLD'' @WAC<A&0E%AITB$@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PM_@[<B90F"@XDA PFAAB@DB0I5@\@DG D@@<PA8 M/@4D@=@B3@OPBW C!!@?PDB0E9AJXB;PK-@=P@]@M/AITC[0FW@GP@]@BZ@_\DB0CF@6<AYP@_AB$D@0BZ@6<DB0BX@\HC2 D1@<0BI FY@3(AL@QB@C @( KU@-TB5PKU@-TB5PKU@-TB5PKU@R@C7 DF@QLAL D;@S,B?@J(@-\B4 J1@WXB$@JP@5<C"@NH@8 C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C"@M_@XLB,@OH@@PACPEE@ZHA PFA@XDA PFP@@ C^PG/@EDCGPK-@:<DJPM7@NHB^0B3@RLA,0P$AITCXPD"@,8B!!@B=@"\@=@A_@Y,@& PK@%LC"@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@8 BLPQ:@THBG0H]AJ0A PF"@[PA80L^@6<BQ0K;AF$DZPSA@ITC)0PK@<8C-0BK@"LB;P@_@6<D%PPK@_\A3 G7@-4DB0C+@!!4AI0RUAITD%PRU@LXAI0IS@R\D%PPK@6<C[0PK@IX@% M/@I(DJPK-@.4DJPG7@!!LB&POM@OXA1@KU@-TB5PKU@-TB5PKU@-TB5PKU@!!XCM @R@ HDIPES@5DAR@EU@XDA PFA@XDDD J)@U4@E@OV@[4COPQF@I\A7PL''@5<CW0H1@B8B? D\A@DA>PRE@M4BXPNF@XDA PFA@XDA PFA@Y@@XPND@\DD# J<@.4B;PL+@L0C@ R-@: C[0JB@\TA?@LS@S\D&PQ"AITDB0G7@I(@& E1@!! BTPIX@I(D%PIS@8 C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@=DBU@GL@7LC+@OQ@=DBB@OH@ALB) FA@XDCW@RU@20DRPB>@]HCS JZ@6<B/PFL@!!@DTPIL@LH@&PPK@6<@& AJ@I(A%0M/AITA=@G4@R\AI0D''@!!4BT0JP@5<B$@JP@)@B$@JP@)@CW0M_@)@B$@JP@)@BGPJP@)@BGPD''A@,C[0G7@\8A=0M/@6<@]@K-@''4D$PKU@-TB5PKU@-TB5PKU@-TB5PKU@CL@4 K-@% A> G:@\<@&0J;@D\BOPQ2@^$A PFA@XDA PFA@XDA PFA@XDA PFA@&@BX@FA@XDA PFA@XDA PFA@XDA PFA@)<@(0KI@FLB]0@E@04B;PK-@5$A"@A4@I(C8@C_@QDAW0GT@!! CF0PK@#<B] K-@:<DJPG7@IXAI0CFAITDB0L_@I0DJPG7@IXB$@NH@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC"@@A@ATAI GH@6(DAPNO@)@AB0FA@XDA PET@0L@6 H2@'' AX@P"AIH@Q@N6@6<B; KO@5(B;POT@I(C[0D''@R\D%PPKAIT@:0G4@)@CW0M_@5<CW0M_@8 C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@NH@5<B$@JP@%LAI0C+@LX@1 CFAITC[0BZ@H0DZ B]@N\@90C''@N\@90C''@N\@90C''@ZLBJ@E/AKLBV A)@-LC5@K-@.4B/0K-@+<AV PN@]LD, J6@PL@_ RC@<HB3@FP@XDA PIO@?,@(0G%@0PDP@A,@''8D,@HL@.4B;PK-@:<D@0HT@?XAX N?@QH@=@EWA@,@Y@J7@BXB8 B&@A@DB0RU@0,AYPFW@_\C[0BV@%LB$@JP@)@@YPQX@_\CN CF@)@C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@8 D1 @)@,,BX NQ@9@@JPM.@N,BJ0H@@ 8@B G0@L@A=0H2@U<AH0IK@MPDR @ A@,D%PLK@Y\A=0M/A@,AI0JP@)@B$@JP@)@B$@NH@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@NH@5<B$@JP@)@B$@JP@%LBT0H]@R\@1 RU@6<@[0DT@>(C: O*@>(C: O*@>(C: P<@#8C''PD#@RL@=@DD@ITA$ G7AH,@00JX@=\DJPOT@:<B;PK-@.4B;PK-@.4B;PK-@24CKPK-@.4B;PK-@.4B;PN/A@LB=PD6AD B6@B2AILCB0@G@T$A,0G<@&4DT B''A@,@5 Q9A@LD@0P)@_\D%PD''@N,D%PBV@R\BT0JP@5<C+@OQ@8 BT0BVAITAI0JP@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@?H@JPNR@I<BX NQ@RPB!!PIP@EP@V KM@]$C?@RR@ITA7 M/@N A''@K-@.4DJPK]@N,AI0C+@N,AI0H]@)@B$@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@NH@8 CW0JP@)@B$@JP@)@B$@H]@_PAI0D''@LXC<0L7@#8C,PRHAH D"@RHAH @L H>@?(A=0L AC(A<PAO@. @@0PK@O<AW0D9@RLA2PP-@W<A=0OP@H,AAPF>@''<CH0@B@I(C)@DL@@0DA@LF@^ C)PK]@[XADPD#@X0A5@G<@4$D%PC/@$(DM@EO@;0@& M/AITDB0G7@_\CB0PK@LXBT0JP@)@B$@JP@5<C+@OQ@=DC4POQ@:0B$@IS@%LB$@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PJPAG@@QPI"@&HC$PD$@.4DJPR>@](B* A=@H\A-PB?@O@CQ0RU@-4@& FW@_\C[0CF@%LB$@JP@)@CW0N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@NH@8 CW0JP@)@B$@JP@)@B$@IS@!!4AI0D''@R\AI0D''@4L@NPA0@LPBIPN+@; B_@N0@6<CB0BZ@.4B!!@IX@.4@50M/@1DBI@SB@3HBF@G<@]@D%PR1@[LA,0E_@X0A#@DVA@,C20FL@[LA5@GT@_0BT RU@A C* BI@!!0C,0EQ@^0D%PM/@I(DJP@_@I(CB0RU@_PAI0D''@R\BGPJP@)@CW0N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@M_@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@H]AE,B:0NQ@9DAI@K-@.4DJPN\@58CY E>@A$B!! N/@I(DB0D''@LXD%PCF@R\BT0JP@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C"@NH@8 CW0JP@)@B$@JP@)@B$@JP@%LAI0D''@R\AI0D''@R\BY0PUAKXDE@DA@6 D"PRUAITDB0M/@_\A=0BZ@Y\C[0PK@3(@R N/@.4C@@I)@ODD%PMJ@.0A-0DB@JT@M MJAITB&0F.@&(CA0PF@MTAB RU@6<@& PC@=PDJPBZ@6<AI0RUA@,C[0PKAITAI0JP@)@CW0M_@5<C"@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCW0D''ALTCY0D$@RPB;PK-AB$AYPP!!AC@DJPP)@A<@& G7A@,AI0JP@)@B$@JP@5<C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@M_@)@B$@JP@)@B$@JP@)@A=@D''@R\AI0D''@R\AI0D''@N,@:0C+@N,@:0D''@R\AI0C+@IXD%PRUAIT@:0D''AITC[0G7@I(@& E%@6<D%PM/@I(C5@K-A@L@R K]AITC[0BZA@LC5@P)@I(C[0CFAITC[0G7@0,C[0PK@R\B$@JP@%LBT0JP@)@CW0N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCW0D''@D4@E K-@.4DJPP)@VTCN AP@1HA%0M/A@,D%PD''@)@B$@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@M_@)@B$@JP@)@B$@JP@)@BGPG4@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0D''@R\BT0IS@!!4AI0D''@IXD%PRU@R\A=@D''A@,CB0K]@-4C[0RU@R\@:0PK@6<C[0M/A@,AI0IS@%LAI0D''@!!4BT0JP@)@C+@N,@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DCW0D''@ ,DT@O=AB$AYPE%@3(@#P@)@^4C[0D''@)@B$@M_@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@M_@)@B$@JP@)@B$@JP@)@BT0IS@_PAI0D''@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0D''@R\A=@IS@%LB$@JP@)@B$@JP@)@B$@JP@)@B$@JP@%LBGPD''@R\A=@JP@)@B$@IS@!!4BT0IS@)@B$@NH@:0CW0M_@8 C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC"@H]@6<B;P@)@>0DMPSGAL BK@P&@I(AI0JP@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@NH@5<B$@JP@)@B$@JP@)@B$@JP@%LA=@D''@R\AI0D''@R\AI0D''@R\AI0D''@R\AI0G4@!!4BT0JP@)@B$@JP@)@B$@JP@)@CW0NH@8 C"@N,@:0C"@NH@8 C"@N,@:0C+@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PJP@LXA3 FSAFTAN G[@;$@N0P)@6<BT0NH@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@8 C"@NH@8 CW0JP@)@B$@JP@)@B$@JP@%LBGPG4@R\AI0D''@R\AI0D''@R\AI0D''@_PBGPH]@!!4BT0JP@)@B$@JP@)@B$@JP@5<C"@NH@8 C"@N,@:0C+@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@%LD%PG7AB$B!!@J?@:<@& M/@R\B$@N,@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 CW0JP@)@B$@JP@)@B$@JP@)@B$@JP@%LBGPH]@_PA=@G4@_PA=@H]@%LB$@JP@)@B$@JP@)@B$@JP@)@B$@JP@5<C"@NH@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0BT0C+A@,CN LK@6<D%PG4@)@C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 CW0JP@)@B$@JP@)@B$@JP@)@B$@JP@)@BT0H]@!!4BGPH]@!!4BGPH]@%LB$@JP@)@B$@JP@)@B$@JP@)@CW0M_@5<C"@NH@:0C+@N,@:0C4POQ@=DC4POQ@=DC4PIC@Z,C4POQ@=DC4POQ@=DC4POQ@=DC4P@N@=DC4POQ@=DC4POQ@=DC4PKC@:4C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DDU PB@=DC4POQ@=DC4POQ@=DC4POQ@=DB$0OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@JP@)@BGPG4@%LB$@M_@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@M_@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@A\ Q&@H8A\0AL@)@B$@JP@)@B$@JP@)@CW0NH@8 C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4PR$@&LC4POQ@=DC4POQ@=DC4POQ@=DC4PLW@=DC4POQ@=DC4POQ@=DC4PO+@>LC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC;PMR@=DC4POQ@=DC4POQAF@@HPOQ@UXA @OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C"@NH@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@NH@5<B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@D2P@Z@)@A%@AU@)@B$@DI@GHB$@JP@)@B4@R''@/4C+@N,@ (@Y NX@:0C&@IC@XPA.0OQ@/H@ @Q8@&LC4POQ@,@@L@NJ@=DC4PNX@EXCU0LW@=DC4POQ@=DCQPR$@,LC4PHR@8(C&@IC@-$@Y OQ@1(@U N-@=DC" HJ@=DC4PF*@=DC;PMR@=DC" R/@WPC4PMW@Y<B0PEV@UXBP0OQ@=DB6P@!!@1(C4POQ@ (C+PCG@)LC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C"@NH@8 CW0JP@)@B$@JP@)@B$@JP@)@B$@JP@)@B$@JP@)@@H0A''@)@A]PG.@)@A.@M8@/\DK@JPAK C8 Q#@Q\C. I@@ZPD[0AW@)LD)@@M@S C\@@!!ADLDE C#@&LC4PG_@[$@O@B(@,PCJ A7AAXA)@H-@=DC4POQ@-$@-PHE@M C4PL4A@HD)@@[@&,AE0Q#@ XBZ0Q#@=DDBPLY@=DC4PLW@=DC;PMR@;(BA DG@N$D*PRT@D @*@P7@98@R@OQ@ 4@U0@=AHXD@ OQ@3PB=0PV@;X@Y OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C"@NH@8 C"@M_@5<CW0JP@)@B$@JP@)@B$@JP@)@B$@JP@)@@H0QD@<TA< JA@R @U0KP@/4DQ@C;AI(D^0N,@6@A]@QD@;(C+@E[@>4D)@PW@5\C4P@=@K,C4PH3@&LC4PR[@^@CU0AX@GL@?@@\@=DBB I0@=DC4POQ@P @CPJS@=DC4PL4A@HD)@@[@8(A]@J+@,@C&@K0@=DDBPLY@=DC4PLW@=DC;PMR@=DC4POQAC$B<POQ@2PDL0OQ@_T@F0OQAE0A]@OQ@$TCM@OQ@3PAQ@OQ@/ C%@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 C"@M_@)@B$@JP@)@B$@JP@)@B$@JP@)@@UPBP@YTC8 A2@7DCIPP,AC\DX0F''@_LDNPN,@:0C_ K1@=DC4PR\@Y<D)@I+@=DC4PJ\A@$C4PR$@&LC4PF:AC\DM0P7@4PC\@M0@=DC4PLW@=DC4POQ@=D@V0@[@(@C4PL4A@HD)@I+@=DCF PX@=DC4PLW@=DDBPLY@=DC4PLW@=DC;PMR@9 @- N^@,HBX0OQ@2PDL0OQ@_T@F0OQ@''DC4POQ@J$@-POQ@3PD@ OQAF\B% OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4PN,@:0C+@N,@:0C+@NH@8 C"@NH@5<CW0M_@)@B$@JP@)@B$@JP@)@@UPBP@)@CMPDX@W DP0NX@8 C"@NHAI(@\0N,@^@AU O/@6@C4P@<@IHD)@I+@=DC4PAX@BHC4PC%@&LC4PQ&@SLC4POQ@=D@;@P7@=D@9@IA@=DC4POQ@:4C4PNX@>HB0@L4A@HD)@I+@=DCF PX@=DC4PLW@=D@ @B(@=D@.PIA@=DC;PMRAC$A)@OQ@:LBX0OQ@7@CN@OQ@_T@F0OQAA\@.POQ@NTD& OQ@3PD@ OQAF\B0POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@NH@8 C"@NH@8 CW0JP@)@B$@JP@)@@%@B*@5<A3PLW@7PB>@B+@;4BZ0N,@EXD!! I#@X@C" JV@A,BA N=@8(D+0J,@=DC4P@0AE0B0 SJ@&,C4PJ]@A,C/PHF@EXCF D8@"PC'' RF@=DC4POQ@<XA.PMS@8HC4PMTACDD+0J,@=DCJ QC@=DC4PM]@=DC4PH$@T(C  QC@=DC? M0@,L@CPNG@;4BZ0OQ@>LCUPA5@ (@U0OQ@$TD!! KB@S AS@OQ@5PDLPOQAF8B0POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C"@NH@8 C"@NH@8 C"@NH@5<CW0M_@5<C]@NH@8 C"@M4@8 C"@M @"8C+@N,@:0C+@IU@:0C4POQ@6@CF OQ@=DC4PNX@=DC4POQ@;(CF OQ@:4C4POQ@;(BD N-@=DC4POQ@/HC4PN-@=DC4POQ@=DCQPJS@=DC4PNX@=DC4PNX@=DC4PNX@=DC4PNX@=DC4POQ@-$C4PN-@=DC. N:@=DC. KC@=DC+POQ@=DCJ ME@=DC&@OQ@=DC. KC@=DC4POQ@9 C4POQ@;(C+POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@:0C+@N,@8 C"@NH@8 C"@NH@8 C"@NH@8 C"@N,@:0C+@N,@:0C+@N,@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@:0C+@N,@:0C+@N,@:0C+@N,@8 C"@NH@8 C"@NH@8 C"@NH@8 C"@N,@:0C+@N,@:0C+@N,@:0C+@OQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC+@N,@:0C+@N,@:0C+@N,@:0C4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ@=DC4POQ')! !

!SimManager class methodsFor: 'resources' stamp: ' 31/3/15 09:57'!
deviationImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #deviationImage"
	
	<resource: #image>
	^Image
		extent: 196 @ 66
		depth: 11
		bitsPerPixel: 16
		palette:
			(MappedPalette
				withColors:
					(#(#(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(0 0 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7066 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6231 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4400 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 5749 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 3276 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2184 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1830 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2633 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2473 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4047 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7130 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 6070 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5814 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5492 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4368 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4432 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2858 4657 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2184 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1830 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4721 4850 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 3854 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 4978 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 4657 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 5492 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2505 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2569 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 3950 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7130 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 7484 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 6552 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6456 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7034 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4240 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5524 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3115 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2312 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3950 4432 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1798 1381)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3115 3693 1670)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 2569 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1895 1895 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7066 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5621 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6649 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4400 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 4497 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3115 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2344 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 2120 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 5171 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 3983 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4015 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7163 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7098 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6135 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4207 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 4111 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 3340 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3083 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2569 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 5235 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1573 2858 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 5107 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2537 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 6552 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5878 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5846 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4304 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 3501 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2344 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1830 1445)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2280 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4240 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7227 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7516 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7130 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7098 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2569 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4015 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5653 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(64 64 64)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5589 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6103 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5589 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5685 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4497 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 3822 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4175 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4336 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1927 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 1156 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7130 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 5589 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5910 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6584 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5043 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4593 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 3372 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3147 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3115 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1863 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2923 3822 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3180 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 3340 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 2312 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4015 4721 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3983 4753 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7291 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 7612 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 5974 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6713 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4753 4753 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2601 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5621 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2633 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1863 1509)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2890 2890 2890)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3822 3822 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4111 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7259 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7163 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5878 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 4657 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4143 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 2216 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3180 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 3501 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 1959 1509)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2698 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 3950 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7355 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 7644 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5910 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7163 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4529 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4561 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 3308 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2441 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5075 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5107 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 5717 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 3886 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2441 2023 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 1092 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 4497 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 5075 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 5653 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7195 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5910 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4561 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 4625 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 2280 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3244 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 4786 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1927 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1509)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2248 3822 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4015 4272 3276)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2923 2923 2923)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 1092 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2955 3822 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4272 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 5524 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3180 3790 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2666 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7195 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7420 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5974 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5974 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4464 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4561 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5107 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3212 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 3469 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1541)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5974 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 5878 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4047 4432 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 1092 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7323 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2698 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4175 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7227 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6167 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 6745 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 5717 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4272 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 3661 3533)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1573)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 1349 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 1124 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7612 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7259 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6006 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4593 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5171 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3244 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3308 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4368 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1959 1606)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 3950 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1573 2923 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2955 2955 2955)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 4207 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7484 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7323 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5974 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 5621 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5974 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4368 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3244 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3308 3083)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2858 3918 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4047 4432 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2730 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3244 3758 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7291 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5749 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 5814 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4625 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 2762 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 1124 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7291 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7355 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 6713 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 5781 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4657 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 6167 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 3533 3372)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3276 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3918 3918 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 2312 1991)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 4850 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 2505 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 1124 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2055 2055 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 2344 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2762 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7387 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5781 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(192 192 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7387 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7323 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 6520 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 5814 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4657 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4272 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 5203 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 3597 3469)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 4432 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7355 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7452 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7420 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4336 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4400 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3308 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2794 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2023 1702)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 1220 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7291 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7420 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6070 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6745 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 6167 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5010 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 5589 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 2569 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3051 4882 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4657 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 5814 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 5717 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3019 3019 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2955 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7484 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6135 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4689 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 4978 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4175 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3340 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2055 1734)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5010 1798 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7387 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7452 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7452 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 5749 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 4432 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5300 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 5107 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 3758 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4175 4914 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 4721 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 2184 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2858 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7516 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 6777 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 5781 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4721 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 4786 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 5846 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 6103 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4978 5171 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 5878 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2312 4015 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3983 3983 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3051 3051 3051)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 1156 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7420 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2890 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 2120 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7452 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7420 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6135 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4786 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5171 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 2698 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 5621 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2087 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 2376 2087)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4272 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4240 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7420 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6777 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4753 4721)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 5749 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4336 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3404 3308)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 2890 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 2505 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2152 1766)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 4400 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 1252 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 2923 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7516 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 6809 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 6360 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7452 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 5878 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4946 4946 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3469 3276)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 2730 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2120 1830)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1188 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 6263 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 6392 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4786 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 5621 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 5524 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3437 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 2666 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 3019 2248)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 2248 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 2505 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1188 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1220 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 5524 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5043 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 5203 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2923 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 4529 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7548 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7805 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7484 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7516 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4818 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3469 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2987 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2184 1830)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2152 1863)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 4561 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1188 32)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1220 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 3051 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7644 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4850 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 5717 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 5589 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 4786 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 4882 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 5910 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3115 3115 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1252 0)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1702 3147 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1252 32)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2184 2184 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1252 1252 1252)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4978 4978 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 3854 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 2698 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4464 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2987 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7516 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 6327 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 6263 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6263 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4272 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4561 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3115 4978 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 2987 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1252 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 2280 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 6006 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 2987 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 1509 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7548 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6713 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 3019 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1445 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7805 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7580 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6295 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4914 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3533 3404)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 2890 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2216 1927)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3147 3147 3147)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1252 96)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2248 1895)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7612 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7612 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6038 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 6841 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7580 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4882 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 4336 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 2633 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 2890 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4914 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 4304 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4625 3372)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 96)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7612 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4593 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3597 3404)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 3597 3437)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 1284 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 3790 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4625 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 5589 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 5974 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1798 3180 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7837 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7612 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 6424 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6874 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4914 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 5974 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 4978 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3597 3437)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 1284 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2248 1991)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 2698 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 160)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 5171 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3180 3180 3180)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 6906 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1316 1316 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4561 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3083 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(385 385 385)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7612 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 5203 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 5300 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 3918 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 4368 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 2344 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 2441 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3147 1927 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5621 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5203 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4721 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 4625 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 6103 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7677 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7644 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 6938 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 4753 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3597 3501)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2280 2023)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 1284 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1316 192)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 1381 610)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2344 1959)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 7869 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 6841 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6006 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4657 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4432 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 3308 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 3983 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 2569 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 2473 2152)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 2376 1991)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2023 3212 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3212 3212 3212)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 2441 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3437 3983 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1638 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7773 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1349 1349 1349)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(417 417 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3115 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7709 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 6135 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4978 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 5685 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5010 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 3950 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 3790 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2312 2055)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 2441 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 1284 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 1316 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 2987 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(899 2312 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 2794 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5332 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1638 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3180 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3147 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 7130 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6360 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7677 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5043 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 6167 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 3276 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 4079 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 5396 4721)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1284 321)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1316 289)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 7901 7901)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5010 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 6038 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 5267 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 2858 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 4368 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2344 2087)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4175 4175 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 1413 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 2120 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3244 3244 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 5107 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 6038 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3180 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1381 1381 1381)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 6777 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5717 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 5557 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3308 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3693 3565)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 4721 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 2505 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 1316 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4657 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1349 321)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3212 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 1702 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1702 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7837 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7773 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 6552 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 6038 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5846 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 3854 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3726 3565)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3276 5107 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 5589 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5364 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6552 5267 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 4721 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 4753 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7869 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 6070 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 5364 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3693 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 4304 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 4207 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2376 2152)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 1316 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2569 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3212 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2344 2344 2344)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1413 1413 1413)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7805 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7773 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 6263 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6167 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5075 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4753 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 4047 3950)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3244 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2441 2120)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 995 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4304 4561 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7869 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7869 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6488 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5428 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5492 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3726 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 4079 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 2826 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2409 2184)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 995 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1381 417)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 1316 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2505 4240 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3051 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3083 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5010 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1766 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3276 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7837 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7966 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 7034 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 6617 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 6713 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5107 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 5492 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 5171 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3340 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4400 3372 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2473 2152)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 5171 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1895 3340 4689)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 4561 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7805 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4786 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3372 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1445 1445 1445)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3276 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 4882 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7869 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7805 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 6327 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 6649 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 5235 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 5910 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 5557 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3758 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3372 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6231 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2441 2216)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7837 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1381 481)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 7901 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6520 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 6263 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 5267 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5171 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 4850 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3790 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3308 5171 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 2601 2280)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 1349 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 4272 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3180 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 1895 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3340 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 1895 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7869 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 7066 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 6809 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 6874 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5203 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 5974 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 5203 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3180 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 2601 2376)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2473 2248)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4272 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3340 3340 3340)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2280 3340 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5107 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2409 2409 2409)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1477 1477 1477)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 5910 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 6263 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 1830 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3340 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7901 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7901 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5460 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 4850 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3372 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3501 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 5524 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 1349 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 1766 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3469 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4529 995 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7934 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6745 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5203 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5235 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4464 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 4015 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3501 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 1381 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1349 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 1573 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1413 578)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1863 3372 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3404 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 6167 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3597 4079 2409)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6584 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 7098 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6617 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 6809 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 6167 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 5235 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3886 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 4304 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2569 2248)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3565 4336 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4464 4850 3597)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1445 578)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 1413 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3469 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2441 2441 2441)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 3950 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 3565 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 5396 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7934 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 6906 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 1895 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3372 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 7998 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7934 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 7130 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5235 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5267 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 5332 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3083 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5235 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2537 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2730 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1413 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2312 3340 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4882 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7966 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6617 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6295 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 5878 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5075 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3886 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 4079 3950)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2601 2280)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 5910 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 6167 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1413 674)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1445 642)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2216 3404 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3501 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7966 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3437 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 6520 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 8030 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 4914 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 7130 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6006 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 6199 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 5267 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 4272 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 4079 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 2858 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 2633 2312)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2601 4336 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1445 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3533 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 4111 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 6231 6552)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5139 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 5589 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4914 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7002 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3629 4111 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 6456 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 7998 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8030 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7998 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5267 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5300 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 4175 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 4143 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1477 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 1702 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3437 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1477 674)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2505 3212 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2344 3372 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4946 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3469 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 3469 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 1959 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7998 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8062 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6327 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6103 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 6199 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 4304 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 4143 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1509 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 2890 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 6199 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 2087 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 6520 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 1959 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 8094 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8030 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6970 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6231 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 4978 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3950 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4625 5332 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 3822 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4368 4368 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 1638 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4625 1027 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1509 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3437 3437 3437)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2505 2505 2505)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(642 642 642)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8094 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8062 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6070 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3340 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 4304 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3308 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 2794 2537)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1509 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8094 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8062 8094)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 6777 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5332 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 5814 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3983 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3533 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2633 2441)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1541 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1509 770)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3533 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 8126 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8062 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6713 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6231 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 5043 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4015 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 3790 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 2890 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1606 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3693 4079 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1541 803)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1509 803)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2537 2537 2537)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1638 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 5332 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3597 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1606 1606 1606)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3501 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8094 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8094 8126)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 6809 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 5235 6809)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 5942 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3372 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5685 4882)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 2858 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1638 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3565 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1477 867)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1541 803)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 1670 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6745 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6809 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6263 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 6617 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3597 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 2858 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2698 2473)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 2890 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2152 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 1606 1060)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8126 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 6809 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 7227 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6295 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 4015 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3533 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 4432 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 2955 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1670 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1541 867)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2152 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2087 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1638 1638 1638)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8158 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6777 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 7195 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6295 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 5300 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 6424 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 3661 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 4047 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3597 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2698 2537)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4529 4753 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1573 867)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2473 3501 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1188 2633 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 6649 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6295 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5428 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 4497 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7163 4529 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 1991 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 4593 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2794 3340 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2152 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 7259 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7259 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6327 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 3501 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 5428 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2730 2569)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 1766 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2152 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1606 899)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2601 2601 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3533 3533 3533)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3726 4240 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1670 1670 1670)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6617 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6681 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5460 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 5492 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 6295 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 3918 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 6070 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 2312 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1766 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3661 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1606 963)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5171 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 3726 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7291 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6649 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7484 6809 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7163 7163)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 7098 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 4625 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6231 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2762 2601)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2280 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 6745 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1606 963)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1284 2633 3950)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1284 2601 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 2248 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 5171 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7291 7291 7291)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7227 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6777 5460 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5043 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 7291 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3693 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4882 5428 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 3019 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 1734 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1606 995)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7869 2923 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1284 2666 3950)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1349 2633 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1863 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 5653 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(770 770 770)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5557 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6713 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6745 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6906 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5043 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 6199 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3726 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2794 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2216 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2216 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 1670 1124)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3790 4272 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1220 2666 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6906 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5524 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 5685 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4175 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 4689 4625)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3854 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5139 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 5781 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1638 1027)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2826 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 1830 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1895 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 2312 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6906 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6938 6906)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7130 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6392 6392 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5460 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 4240 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3726 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4657 4850 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 6167 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7901 1734 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1670 1027)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 3597 5075)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3758 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6777 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5557 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6809 5557 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5235 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 3597 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2890 2633)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2858 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5878 1830 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1927 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1959 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 1895 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1702 1060)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3758 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6809 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 6970 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5171 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 1830 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 2923 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5814 1991 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 2955 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 1766 1284)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2473 2216 3372)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1381 2666 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1638 1124)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2280 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 2312 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7002 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5589 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 4625 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 4079 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2890 2698)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2923 2666)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 3180 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1702 1092)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 3629 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 1830 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 5878 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6038 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1766 1766 1766)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2280 2312 3501)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 6424 6713)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 6970 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 7002 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5781 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5203 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4272 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 3983 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2890 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 3180 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2184 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1670 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3758 4047 3115)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2794 4561 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6777 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6809 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5492 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3822 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 2312 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6841 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5396 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 4432 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4946 5557 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4079 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3822 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5364 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 2344 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 1734 1156)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2120 3661 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2666 3661 4625)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3469 1863 2826)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 7387 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6456 6456 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 5621 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 4111 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 3983 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 3854 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2923 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4593 4593 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 3501 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5364 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2730 2730 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1798 1798 1798)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 7387 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 7420 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 7066 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 6938 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6874 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4272 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 4079 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 2344 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 3180 2987)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2987 2730)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1702 1220)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 3212 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 3372 3244)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(1509 2730 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6906 5524 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2344 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7002 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 7420 7869)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 6906 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 5717 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 5974 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 4143 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 4304 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 2344 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 6488 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 5075 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 4015 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 3886 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7130 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7420 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 6488 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 5942 6777)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4336 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 5300 7130)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4015 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2473 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 3180 3019)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3918 4336 2826)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2152 5878)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 2409 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2762 2762 2762)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 5428 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 3886 6456)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(899 899 899)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7034 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 7098 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6938 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 5428 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 6617 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7130 4818 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5878 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 4015 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 2987 2826)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 7066 7098)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 6970 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7420 7484)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 6006 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6713 5043 4978)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 4850 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3051 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 2184 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 1734 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 1830 1316)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4368 4240)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 4015 6392)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7323 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 7452 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 5717 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6520 6520 6520)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 4753 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8126 4336 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 6167 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8094 3019 2858)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4657 4657 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 2055 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 2376 5814)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3726 3726 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(2794 2794 2794)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5685 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7098 5267 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 5621 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7034 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 3918 6488)))
						collect:
							[:each | 
							(each at: 1) value
								perform: (each at: 2)
								withArguments: (each at: 3)]))
		usingBits:
			(ByteArray fromPackedString:
					'@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0L''@1PC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C.PL>@>,C:0O+@>,C:0O+@>,C:0O+@>,BNPO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@B<AL@JA@>,DA E9@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@(XA9PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0H)@U<C:0O+@>,C:0O+@>,C5PQ>@>,@<0OA@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,CKPJV@A@C:0NZ@F(C:0O+@%TD''PNN@>,A!!PNN@>,BNPK(@>,CI0G5@>,C:0O+@2\DJ I&@>,B(@JA@>,AZPN-AI4C# OTAI4CE@O+@88A)0O+@>,AM@O+@"$AW0O+@88DQ DH@>,CT R/@O@@<0C3@]PC:0O+@88D''PGT@>,C:0F''@<X@Q@H9@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0L-AEP@SPDH@9(@Z O+@H<C7PJS@)XB PKHAEPC:0DV@A@C:0G%@WXC:0O+@*@B/ S0@9HC:0H)@U<C:0CY@CH@.PL!!@K$A^PEY@5HCY0@>@>,C:0R4@>,BJPE_@=PDL@O[@-,CUPPF@ 0B% G@@O0BC@O+@DPBK KH@"8CG@O+@F(@Z0FJ@G4D5 O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@24@1PJ%@ ,C& A*@>,A#PE)@5HB.0O;@Q0AX OT@$,B% O+AC@D70O+@>,@ PGC@#$C:0O+@"$AW0O+AF(AM@O+@L,C@ O+AJPCY0M''@C8C:0O+AKPC:0H)@U<C:0O+@>,C& @2@>,AK@JF@>,A!!PG*@>,B$0Q/@>,BD0RH@>,@Z S-@>,AC@GL@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,CKPCE@88AVPO$@F(C:0L2@\@A0@G@@#,CT A,@8XC^PNT@A4A00O+@>,C:0O+@>PA: BQ@>,BJPE_@>,D90O+@>,B^0D[@>,AK0IW@6\@O O+@>,D-@O+@"$AW0N-@7$@?@S2AHTC:0D,@(XC:0FE@^(C:0PN@=TC:0O+AKPCE@A*@38C:0K4@K\C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0L-@LTC:0BC@J\@Z O+@WH@00O+@>,C:0O+@MX@O BO@R0@Z0R/@>,C:0O+@<XC:0N-@J\BUPH)@U<C:0S''@>,C:0I;@Q,C:0D/@%\D70JV@>,@J0N6@>,BJPE_@9(C<PO+@,LD!!PO+@X$AQ@O+@XTA: O+@'' C$@O+@M<AF@O+@F(CO O+@/P@5@O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@7$@8 O+@>,D\0D/@>,AU@G*@R<DPPR:@>,DM0IB@&XDQ FO@2 C:0O+@>,C@ O]@K$@90O+@$XA"PO+@B\C:0O+@+8AM@O+@VHB]@O+AE$C%@C''@Q C:0IF@X$BY GC@MXAK0R$@>,CJ@S''@24A)0H.@>,@Q@IKAM8BK GV@>,@!!0NF@>,CG@C0@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1 O+@>,C:0O+@=PC:0O+@=PA10OF@>,C:0O+@88C:0O+@88C:0O+@>,C:0O+@2\BNPO+@>,C5@OT@>,C+PO+@>,C+PO+@>,C+PO+@>,C:0J @>,C1 O+@=PC5@O+@=PBY O+@<XC:0O+@1PCI0O+@:4C:0O+@>,BUPO+@>,C:0N-@>,C:0OT@<XC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OEACXD 0F<@6PC&@OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TB\0D^@3LDP@I+@R,CI NX@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC&@I3@I8D8 N7@W8A_ PQ@](DN@LA@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC&@I3@$PCU0G9@P<B0@E>@W8A_ E>@=@B=PM3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC&@NX@7LC 0@L@KPAUPG(@*(C% E>@W8A_ E>@W8A_ E>@W8CK BL@''LC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@<TC1POE@<TC1POE@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@9 C\0L=AF8D/PA]@N A#@JX@W8A_ E>@W8A_ E>@04AOPMDACLA_ E>AD<D80B!!ANDB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC1POE@<TC1PNX@9 C\0M3@7LC\0M3@7LC\0M3@7LC\0NX@9 C1POE@<TC1POE@<TC1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC&@NX@7LAD B5@IH@)PE%@ 8A_ E>@W8A_ E>@W8C70G=AL8B"@S$@(TC2PK_@''$A_ E>@)T@9PQI@-L@=@I3@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC1POE@<TC1PNX@9 C&@NX@9 C&@M3@7LC\0M3@7LC\0M3@7LC\0M3@9 C&@NX@9 C&@NX@<TC1POE@<TC1POE@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 C&@M3@EDD/PSJAGPD] E>@W8A_ E>@W8A_ QP@%8@ZPMB@K CO0OI@>8DRPQI@A<@]0B!!@B@DW N$@$(A[ @_@30@3 I3@9 C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC1POE@9 C&@M3@7LC\0M3@7LC\0M3@7LC\0M3@7LC\0M3@7LC\0M3@7LC\0M3@7LC1POE@<TC1POE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@9 C\0DR@FTD:PQXAB@A_ E>@W8A_ E>@,@A_@@E@6,@5PNG@<$C; QIAD$@G0B!!@JDA%@HI@30C] R\AL\CP0O@@&$C; FTAI0AI I3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1PNX@9 C&@NX@7LB\0I3@''LB\0I3@''LB\0I3@''LB\0I3@''LB\0I3@''LC\0M3@7LC\0NX@9 C&@NX@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 C\0AQ@14A\@@T@W8A_ E>@W8A_ L3@"<@. O%@_(C; OIAD$DRP@_@JD@(PFT@ $CO@M6AL\@'' D&@RXAI HQ@''L@8@LS@ $A%@M6@I8BQ@I3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC1POE@7LC\0M3@7LC\0I3@''LB\0I3@''LB\0I3@''LB\0I3@''LB\0I3@''LB\0M3@7LC\0M3@7LC\0NX@9 C1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC&@M3@)@CB@B;@W8A_ E>@W8B0@F1@C4C9PGW@>8C; QIAD$@QPB!!@YPBBPL<@7XD10B^@RXAI G!!@$PB\0I3@''LC&@NX@<TC&@I3@OPD''@S!!@RXB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1PNX@9 C\0M3@''LB\0I3@''LB\0I3@$PBQ@ID@$PBQ@ID@$PBQ@ID@$PB\0I3@''LB\0I3@''LC\0M3@9 C&@NX@9 C1POE@<TC1PO+@>,C:0O+@>,C:0O+@>,C1POE@9 @C@@Q@J A_ E>@W8B?@KZ@"0AN@OW@>8DRPQI@DT@(PFT@ $C] Q-AND@3 D&@^DBQ@I3@''LB\0NX@9 C1POE@>,C:0O+@>,C:0OE@''LBDPG!!@''LB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC1POE@7LC\0M3@7LB\0I3@''LB\0I3@''LBDPHQ@!!DBDPHQ@!!DBDPHQ@!!DBQ@I3@''LB\0I3@''LB\0M3@7LC\0M3@9 C&@OE@<TC1POE@<TC1PO+@>,C:0O+@>,C1PNX@;(@:@FP@W8A_ O_@C4@%POJ@>8DRP@_@JDA%@HI@7XD[PS!!@OPAI G!!@''LB\0I3@7LC&@OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C&@I3@''LC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,@7@Q;@8HB8 Q;@-<C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1PNX@9 C\0M3@''LB\0I3@''LB40H%@_LA<0G3@_L@(PHQ@!!DBDPHQ@!!DBDPHQ@$PBQ@ID@$PB\0I3@''LB\0M3@7LC&@NX@9 C&@OE@<TC1POE@>,C:0O+@<TC&@P?@F8A$@E>@]LC,0S[@<(DRPQI@JDA/PKS@7XD8PCN@RXA8PI3@''LB\0NX@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,DI I3@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC1POE@7LC\0M3@7LB\0I3@''LB\0CN@-<D= AX@''TB70D&@RXAI D&@RXAI D&@RXBDPG!!@!!DBQ@I3@''LB\0I3@7LC\0M3@7LC&@NX@<TC1POE@<TC:0OE@9 BYPRC@ 8A_ G,AKHB@PPZAD$@(PHI@7XD8PC4@RXBQ@I3@''LC&@NX@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,AI I3@>,DRPA?@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C@0O8@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 C\0M3@''LB\0I3@''LBQ@HQ@^DA8PIO@ZDAI D&@RXAI D&@RXAI D&@RXAI D&@^DBDPHQ@$PBQ@I3@''LB\0I3@7LC\0NX@9 C1POE@<TC1POE@7L@Q0@T@W8A_ P^@%$DRPAE@[4C] S!!@RXBDPI3@''LC&@OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0S7@A<C:0D&AL\C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0N(@-4C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC:0O+@<TC1POE@<TC1POE@9 C&@M3@7LB\0I3@''LB\0G!!@!!DAI D&@.HD=0D&@RXAI D&@OPAI D&@RXAI D&@RXAI D&@^DBDPID@''LB\0I3@''LC\0M3@9 C&@OE@<TC1PNXALXD9PE>@W8@"PA''AA(@QPHI@7X@3 G!!@''LB\0OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0R%@"TB_0LP@+D@(PI5@8@C PF!!@D$CD@J@@I8C:0IL@:XD^0A7@>,C:0O+@>,C:0O+@G<@?0O+@>,C:0QEAF4C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@9 C&@M3@ \DJ0QG@9 D_0FU@@LC''0G(@^ B1 M3AFD@>PF>@-X@C NO@!!HC&@NX@7LC\0I3@''LB\0HQ@^DA8PD&@RXAA0M<@OP@=@B^@I8@'' B^@I8@3 C4@OPAI D&@RXAI HQ@!!DBQ@ID@''LB\0I3@''LC&@NX@9 C&@MQ@TTB0@E>@,@A>0N]AD$A/PM6@OPBDPI3@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C5@DZ@:0C&@NX@9 C1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@RXC>@O+@>,B8 G!!@$0B8PI3@T0D*@M3AMHDRPIPAOXC1PS6@O<C:0O+@>,C:0O+@>,A(@A7@>,C:0N(@''(D4 HI@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC&@NX@(4@30NX@% @LPGF@:TA_ E>@F8BDPL^@W8A_ E>@W8A_ @$@RXCG E>@W8A_ E>@W8DY@I3@Z$@50QK@,TB-0D&@!!DAI D&@RXC2P@@@V8@'' R*@4(D$0P]@$\DA0S!!ANDD8PC4@RXAI D&@RXA8PHQ@$PB\0I3@''LB\0M3@7LC\0N<@((A_ E>@2HBJ QI@JDC] B^@!!DB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0NXA@ A3 G+@E8DFPKD@[,C\0M3@9 C1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,B70IO@>,B\0K"@>,C) AE@>,AT@HI@>,D^0C4@Z@D=0H_@JXC&@O+@>,C:0O+@>,C:0SU@''LC:0O+@R\C:0MA@V8C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1PL)@0PBOPGY@VTA''PR3@!!DDNPE>@W8A_ G?@@\BZ S!!@@4@[0BH@S(BP@NI@''\D10R>@O,D!! ON@!!0D:@H-@I8@!!@E>@W8A\0E3@#DB=0D&@;4A]PA9@P\C] D;AAHA8@QQAG\B+@O!!@7(D8PS!!@I8@'' D&@RXAI D&@!!DBDPID@''LB\0I3@7LB\0B#@&DA_ O4A@0DF AE@ $D8PD&@''LC&@O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@7LBDPS+@AXB; K.@.8B; QZ@JPA3PJD@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0R%@G$C:0QI@M0C:0F!!@<TC1PF!!@>,B\0F!!@>,B,PS!!@>,C:0O+@>,C:0O+@>,C:0O+@7LC:0O+@RXC= O+@T,C] O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0NX@9 C@POG@14A4@I3@WPA_ E>@W8A_ FP@4TD8PG6AGD@% F?@2,B:PIVAI0C6@@"@:@B>@I[@4 @1 R\@4,@R S@AIHANPN0@ $D[P@M@0$@R0H[@<PAO0L.AI0CK C2@V\AV @)@M,AH KI@,$B2PKI@Z8DMPH3@>4D8PS!!@L8AI D&@RXA8PHQ@$PB\0I3@''LB(0H]@W8A_ N!!@+$DRPFT@7XAI I3@7LC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TB\0G!!AL\A9@AO@:HB; K.@.8B; S4A@$B\0OE@>,C:0O+@>,C:0O+@>,C:0O+@%@B,PN(@O<D)PS!!@PHC:0LC@.DC:0B!!AMHC:0OM@? AS@R%@>,C:0O+@>,C:0O+@>,C:0O+@>,@'' EL@RXAS@O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC&@G4@JHCB K@@W8A_ M]@RXDB A!!@<HA(0@W@9DBE@QE@QPA0PSP@:HB; K.@D D8PF$@.8B; K.@.8B; B ANDA^ KK@,,B&PJY@''0DUPQE@E<B;@OKAN<A% I)@E@C@0JT@; @3PR[AALB2PKI@,$B2PKI@,$B2PKI@/4CM@R+AND@'' C4@RXAI D&@!!DBQ@ID@8T@$0E>@W8D@0P;@>8@(PLCANDBDPI3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PD3AFHC" P_@.8B; K9@.8B; O2AL$D8PI3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0D&@<TC&@O+@>,C&@O+@>,C&@O+@>,C&@O+@>,BDPD&@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@%@B7@S!!@>,C:0O+@>,C:0O+@>,C:0O+@9 C&@E@@?0BW@JO@R BXPE>@W8D&@NK@28DE0KT@+ C(@E#AE,B; R AL\B&0K.@.8B; N''@G@@/@S!!@] C6 P<AIP@X@CX@*PD8PG]@:$B*@F/@CLC_PE,AL\D9 HM@ 4A:PG)@>\D^PHI@40A]0D<AF$B[@KI@,$B2PKI@,$B2PKI@,$B2PF^@I\D8PS!!@L8AI D&@RXAT P,ABDA_0E>@Y4D]PKWAD$A/PQE@RXB\0M3@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 C\0C5@J<AIPI3AL,B; K.@.8DYP@?@.8B; RG@Y\@(PS!!@''LC&@O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0NX@)@D2 HP@Y@A_ E>@O(D''@JT@>XA7 D-AJDD @M6@8 B; K.@.8B; N"@20D8PS8@",B$PL0@>8@]0M6ANDC] B!!AD$DRP@_@V,DQPS!!@7X@(PQI@>8DRPB!!@7XD[PL AK<BFPR1@$4A60DJ@-LB;0DY@ @@*PKI@,$B2PKI@,$B2PKI@,$B2PKI@)(@:PS!!AHHBT IH@]0A? H1@T4ASPF_@68A^@K_@G\C@0S!!@!!DB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC1PJB@NL@&@BF@.8B; D!!@RXC+ KY@KXBV E.AOTB; SA@R@DRPM6@RXC\0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C&@NX@R(CU SW@$PCB E>@W8A;@H @28A- CQAA0@A L#@.8B; BEAI0BE0D@@0<@&0J&@FXC] S!!@7XA/PB!!@JD@(PKSANDAI S!!@7XCO@L<@7XD[PC4@RXD8PM6@ $BBPG/@-LD10S!!@0L@QPOI@V8A[ J:@^<A-0SM@[$@&PMF@,$B2PKI@,$B2PKI@,$B2PKI@,$@D Q<@J0@/0B?@OHA@PD2@SHDY0CJ@Y B70QI@[4D[PD&@''LC\0OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 B< O9AB4A+@I3@@DB; K.@.8C30J[@Z4D8PSG@^<@G0QI@)HB; BJ@V@DRPM6@RXB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC&@OE@<TC:0O+@9 @]@F>@2<A$@E>@C@@'' @XAKTC:@EVAGHA&PM6@%4B; K.@4\@S@K>AA D8PM6@JDDRPQI@G\A;0R\@RX@=@SGAF4D8PB^@RXBQ@I3@''LA8PD&@RXA8PID@''LB\0I3@^DAI D&@RXAI HQ@RXD8PLC@YP@QPQI@JDB40HIAD$AQ M^@)(B2PKI@,$B2PKI@,$B2PKI@,$B2PRJAF @& C]@ <@? R6@/XAV@IQ@-<DRPB!!@7XD8PHQ@''LC&@NX@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC&@NX@9 C&@MS@]DBRPNU@.8B; K:@H4@=@O/@C,B[ O#AD$A;0S!!@OPD[PM6@7XDS@I>@3D@(PM6@RXB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1PBN@&4@I SO@D@BN KB@''LA90E>@W8A_ GE@,(A>@PK@.@B/@P$@.8B; D!!AF4BY0S*@ HCZPO.@DTC@0B^ANDC] KS@7XD[PB^@RXB\0I3@''LB\0I3@''LB\0OE@<TC1PNX@9 C&@NX@<TC1POE@<TC&@NX@7LB\0I3@7LB\0HQ@RXD8PQ-@7XC] SG@7X@(PK_@0,D&PKI@,$B2PKI@,$B2PKI@,$B2PKI@T(C:PE=AJXA?@@Y@V8B70OI@A<AZ0M6ANDAI I3@9 C&@NX@9 C1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1PNX@KHAP0HX@1<D^@C6@$P@M@K.@/(@D0M\@ (DR@S!!@ $@(PAE@JDBBPQE@RXB\0HQ@RX@,0DM@JDA/PQ-@^DB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1PA5@N0@* @U@^4DSP@(@W,AI AZ@$LB_PKL@Q<AH0KS@Z(B; K.@.8D@PI>@)4D10SG@ $@]0B!!@YPC@0S!!@^DBQ@D&@RXA8PID@''LC\0OE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC&@NX@9 C&@I3@''LB\0ID@RXAI D&@RXD8PM6@ $B?0P"@& C?PO=@?4C?PO=@?4C?PO=@6(@PPJ)@(,B%0K1@FHALPLQ@ $B5PLE@RXA8PI3@''LC&@NX@9 C&@OE@<TC1PO+@>,C:0O+@>,C1POE@<TC1POE@<TC1PNX@5L@1@J=AO$ABPI3@#PB; K.@.8B; K.@N<@3 N/@*,C?0O.AD$A/PS!!@OPD10M6@7XD8PD&@!!DB\0M3@<TC\0FRANDC] S!!@!!DC\0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1PFF@B D"PB&@%@C*@D$@@P@J@OY@30B[0LRAE0B; MZ@7TD''@J\AHPBMPK_AD$BBPS!!@OPD8PQ-AND@3 D&@$PB\0NX@9 C&@NX@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1PNX@9 C&@NX@''LB\0I3@''LA8PG!!@RXAI C4ANDD[PM6@GDBL0AF@\(A2 GJ@\(A2 GJ@U8BG A-@X@BF Q&@$8@3@A"@7,C] HC@[@B>0BT@;DAV0J6@''LA2@DQ@"\CFPM3@7LC&@OE@9 B-@DIAH,B9@D6@I@C\0J-@PLC_0K.@.8B; A$@RXDU0QB@\<DO@FZ@C(C] S!!@7X@(PB!!@V,BBPQ-@RXB\0ID@!!DBQ@I3@''LC&@OE@>,C:0NX@''LAI D&@''LC\0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0M3@Z,C(0B&@%@C*@D$@-<DRPK-@00@IPKK@.8B; PA@:,B<0S!!@ $@QPAE@JDBBPR\@RXB\0ID@$PB\0I3@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 B\0I3@''LB\0G!!@^DA8PD&@RX@3 S!!ANDD8PA2@#LA&0P[AK,D.0R^@6<CW0B-@JD@(PK_@V8@40C8@P8D^ M6@J8CV0HM@ 4BL@I_@&@BDPE\@)$B20KK@80DX0RA@''L@6 K.@.8B; K.@.8DOPG!!@H,B; K:AE4AU0OL@NPD8PMN@JDDRPQI@A<A;0R\@RX@3 SGAND@'' D&@!!DB\0M3@<TC1POE@<TC:0O+@>,C:0O+@>,C\0I3@''LC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@''L@MPJL@%@C*@D$@RPB70QI@2(DM@H?ABPB<@FA@;,@(PR\@L8D''@M6ADTD8PD&@$PB\0OE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@9 C&@I3@''LB\0I3@!!DA8PG!!@^DAI D&ANDD8PS!!ANDA70RZABLB7 O AK\CI@O0@0LC] L<@JDDRPQI@>8DRPF=@7XBBPQI@.LA  A(AK@@] S!!@VDDP0N4@08B; K.@44AI D.@64DWPAN@WDB3PS:ANDA80P>AB8C; PZ@JDC] B^AI0B40HI@ $C] S!!@RXB\0I3@''LB\0I3@7LC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@9 AI SC@=8C*@D$@RPB70QI@V,D6 O7AD8DRPQIAD$@(PM6@L8BQ@ID@!!DBQ@I3@''LC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC&@NX@''LB\0I3@''LB\0ID@^DA8PD&@RX@'' S!!ANDD8PS!!AI0CF0SBAG4BBPQEADTD8PS!!AI0C] M6@7XCO@L<ADTD8PM6@V,@QPQIAD$@(PL<ANDC] B!!AA(C; PM@@HCE S!!@=X@(PPZ@>8DF B!!@7XD8PR\@ $@(PB!!@[4CO@S!!@^DAI D&@RXAI HQ@''LB\0OE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C\0D&@;HA# D$@-<B70QI@V,CO@S\@]H@(PG/@ $C] S!!@RXB\0M3@9 C&@OE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 B\0I3@''LB\0I3@$PA8PG!!@RXAI C4@L8D8PS!!ANDD8PR\AI0D[PQ-AF4D10S!!ANDD8PB^@L8D8PB^@OPAI D&@L8D8PR\@7XC] M6ANDAI S!!@-L@(PB!!@JDA;0QE@L8D8PKS@YPAZ0G/@0LD8PD&@RX@'' S!!@I8AI D&@''LB\0M3@''LB\0NX@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0M3@RX@10H!!@$DDRPQI@V,CO@@.@B DIPM6@I8AI HQ@''LB\0OE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@9 C&@M3@7LB\0I3@''LBQ@G!!@^DA8PD&@RXAI B^ANDD8PS!!ANDD8PS!!ANDD8PS!!ANDD8PB^@L8AI D&@RXA8PHQ@!!DB\0HQ@!!DA8PD&@RXB\0I3@$PAI B^ANDD8PB^@RXB\0HQ@RX@3 C4@RXAI ID@''LB\0I3@''LB\0I3@9 C1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@7LA8PLC@K4@J@AB@6 @^@EG@K@@''@AEANDB\0M3@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC&@NX@9 C&@I3@''LB\0I3@!!DA8PG!!@^DAI D&@OP@3 S!!ANDD8PS!!ANDD8PS!!AND@'' CN@OP@=@D&@RXAI G!!@!!DBDPI3@''LB\0I3@7LC&@NX@9 C1PI3@''LB\0I3@''LB\0M3@7LB\0I3@''LB\0NX@<TC1PO+@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0I3AND@]0P''@N(C@@MO@K8@''@K_@30AI M3@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 C&@NX@''LB\0I3@''LB\0ID@^DA8PG!!@RXAI D&@OP@=@CNANDD8PS!!ANDD8PC4@OPAI D&@RXAI HQ@!!DBDPID@''LB\0I3@''LC&@NX@9 C&@OE@<TC1POE@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@7LAI M6@A<A[ CS@RPA[ PZ@ $@3 I3@9 C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 C&@NX@9 C\0M3@''LB\0I3@$PA8PG!!@^DA8PD&@RXAI D&@RXAI C4@OP@=@C4@RXAI D&@RXAI G!!@!!DBDPID@''LB\0I3@''LB\0NX@9 C&@NX@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0I3@RXD''@HI@JD@(PFT@7X@3 I3@9 C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@9 C&@M3@7LB\0I3@''LB\0ID@!!DA8PG!!@^DAI D&@RXAI D&@RXAI D&@RXAI D&@^DA8PHQ@!!DBDPID@''LB\0I3@''LB\0M3@9 C&@OE@<TC1POE@>,C:0O+@>,C:0O+@>,BO@F2@>,C:0O+@>,C:0O+@>,C:0O+@>,@C0O+@>,C:0O+@>,C:0O+@>,B-POF@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+AH0DJ@O+@>,C:0O+@>,C:0O+@>,C:0O+@(HC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,B\0I3@RX@3 S!!@RXAI I3@9 C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC&@NX@9 C&@I3@''LB\0I3@$PBQ@G!!@!!DA8PG!!@RXAI D&@RXAI D&@RX@9 P@@@ AJPR,@!!DBDPID@''LB\0I3@''LB\0NX@9 C&@NX@<TC1POE@<TC:0O+@>,C:0O+@>,C:0SX@%LC:0O+@>,C:0O+@>,C:0O+@>,C:0LW@>,C:0O+@>,C:0O+@>,C:0PB@?(C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,DA@M @>,C:0O+@>,C:0O+AI@@HPO+@U4A 0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC\0I3@''LB\0M3@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 C&@NX@''LB\0I3@''LB\0I3@''LBDPG!!@^DA8PG!!@^DA8PG!!@^DA8PR"AH4A8PDPAL0BQ@I3@L@@B0I3@''LB\0JNAJ4B0PNX@9 A5PAS@84C1PN,@#0A!!0F5@>,B90BBAJ8BT0O+@>,B+ @,@9$C:0O+@:0@U@M%@1\C:0O+@>,C:0MTAM B-PO+@  C&PN,@#0B4PA#@>,CF AT@<XC:0NY@_\C:0O+@Z C:0PD@6@C:0NYAN@A[PO+@6TA)PJ/@U4AWPH<@>,C:0KQ@BDCF O+@>,A=0OF@M@B  O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@9 C&@NX@9 C&@NX@''LB\0I3@''LB\0I3@$PBQ@HQ@!!DBDPHQ@!!DBDPHQALPD.@HQ@QTA!!@I3@S\CMPJ0A@TB\0S;@=DDT DD@9 BA@FKAH8@UPJBAM @BPD>@7 @HPQ+AB<@:0IS@>,A2PF3@CX@,PJ?@3X@^ P/@ZXBH O+@>,C:0KQ@LDA<PC^@>,CM0P(AM @F I"@Q\D%PG2@&HD%PO+AB$CF@O+@>,CE0O+A@PCX@OT@_HACPC1AM$D/@AC@KDDW0N5@DLC:0HE@ET@M0R9AB C:0L7@.,DK0OR@FLC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@9 C&@NX@9 B\0I3@''LB\0I3@''LB\0I3@''LB\0ID@$PBQ@ID@$PD7PPO@7@A$PH#@PT@F0I2@''HDQ@C!!ALTD$PNX@1$ATPQ,@<TC1PE&A@PD6@P1@6TC:0@7@L C:0H(@%LC:0SQ@\,CYPAV@G,AB0@\@>,A=0I#@>,C:0O+@P$@BPJB@>,C:0L7AB D6@@Z@9$A[PJ^@*8C+@K%@>,DJPLX@>,C:0LW@>,DA@M @>,C:0O+AF@B9 O+@2TDU O+@^H@F O+AH<A[PO+@#8CM0O+@3\ARPO+@.(C'' O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC&@NX@9 C&@NX@9 C&@NX@''LB\0I3@''LB\0I3@''LB\0I3@''LB\0S]@B4AD0OC@C CN@KNA@TDAPQR@X A.@PP@9 C&@M1@,<C1POEAMLA)PSX@&HC:0O+@($DJPO+AM BT0O+@[PDW0Q_AE<CT@M8@7 C:0O+@1\C:0O+@>,C:0A[@A(B\@O+@3\DJ@SX@&HC:0LZACHC:0O+@1\C:0P)@1 C:0O+@1\C:0PD@6@C+@CB@;TB, IS@>,CIPQV@>,A8 @Z@>,BY@O+@>,@''0CA@>,CM0P(@>,D% JG@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@<TC1POE@<TC1POE@9 C&@NX@9 B\0I3@''LB\0I3@''LB\0I3@''LB\0I3@@(@U0I3@+L@2PD5AAPCNPM3@9 C&@R#@E$C1PF5@T8C: MS@<T@M B]AM BX O+@>,@U @#@>,@; IS@>,D%0D3@>,C:0O+@PXDW0O+@N4BM O+@>,C:0OF@>,C+@O3@*8CM0P(AM BX O+@1(DL O+@>,CE0O+@HH@,PO+@LPBM O+A@PCX@Q @ZXC:0N>@%LC:0M8@3(C:0G"@A(C:0P1@LPC:0C.AMPC:0L7AB C:0RV@*<C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1POE@<TC&@NX@9 C&@NX@9 C\0I3@''LB\0I3@''LB\0I3@''L@O@A\@''LA"@KP@6XB10A<@;<BM0NX@C$D%0H8@V C!!@I1@A(A< O\@9$D8@J_@>,C:0@,AH<B, S<@&HC:0JC@A(C7@G2@EPCF D>@"XC-PR9@>,C:0O+@>HA,0M!!@9LC:0M"AELD8@J_@>,CM Q+@>,C:0M2@>,C:0H&@T<C$0Q+@>,DEPM8@+T@BPNW@=0BX O+@?(CX0B@@_\@UPO+@#8D.PJ2@S8AT0O+@6HDT0O+AJ\B+0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC&@NX@9 C&@NX@7LB\0I3@''LB\0I3@''LB\0L9@''LB\0NX@6XC&@NX@5LBA OE@<TC1POE@"\C1POE@<TC]@LZ@>,C:0O+@:0C:0O+@>,C5@LZ@>,C1 O+@>,C5@HH@<XC:0O+@>,B90O+@<XC:0O+@>,C:0MT@(HC:0O+@:0C:0O+@:0C:0O+@:0C:0O+@:0C:0O+@>,B4PO+@<XC:0OT@=PC:0OT@+TC:0OF@>,C:0L6@5PC:0N,@>,C:0OT@+TC:0O+@>,C+@O+@>,C5@OF@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C1POE@<TC1PNX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1POE@<TC&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@<TC1POE@<TC1POE@<TC1PO+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0OE@<TC1POE@<TC1PNX@9 C&@NX@9 C&@NX@9 C&@NX@9 C&@NX@9 C1POE@<TC1POE@<TC:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+@>,C:0O+')! !

!SimManager class methodsFor: 'resources' stamp: ' 31/3/15 09:57'!
flecheImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #flecheImage"
	
	<resource: #image>
	^Image
		extent: 21 @ 57
		depth: 7
		bitsPerPixel: 8
		palette:
			(MappedPalette
				withColors:
					(#(#(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6841 6841 6841)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4304 4304 4304)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6070 6070 6070)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3533 3533 3533)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7837 7837 7837)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5300 5300 5300)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7066 7066 7066)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4529 4529 4529)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6295 6295 6295)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3758 3758 3758)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5524 5524 5524)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8062 8062 8062)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4753 4753 4753)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3983 3983 3983)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5749 5749 5749)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7516 7516 7516)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4207 4207 4207)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6745 6745 6745)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5974 5974 5974)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5203 5203 5203)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7741 7741 7741)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4432 4432 4432)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6970 6970 6970)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3661 3661 3661)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6199 6199 6199)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5428 5428 5428)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7966 7966 7966)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4657 4657 4657)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7195 7195 7195)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3886 3886 3886)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6424 6424 6424)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5653 5653 5653)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7420 7420 7420)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4111 4111 4111)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6649 6649 6649)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7644 7644 7644)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5107 5107 5107)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4336 4336 4336)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6874 6874 6874)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3565 3565 3565)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6103 6103 6103)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5332 5332 5332)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4561 4561 4561)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6327 6327 6327)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3790 3790 3790)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5557 5557 5557)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7323 7323 7323)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4786 4786 4786)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4015 4015 4015)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5781 5781 5781)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5010 5010 5010)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7548 7548 7548)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4240 4240 4240)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6006 6006 6006)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3469 3469 3469)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5235 5235 5235)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7773 7773 7773)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4464 4464 4464)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7002 7002 7002)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3693 3693 3693)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6231 6231 6231)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5460 5460 5460)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7998 7998 7998)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7227 7227 7227)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3918 3918 3918)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5685 5685 5685)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4914 4914 4914)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7452 7452 7452)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4143 4143 4143)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6681 6681 6681)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5910 5910 5910)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5139 5139 5139)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7677 7677 7677)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4368 4368 4368)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3597 3597 3597)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6135 6135 6135)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5364 5364 5364)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4593 4593 4593)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3822 3822 3822)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6360 6360 6360)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5589 5589 5589)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7355 7355 7355)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4818 4818 4818)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6584 6584 6584)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4047 4047 4047)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7580 7580 7580)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5043 5043 5043)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4272 4272 4272)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6038 6038 6038)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3501 3501 3501)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5267 5267 5267)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7805 7805 7805)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7034 7034 7034)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4497 4497 4497)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6263 6263 6263)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3726 3726 3726)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5492 5492 5492)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8030 8030 8030)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4721 4721 4721)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7259 7259 7259)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3950 3950 3950)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6488 6488 6488)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5717 5717 5717)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4946 4946 4946)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4175 4175 4175)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5942 5942 5942)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5171 5171 5171)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7709 7709 7709)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4400 4400 4400)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6938 6938 6938)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3629 3629 3629)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6167 6167 6167)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5396 5396 5396)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7934 7934 7934)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4625 4625 4625)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(3854 3854 3854)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(8158 8158 8158)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5621 5621 5621)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7387 7387 7387)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4850 4850 4850)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(4079 4079 4079)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(6617 6617 6617)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5846 5846 5846)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(7612 7612 7612)) #(ColorValue 
						#scaledRed:scaledGreen:scaledBlue: #(5075 5075 5075)))
						collect:
							[:each | 
							(each at: 1) value
								perform: (each at: 2)
								withArguments: (each at: 3)]))
		usingBits:
			(ByteArray fromPackedString:
					'HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HB@!!S7I2AB@ HB@ HB@ @@@@HB@ HB@ HBA8BWX!!I4$ HB@ HB@ @@@@HB@ HB@ HDAO^25PJPY2HB@ HB@ @@@@HB@ HB@ HD8%TC@LTP!!<HB@ HB@ @@@@HB@ HB@ I4=LSG- IW,''HB@ HB@ @@@@HB@ HB@ W%-LSD00I )LU"@ HB@ @@@@HB@ HB@@LT1LSD1;XBT2I2@ HB@ @@@@HB@ HB@AJ$1LSD1L^BYMSBD HB@ @@@@HB@ HBM9VU%YVU%Y^6@%L"\ HB@ @@@@HB@ HG$*^7-;^7-;^7!!XST0 HB@ @@@@HB@ HC]OS4=N^2X-KR47ISH@HB@ @@@@HB@ HBP!!I7 +^7%8IPTJ]''-PRR@ @@@@HB@ HBA2_GXGL''$%SWYTI2]$AB@ @@@@HB@ HBA5\"$G]''$%SW-@HB@ HB@ @@@@HB@ HB@ HD1^]''%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&]''%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&K''%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&B''%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&SW%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&SW%[SW-7HB@ HB@ @@@@HB@ HB@ HD0&J%U[SW-7HB@ HB@ @@@@HB@ HB@ HD0&V5U[SW-7HB@ HB@ @@@@HB@ HB@ HD0AIUU[SW-7HB@ HB@ @@@@HB@ HB@ HD1XISE[SW-7HB@ HB@ @@@@HB@ HB@ HD05_SE[SW-7HB@ HB@ @@@@HB@ HB@ HD05U3E[SW-7HB@ HB@ @@@@HB@ HB@ HD19^@5[SW-7HB@ HB@ @@@@HB@ HB@ HD19^@5[SW-7HB@ HB@ @@@@HB@ HB@ HD19T05[SW-7HB@ HB@ @@@@HB@ HB@ HD19LD=[SW-7HB@ HB@ @@@@HB@ HB@ HD1US$=[SW-7HB@ HB@ @@@@HB@ HB@ HD1US$=[SW-7HB@ HB@ @@@@HB@ HB@ HD01S$=[SW-7HB@ HB@ @@@@HB@ HB@ HD0MJ4=[SW-7HB@ HB@ @@@@HB@ HB@ HD1OI$=[SW-7HB@ HB@ @@@@HB@ HB@ HD1OI$=[SW-7HB@ HB@ @@@@HB@ HB@ HD1OI$=[SW-7HB@ HB@ @@@@HB@ HB@ HD1OVD=[SW-7HB@ HB@ @@@@HB@ HB\''I45O^T<L^B(,HB@ HB@ @@@@HB@ HC]OS4=O^T=OS0%ZI2D$\''T @@@@HB@ HBYO^W%9^W%9^T<G^7-P_B@ @@@@HB@ HB] S4<MS4=OS2 %SWYTRR@ @@@@HB@ HBANKT=OS4=OKRX*SW,/HB@ @@@@HB@ HBA@XD=OS4<-JBUM]'')IHB@ @@@@HB@ HB@ T2!!OKR4IA2)MVUH HB@ @@@@HB@ HB@ HR!! JB (IT56H4$ HB@ @@@@HB@ HB@ HCL(JFANJ$4B]2@ HB@ @@@@HB@ HB@ HBD(JB!!MSWX#AB@ HB@ @@@@HB@ HB@ HB@%@5E;B$0!!HB@ HB@ @@@@HB@ HB@ HBAI^REP^0@ HB@ HB@ @@@@HB@ HB@ HB@ RWH\H2@ HB@ HB@ @@@@HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@HB@ HB@ HB@ HB@ HB@ HB@ HB@ @@@@')! !

!SimManager class methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
newFolder
	
	^newFolder ifNil: [newFolder := 'A new folder']! !

!SimManager class methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
newFolder: aFilenmaFolder
	
	^newFolder := aFilenmaFolder! !

!SimManager class methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
newFolderName
	"return a String for newFolder (starting at model's name"
	
	| i listComp str |
	self newFolder isString ifTrue: [^self newFolder].
	listComp := self newFolder components.
	i := listComp
		indexOf: 'Models'
		ifAbsent: [^self newFolder asString].
	str := '..'.
	(listComp
		copyFrom: i + 1
		to: listComp size) do: [:e | str := str , listComp first , e].
	^str! !

!SimManager class methodsFor: 'interface specs' stamp: ' 31/3/15 09:57'!
scenarioBuilderInterface
	"Tools.UIPainter new openOnClass: self andSelector: #scenarioBuilderInterface"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #sizeAutoSave false #labelFromApplication false #openType #advanced #sizeType #lastSavedSize #positionType #screenCenter) 
			#label: 'Confirmation before launching' 
			#min: #(Point 400 200) 
			#max: #(Point 1200 900) 
			#bounds: #(Rectangle 960 540 1615 980) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(LabelSpec 
				#layout: #(Point 268 31) 
				#label: 'Select probes to record' 
				#style: #systemDefault) #(SequenceViewSpec 
				#layout: #(LayoutSizedOrigin 12 0 237 0 236 154) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 8191 7679 7167)) 
				#model: #listControle 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #actionModifierControle) 
				#helpText: 'select a control method. Ctrl click for several selections') #(SequenceViewSpec 
				#layout: #(LayoutFrame 12 0 53 0 248 0 190 0) 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 8191 7679 7167)) 
				#model: #listInit 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #actionModifierInit) 
				#helpText: 'select an init method. Ctrl click for several selections') #(CheckBoxSpec 
				#layout: #(Point 13 6) 
				#name: #CheckBox1 
				#model: #fixRandomSeed 
				#label: 'Fix the random seed to' 
				#style: #small) #(ActionButtonSpec 
				#layout: #(LayoutFrame 458 0 -40 1 521 0 -8 1) 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #accept 
				#label: 'Apply' 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 12 31) 
				#label: 'Select a method of ' 
				#style: #systemDefault) #(LabelSpec 
				#layout: #(Point 128 31) 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red)) 
				#label: 'initialization' 
				#style: #systemDefault) #(LabelSpec 
				#layout: #(Point 12 216) 
				#label: 'Select a method of' 
				#style: #systemDefault 
				#mnemonic: #'22') #(LabelSpec 
				#layout: #(Point 127 216) 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red)) 
				#label: 'control' 
				#style: #systemDefault) #(CheckBoxSpec 
				#layout: #(Point 12 196) 
				#name: #releaseRandomSeed 
				#flags: 32 
				#model: #releaseRandomSeed 
				#label: 'Release random seed after initialization' 
				#style: #small) #(InputFieldSpec 
				#layout: #(Rectangle 147 5 265 29) 
				#name: #randomSeed 
				#flags: 40 
				#model: #randomSeed 
				#alignment: #right 
				#type: #number 
				#formatString: '0') #(LabelSpec 
				#layout: #(Point 12 407) 
				#name: #Label1 
				#label: 'Final step:') #(InputFieldSpec 
				#layout: #(Rectangle 74 406 145 428) 
				#name: #InputField1 
				#model: #finalStep 
				#type: #number 
				#formatString: '0') #(SequenceViewSpec 
				#layout: #(LayoutFrame 269 0 53 0 -15 1 -75 1) 
				#flags: 15 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6143 6143 8191)) 
				#model: #listProbes 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyProbe) 
				#helpText: 'select the probes (indicators). Ctrl click for several probes' 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #checkMark) #(ActionButtonSpec 
				#layout: #(LayoutFrame 388.5 0 -40 1 450.5 0 -8 1) 
				#name: #cancel 
				#model: #cancel 
				#label: 'Cancel' 
				#defaultable: true) #(CheckBoxSpec 
				#layout: #(LayoutSizedOrigin 269 0 -67 1.0 122 19) 
				#name: #CheckBox2 
				#model: #enableBackwardValue 
				#helpText: 'Backward option will store each step of the model' 
				#label: 'Enable stepping back'))))! !

!SimManager class methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
separator
	
	^'-------'! !

!SimManager class methodsFor: 'interface specs' stamp: ' 31/3/15 09:57'!
windowNewDeviation
	"Tools.UIPainter new openOnClass: self andSelector: #windowNewDeviation"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Back to simulation' 
			#min: #(Point 543 330) 
			#max: #(Point 0 0) 
			#bounds: #(Rectangle 720 450 1263 780) 
			#colors: #(LookPreferences 
				#setForegroundColor: nil 
				#setBackgroundColor: #(ColorValue #white) 
				#setSelectionForegroundColor: nil 
				#setSelectionBackgroundColor: nil 
				#setBorderColor: nil)) 
		#component: #(SpecCollection 
			#collection: #(#(LabelSpec 
				#properties: #(PropertyListDictionary #labelFromApplication false) 
				#layout: #(Point 22 12) 
				#name: #Label1 
				#label: 'A new forwards-in-time branch may be taken at time T: ' 
				#style: #large) #(LabelSpec 
				#layout: #(Point 22 198) 
				#name: #Label2 
				#label: 'The new simulation history files will be stored into:' 
				#style: #systemDefault) #(LabelSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Point 22 224) 
				#name: #Label3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 6089 762 3426)) 
				#label: #newFolderName) #(LabelSpec 
				#layout: #(Point 230 264) 
				#name: #Label4 
				#label: 'Ok to continue?' 
				#style: #large) #(CheckBoxSpec 
				#layout: #(Point 22 248) 
				#name: #CheckBox1 
				#model: #enableBackwardValue 
				#label: 'Enable stepping back' 
				#style: #systemDefault) #(ActionButtonSpec 
				#layout: #(Rectangle 196 297 249 317) 
				#name: #ActionButton1 
				#model: #accept 
				#label: 'OK' 
				#defaultable: true) #(ActionButtonSpec 
				#layout: #(Rectangle 316 297 369 317) 
				#name: #ActionButton2 
				#model: #cancel 
				#label: 'Cancel' 
				#defaultable: true) #(ArbitraryComponentSpec 
				#layout: #(Rectangle 334 150 537 228) 
				#name: #ViewHolder1 
				#flags: 0 
				#component: #deviationImage) #(InputFieldSpec 
				#layout: #(Rectangle 420 15.5 476 36.5) 
				#name: #InputField2 
				#flags: 0 
				#model: #nextStep 
				#tabable: false 
				#style: #large 
				#isReadOnly: true 
				#type: #number 
				#formatString: '0') #(LabelSpec 
				#layout: #(Point 23 37) 
				#name: #Label7 
				#label: 'Please, choose the simulation way:' 
				#style: #large) #(RadioButtonSpec 
				#layout: #(Point 23 70) 
				#name: #RadioButton1 
				#model: #deviationChoice 
				#label: 'Same way' 
				#select: #noDeviation) #(LabelSpec 
				#layout: #(Point 38 83) 
				#name: #Label8 
				#label: '(same #step method, same random seed)' 
				#style: #small) #(RadioButtonSpec 
				#layout: #(Point 23 113) 
				#name: #RadioButton2 
				#model: #deviationChoice 
				#label: 'Probably same way' 
				#select: #deviationRandom) #(LabelSpec 
				#layout: #(Point 38 126) 
				#name: #Label9 
				#label: '(same #step method, new random seed)' 
				#style: #small) #(RadioButtonSpec 
				#layout: #(Point 23 156) 
				#name: #RadioButton3 
				#model: #deviationChoice 
				#label: 'Different way' 
				#select: #newDeviation) #(LabelSpec 
				#layout: #(Point 38 169) 
				#name: #Label10 
				#label: '(other #step method, new random seed)' 
				#style: #small) #(ArbitraryComponentSpec 
				#layout: #(Rectangle 334 46 537 124) 
				#name: #ViewHolder2 
				#flags: 0 
				#component: #deviation2image) #(ArbitraryComponentSpec 
				#layout: #(Rectangle 398 104 421 162) 
				#name: #ViewHolder3 
				#flags: 0 
				#component: #flecheImage))))! !

!SimManager methodsFor: 'actions' stamp: 'SergeStinckwich 3/31/2016 12:16'!
accept
	
	self listInit selection isNil
		ifTrue: [^self inform: 'Please, select a method of #initialization']
		ifFalse: [self cormasModel activeInit: self listInit selection].
	self listControle selection isNil
		ifTrue: [^self inform: 'Please, select a method of #control']
		ifFalse: [self cormasModel activeControl: self listControle selection].
	self closeRequest.
	self setActiveProbes.
	self initScenario.
	^true! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
allReplayButtonsTo: bool
	"bool = false => all replay buttons are grey and inactivate.
	buttonName = <Symbol> = #step #stepBack #run #runBack #replayRunForward #replayStepForward  "
	
	self simButtonAt: #stepBack displayActivated: bool.
	self simButtonAt: #runBack displayActivated: bool.
	self simButtonAt: #replayRunForward displayActivated: bool.
	self simButtonAt: #replayStepForward displayActivated: bool! !

!SimManager methodsFor: 'actions' stamp: ' 31/3/15 09:57'!
applyUserChangeForFinalStep: aNewFinalStep
	"this method is call from Cormas when user have manually change the inputField current step"
	
	aNewFinalStep < 0 ifTrue: [^false].
	self finalTime = aNewFinalStep ifTrue: [^true].
	self currentTime < aNewFinalStep
		ifTrue:
			[self simButtonAt: #run displayActivated: true.
			^true]
		ifFalse:
			[self simButtonAt: #run displayActivated: false.
			^false]! !

!SimManager methodsFor: 'actions' stamp: ' 31/3/15 09:57'!
applyUserChangeForStep: aNewStep
	"this method is call from Cormas when user have manually change the inputField current step"
	
	self enableBackward ifFalse: [^false].
	aNewStep < 0 ifTrue: [^false].
	self currentTime = aNewStep ifTrue: [^true].
	aNewStep = 0
		ifTrue: [self setButtonsForTime0]
		ifFalse: [self setButtonsForTime1].
	self currentTime < aNewStep ifTrue: [^self replayStepForward: aNewStep].
	self currentTime > aNewStep
		ifTrue:
			[buttonsForwardAreOn := false.
			^self restoreOrganizationAt: aNewStep].
	^false! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
buttonsForwardAreOn
	
	^buttonsForwardAreOn ifNil: [buttonsForwardAreOn := false]! !

!SimManager methodsFor: 'actions' stamp: ' 31/3/15 09:57'!
cancel
	
	self closeRequest.
	^false! !

!SimManager methodsFor: 'actions' stamp: ' 31/3/15 09:57'!
changedRandomSeed
	
	| wrapper |
	wrapper := self builder componentAt: #randomSeed.
	fixRandomSeed value
		ifTrue:
			[wrapper beVisible.
			wrapper enable.	"wrapper beInvisible."
			(self builder componentAt: #releaseRandomSeed) enable]
		ifFalse:
			[wrapper disable.
			(self builder componentAt: #releaseRandomSeed) disable.
			releaseRandomSeed value: false]! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
confirmDeviation
	"check if bos file for next step exists. If not, then continue to simulate and to save into the same folder (continue the same simulation process).
	If exists, then proposes to save the sim history (from 0 to currentStep) into a new folder"
	
	| finename resp |
	finename := self simFolder
		construct: (self stepFileNameAtStep: self currentTime + 1).
	finename exists
		ifTrue:
			[self class
				newFolder:
					((Cormas dumpPath: self cormasModel class name) construct: self newSimName).
			resp := self openNewDeviationWin.
			resp
				ifTrue:
					[self simNumero: self simNumero + 1.
					self enableBackward
						ifTrue:
							[self copyPreviousBackStepsInNewFolder.
							self traceSize: self currentTime]
						ifFalse: [self traceSize: 0]].
			^resp]
		ifFalse: [^true]! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
copyPreviousBackStepsInNewFolder
	
	| stepFiles previousFolder |
	stepFiles := self simFolder directoryContents
		select:
			[:st | 
			(st
				indexOfSubCollection: self stepNameStart
				startingAt: 1) ~= 0].
	stepFiles := stepFiles
		select:
			[:str | 
			(str
				copyFrom: 1 + self stepNameStart size
				to: str size) asNumber <= self currentTime].	"change it simFolder and simName"
	previousFolder := self simFolder copy.
	self simFolder: self class newFolder.
	self simFolder makeWritable.
	self simName: self class newFolder tail.	"copy the stepfiles to the new folder"
	stepFiles
		do:
			[:str | 
			| files |
			files := previousFolder filenamesMatching: str.
			files isEmpty
				ifFalse:
					[files first copyTo: (self simFolder construct: files first tail)]]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
cormas
	
	^self cormasModel cormas! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
cormasModel
	
	^cormasModel! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
cormasModel: anObject
	
	cormasModel := anObject! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
cormasModelClass
	
	^self cormasModel class! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
currentSimEnded
	
	^self finalTime <= self currentTime! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
currentTime
	
	^self cormasModel timeStep! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
currentTime: aValue
	
	self cormasModel timeStepValue: aValue! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
deviationChoice
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^deviationChoice isNil
		ifTrue: [deviationChoice := #noDeviation asValue]
		ifFalse: [deviationChoice]! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
displayRunDuration: duration
	"display on th Transcript, the duration time of the simulation"
	
	| txt |
	txt := '
Simulation [' , self simName , ']¬†was run in ' , duration printString ,
			' milliseconds'.
	duration > 1000
		ifTrue:
			[| dur |
			txt := txt , ', ie. '.
			dur := Time fromSeconds: duration / 1000.
			txt := txt , dur hours printString , ' h: ' , dur minutes printString ,
					' m: ' , dur seconds asFloat printString , ' s.'].
	Transcript print: txt! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
dontAsk
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^dontAsk isNil
		ifTrue: [dontAsk := false asValue]
		ifFalse: [dontAsk]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
enableBackward
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^enableBackward isNil
		ifTrue:
			[enableBackward := self cormasModelClass defaultSteppingBackSetting]
		ifFalse: [enableBackward]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
enableBackward: bool
	
	enableBackward := bool.
	bool
		ifFalse: [self allReplayButtonsTo: false]
		ifTrue:
			[self currentTime = 0
				ifTrue: [self allReplayButtonsTo: false]
				ifFalse: [self allReplayButtonsTo: true]]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
enableBackwardValue
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^enableBackwardValue isNil
		ifTrue:
			[enableBackwardValue := self cormasModelClass defaultSteppingBackSetting
				asValue]
		ifFalse: [enableBackwardValue]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
finalStep
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^finalStep isNil
		ifTrue: [finalStep := 0 asValue]
		ifFalse: [finalStep]! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
finalTime
	
	^self cormas cycle value! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
finishSimulation
	
	self cormasModel timeStepValue: self finalTime! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
fixRandomSeed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^fixRandomSeed isNil
		ifTrue: [fixRandomSeed := false asValue]
		ifFalse: [fixRandomSeed]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
fixedRandomSeed
	
	^fixedRandomSeed! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
fixedRandomSeed: anObject
	
	fixedRandomSeed := anObject! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
getStepNumberOfBosFilename: aFilename
	"Return the number from the name of the bosFile.
	Example: 'step_26.bos' => 26
	aFilename = <String>"
	
	| name |
	name := (Cormas splitString: aFilename with: $.) first.
	name := name
		copyFrom: self stepNameStart size + 1
		to: name size.
	^Cormas stringAsObjectType: name! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
initRandomSeed
	
	self fixRandomSeed value
		ifTrue: [Cormas randomSeed: self randomSeed value]
		ifFalse: [Cormas initRandomSeed]! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
initScenario
	
	self cormas cycle value: self finalStep value.
	self enableBackward: self enableBackwardValue value.	"*** initialize the simulation ***"
	self initializeSimulation.
	self keepOrReleaseRandomSeed! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
initScenarioWindow
	
	| initialList aSet i |
	self randomSeed value = 1 ifTrue: [self randomSeed: Cormas seed asValue].
	self fixRandomSeed onChangeSend: #changedRandomSeed to: self.	"self fixRandomSeed value: self fixRandomSeed value."
	(self enableBackward isKindOf: Boolean)
		ifTrue: [enableBackwardValue := self enableBackward asValue].
	self listInit
		list: (self cormasModel class organization listAtCategoryNamed: #init).
	self listInit list size = 0
		ifTrue:
			[^Dialog warn: 'The model does not define any method for initialization !!'].
	(self cormasModel activeInit
		ifNotNil: [:m | self listInit list includes: m]
		ifNil: [false])
		ifTrue: [self listInit selection: self cormasModel activeInit]
		ifFalse:
			[self listInit list size >= 1
				ifTrue: [self listInit selection: self listInit list first]].
	self listControle
		list: (self cormasModel class organization listAtCategoryNamed: #control).
	self listControle list size = 0
		ifTrue:
			[^Dialog warn: 'The model does not define any method for control !!'].
	(self cormasModel activeControl
		ifNotNil: [:m | self listControle list includes: m]
		ifNil: [false])
		ifTrue: [self listControle selection: self cormasModel activeControl]
		ifFalse:
			[self listControle list size >= 1
				ifTrue: [self listControle selection: self listControle list first]].
	initialList := List new.
	aSet := Set new.
	i := 0.
	self cormasModel class probes
		do:
			[:p | 
			i := i + 1.
			initialList
				add: self cormasModel class name asString , '>>' , p asString.
			(self cormasModel class activeProbes includes: p) ifTrue: [aSet add: i]].
	(self cormasModel class allClasses
		asSortedCollection: [:cl1 :cl2 | cl1 name < cl2 name])
		do:
			[:c | 
			(c probes isEmpty or: [c isAbstract])
				ifFalse:
					[initialList add: self class separator.
					i := i + 1.
					c probes
						do:
							[:p | 
							i := i + 1.
							initialList add: c name asString , '>>' , p asString.
							(c activeProbes includes: p) ifTrue: [aSet add: i]]]].
	self listProbes list: initialList.
	self listProbes selectionIndexHolder value: aSet.
	self finalStep value: self cormasModel finalTime.
	self builder: nil! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
initializeSimulation
	
	self setSimName.
	self simFolder: nil.
	self simNumero: self simNumero + 1.
	self traceSize: 0.
	self allReplayButtonsTo: false.
	self finalTime > 0 ifTrue: [self simButtonAt: #run displayActivated: true].	"self updateCormasInterface."
	self initRandomSeed.
	self cormas initSimulation.
	self enableBackward ifTrue: [self storeCurrentStep]! !

!SimManager methodsFor: 'time' stamp: ' 31/3/15 09:57'!
intoASimulation
	"return if the current sim is between the time range (0 - final time) "
	
	^(self currentTime = 0 or: [self finalTime <= self currentTime]) not! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
keepOrReleaseRandomSeed
	
	self releaseRandomSeed value ifTrue: [Cormas initRandomSeed]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
listControle
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^listControle isNil
		ifTrue: [listControle := SelectionInList new]
		ifFalse: [listControle]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
listInit
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^listInit isNil
		ifTrue: [listInit := SelectionInList new]
		ifFalse: [listInit]! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
listProbes
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^listProbes isNil
		ifTrue: [listProbes := MultiSelectionInList new]
		ifFalse: [listProbes]! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
newSimName
	"Return a new simName defined from the current clock time. 
	Ex:    self basicNew newSimName  =>   sim_2014.04.22-14.09.43"
	
	| d |
	d := Timestamp now.
	^self simNameStart , d year printString , '.'
		,
			(d month < 10
				ifTrue: ['0' , d month printString]
				ifFalse: [d month printString]) , '.'
		,
			(d day < 10
				ifTrue: ['0' , d day printString]
				ifFalse: [d day printString]) , '-'
		,
			(d hour < 10
				ifTrue: ['0' , d hour printString]
				ifFalse: [d hour printString]) , '.'
		,
			(d minute < 10
				ifTrue: ['0' , d minute printString]
				ifFalse: [d minute printString]) , '.'
		,
			(d second < 10
				ifTrue: ['0' , d second printString]
				ifFalse: [d second printString])! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
nextStep
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^nextStep isNil
		ifTrue: [nextStep := (self currentTime + 1) asValue]
		ifFalse: [nextStep]! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
openNewDeviationWin
	
	| resp |
	(self openDialogInterface: #windowNewDeviation) ifFalse: [^false].
	resp := self deviationChoice value.
	resp = #noDeviation.
	resp = #deviationRandom ifTrue: [Cormas initRandomSeed].
	resp = #newDeviation
		ifTrue:
			[releaseRandomSeed value: true.
			^self setStepMethod].
	^true! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
openReplayWin
	
	| directoryContent name firstStep |
	self terminateAllProcesses.
	directoryContent := (Cormas dumpPath: self cormasModel class name)
		directoryContents asOrderedCollection.
	directoryContent
		removeAllSuchThat:
			[:txt | 
			(txt
				startingAt: 1
				couldComplete: self simNameStart) not].
	directoryContent isEmpty
		ifTrue:
			[^Dialog warn: 'The ''Dump'' folder does not contain any stored simulation'].
	name := directoryContent
		detect: [:txt | txt = self simName]
		ifNone: [directoryContent first].
	self simName: name.
	name := Dialog
		requestDirectoryName: 'Choose a ''Dump'' Directory:'
		default: ((Cormas dumpPath: self cormasModel class name) construct: name).
	name isEmpty ifTrue: [^nil].
	self simFolder: name asFilename.
	self simNumero: self simNumero + 1.
	self enableBackward: true.
	directoryContent := name asFilename directoryContents asOrderedCollection.
	directoryContent
		removeAllSuchThat:
			[:txt | 
			(txt
				startingAt: 1
				couldComplete: self stepNameStart) not].
	directoryContent isEmpty
		ifTrue:
			[^Dialog
				warn:
					'The '' ' , name , ' '' folder does not contain any stored simulation'].
	self traceSize: directoryContent size - 1.
	self traceSize > 1
		ifTrue:
			[self simButtonAt: #replayRunForward displayActivated: true.
			self simButtonAt: #replayStepForward displayActivated: true].
	firstStep := self getStepNumberOfBosFilename: directoryContent first.
	firstStep > 0
		ifTrue:
			[Dialog warn: 'The replay will starts at step ' , firstStep printString].
	self currentTime: firstStep.
	self cormas cycle value: self traceSize + firstStep.
	self cormasModel spaceModel ifNil: [self cormasModel initializeSpaceModel].
	self replayStepForward: firstStep! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
openScenarioBuilderWin
	
	self terminateAllProcesses.
	self initScenarioWindow.
	self openInterface: #scenarioBuilderInterface.
	self changedRandomSeed! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
randomSeed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^randomSeed isNil
		ifTrue: [randomSeed := 1 asValue]
		ifFalse: [randomSeed]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
randomSeed: anObject
	
	randomSeed := anObject! !

!SimManager methodsFor: 'undo/redo' stamp: ' 31/3/15 09:57'!
redo
	"reload the last redo BOS File from the redoList"
	
	| filename currentFile |
	self redoList size < 2 ifTrue: [^Dialog warn: 'No available Redo'].
	currentFile := self redoList last.
	self redoList removeLast.
	filename := self redoList last.
	(self cormasModel restoreOrganizationFromFile: filename)
		ifTrue: [self undoList add: currentFile]
		ifFalse: [redoList := nil]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
redoList
	
	^redoList ifNil: [redoList := OrderedCollection new]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
redoList: anObject
	
	redoList := anObject! !

!SimManager methodsFor: 'aspects' stamp: ' 31/3/15 09:57'!
releaseRandomSeed
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^releaseRandomSeed isNil
		ifTrue: [releaseRandomSeed := false asValue]
		ifFalse: [releaseRandomSeed]! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
replayRunForward
	"Replay the stored simulation history forward using BOS file.
	Threaded process"
	
	Processor yield.	"Terminate the others processes"
	processRun isNil
		ifFalse:
			[processRun terminate.
			processRun := nil].
	processReplayBackward isNil
		ifFalse:
			[processReplayBackward terminate.
			processReplayBackward := nil].	"Suspend or resume current process"
	processReplayForward isNil
		ifFalse:
			[processReplayForward suspendedContext isNil
				ifFalse:
					[processReplayForward suspendingList isNil
						ifFalse: [^processReplayForward suspend]
						ifTrue: [^processReplayForward resume]]].	"Create the process"	"*********************************************************************************"	"**********************     RUN  Step Forward threaded    *********************"
	processReplayForward := ["***"
	[self currentTime < self traceSize or: [processReplayForward = nil]]
		whileTrue:
			[self replayStepForward
				ifFalse:
					[processReplayForward terminate.
					processReplayForward := nil.
					^nil]]	"***"] forkAt: Processor userBackgroundPriority.	"  *********************       END PROCESS ***        ************************"	"*********************************************************************************"	"Normaly, the instructions below are not called, because #terminate (called on process) will leave this current method"
	self finalTime = self currentTime
		ifTrue:
			[processReplayForward terminate.
			processReplayForward := nil]! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
replayStepForward
	"Replay a step forward using BOS file"
	
	^self replayStepForward: self currentTime + 1! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
replayStepForward: newStep
	"Replay a newStep forward using BOS file"
	
	| finename resp |
	finename := self simFolder construct: (self stepFileNameAtStep: newStep).
	finename exists
		ifFalse:
			[self simButtonAt: #replayRunForward displayActivated: false.
			self simButtonAt: #replayStepForward displayActivated: false.
			buttonsForwardAreOn := false.
			Dialog
				warn:
					'Sorry, there is no bos file at time ' , newStep printString ,
							'
for simulation ' , self simName.
			^false].
	undoList := nil.
	redoList := nil.
	resp := self cormasModel restoreOrganizationFromFile: finename.
	finename := self simFolder
		construct: (self stepFileNameAtStep: newStep + 1).
	finename exists
		ifFalse:
			[self simButtonAt: #replayRunForward displayActivated: false.
			self simButtonAt: #replayStepForward displayActivated: false.
			buttonsForwardAreOn := false].
	^resp! !

!SimManager methodsFor: 'replay-store/restore' stamp: ' 31/3/15 09:57'!
restoreOrganizationAt: aStep
	"Restore the stored model state at aStep"
	
	| finename |
	finename := self simFolder construct: (self stepFileNameAtStep: aStep).
	finename exists
		ifFalse:
			[Dialog
				warn:
					'Sorry, there is no bos file at time ' , aStep printString ,
							'
for simulation ' , self simName.
			^false].
	self buttonsForwardAreOn
		ifFalse:
			[self simButtonAt: #replayRunForward displayActivated: true.
			self simButtonAt: #replayStepForward displayActivated: true.
			self simButtonAt: #run displayActivated: true.
			buttonsForwardAreOn := true].
	^self cormasModel restoreOrganizationFromFile: finename! !

!SimManager methodsFor: 'replay-backward' stamp: ' 31/3/15 09:57'!
runBack
	"Replay the story of the stored simulation backwards, using BOS file.
Threaded process"
	
	Processor yield.	"Terminate the others processes"
	processRun isNil
		ifFalse:
			[processRun terminate.
			processRun := nil].
	processReplayForward isNil
		ifFalse:
			[processReplayForward terminate.
			processReplayForward := nil].	"Suspend or resume current process"
	processReplayBackward isNil
		ifFalse:
			[processReplayBackward suspendedContext isNil
				ifFalse:
					[processReplayBackward suspendingList isNil
						ifFalse: [^processReplayBackward suspend]
						ifTrue: [^processReplayBackward resume]]].	"Create the process"	"*********************************************************************************"	"**********************     RUN  Step Back threaded    *********************"
	processReplayBackward := ["***"
	[self currentTime <= 0 or: [processReplayBackward = nil]]
		whileFalse:
			[self stepBack
				ifFalse:
					[processReplayBackward terminate.
					processReplayBackward := nil.
					^nil]]	"***"] forkAt: Processor userBackgroundPriority.	"  ********************       END PROCESS ***        ********************"	"*******************************************************************"	"The instructions below are, normaly, not called, because #terminate (called on process) will leave this current method"
	self currentTime = 0
		ifTrue:
			[processReplayBackward terminate.
			processReplayBackward := nil]! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
runSimulation
	"  Loop over the STEPs until simulation end. This take place into a treaded process (called from runSimulationThreaded).
	Display the Duration time on the Transcript"
	
	| chrono |
	chrono := Time millisecondsToRun: [self runSimulation_Basic].
	self simButtonAt: #run displayActivated: false.
	self displayRunDuration: chrono.
	processRun terminate.
	processRun := nil! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
runSimulationThreaded
	"  Loop over the STEPs until simulation end. Threaded process.
	Method called from Cormas' runButton [>II]"
	
	Processor yield.	"Terminate the others processes"
	processReplayForward isNil
		ifFalse:
			[processReplayForward terminate.
			processReplayForward := nil].
	processReplayBackward isNil
		ifFalse:
			[processReplayBackward terminate.
			processReplayBackward := nil].	"Suspend or resume current process"
	processRun isNil
		ifFalse:
			[processRun suspendedContext isNil
				ifFalse:
					[processRun suspendingList isNil
						ifFalse:
							[self simRunButton_Pause: false.
							^processRun suspend]
						ifTrue:
							[self simRunButton_Pause: true.
							^processRun resume]]].	"Create the process"	"*******************************************************************"	"**********************     RUN  threaded    *********************"
	processRun := [self runSimulation]
		forkAt: Processor userBackgroundPriority.	"  ********************       END LOOP        ********************"	"*******************************************************************"	"The instructions below are, normaly, not called, because #terminate (called on process) will leave this current method"
	self finalTime = self currentTime
		ifTrue:
			[processRun terminate.
			processRun := nil.
			self simButtonAt: #run displayActivated: false]! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
runSimulation_Basic
	"Run one simulation step by step.
	Do not display the Duration time on the Transcript.
	Method called from #runSimulation but also from SensitivityAnalysisAbstract #runOneSimulation"
	
	| continue |
	continue := true.
	[continue]
		whileTrue:
			[self currentSimEnded
				ifTrue: [continue := false]
				ifFalse: [self runStepByStep ifNil: [continue := false]]	" *********   One Step  ***********"	" *********     Done  ***********"]! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
runStepByStep
	
	self buttonsForwardAreOn ifTrue: [buttonsForwardAreOn := false].
	undoList := nil.
	redoList := nil.
	self enableBackward
		ifTrue:
			[self confirmDeviation
				ifFalse: [^nil]
				ifTrue:
					[self cormasModel activeControl isNil
						ifTrue: [self setStepMethod ifFalse: [^nil]]]]
		ifFalse:
			[self cormasModel activeControl isNil
				ifTrue: [^self cormas alert_NoDynamic]].	"  **********   RUN Step   ********"
	self cormasModel runStep.	"  **********    Done   ********"
	self enableBackward ifTrue: [self storeCurrentStep]! !

!SimManager methodsFor: 'actions' stamp: ' 31/3/15 09:57'!
setActiveProbes
	"set the active probes (to be registered) to CormasModel class"
	
	self cormasModel class setActiveProbes: self listProbes selections! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
setButtonsForTime0
	
	self simButtonAt: #stepBack displayActivated: false.
	self simButtonAt: #runBack displayActivated: false.
	enableBackward value
		ifFalse:
			[self simButtonAt: #replayRunForward displayActivated: false.
			self simButtonAt: #replayStepForward displayActivated: false]! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
setButtonsForTime1
	
	enableBackward value
		ifTrue:
			[self simButtonAt: #stepBack displayActivated: true.
			self simButtonAt: #runBack displayActivated: true]! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
setSimName
	"set the simName attribute to the current time"
	
	self simName: self newSimName.
	^simName! !

!SimManager methodsFor: 'replay-forward' stamp: ' 31/3/15 09:57'!
setStepMethod
	
	| resp |
	(self enableBackward isKindOf: Boolean)
		ifTrue: [enableBackwardValue := self enableBackward asValue].
	self listControle
		list: (self cormasModel class organization listAtCategoryNamed: #control).
	self listControle list size = 0
		ifTrue:
			[Dialog warn: 'The model does not define any method for control !!'.
			^false].
	self cormasModel activeControl notNil
		ifTrue: [self listControle selection: self cormasModel activeControl]
		ifFalse:
			[self listControle list size >= 1
				ifTrue: [self listControle selection: self listControle list first]].
	self finalStep value: self cormasModel finalTime.
	resp := self openDialogInterface: #changeStepInterface.
	resp ifFalse: [^false].
	self listControle selection isNil
		ifTrue:
			[Dialog warn: 'Please, select a method of #control'.
			^self setStepMethod]
		ifFalse: [self cormasModel activeControl: self listControle selection].
	self cormas cycle value: self finalStep value.
	self enableBackward: self enableBackwardValue value.
	self keepOrReleaseRandomSeed.
	^true! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
simButtonAt: buttonName displayActivated: bool
	"bool = false => display the buttonName in grey color and inactivate it, 
			otherwise, display the button in red or green and activate it.
	buttonName = <Symbol> = #step #stepBack #run #runBack #replayRunForward #replayStepForward 
	bool = <Bollean>

List of buttons : runBackButton stepBackButton <--  Time  --> replayStepForwardButton replayRunForwardButton stepButton runButton 
List of icons : 
		runBack_offIcon     -     runBackIcon
		stepBack_offIcon   -   stepBackIcon
		replayStepForwardIcon  - ->   replayStepForward_offIcon (= step_offIcon)
		replayRunForwardIcon   - ->  replayRunForward_offIcon (= run_offIcon)
		step_offIcon    -    stepIcon
		run_offIcon   -      runIcon
"
	
	| aLabel aButtonName |
	(#(#step #stepBack #run #runBack #replayRunForward #replayStepForward)
		includes: buttonName) ifFalse: [self halt].
	aLabel := buttonName.
	aButtonName := buttonName.
	bool ifFalse: [aLabel := aLabel , '_off'].
	aLabel := (aLabel , #Icon) asSymbol.
	aButtonName := (aButtonName , #Button) asSymbol.	"Dev todo: 'Ancienne m√©thode pour simInterface independante'.  "	"self cormas simulationWin controller notNil 
		ifTrue: 
			[self simulationWin controller closeAndUnschedule.
			self simulationWin: nil]."
	(self cormas mainBuilder componentAt: aButtonName) isNil
		ifFalse:
			[(self cormas mainBuilder componentAt: aButtonName)
				label: (Cormas perform: aLabel)]! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
simFolder
	"return the appropriate Dump folder = simName"
	
	simFolder
		ifNil:
			[simFolder := (Cormas dumpPath: self cormasModel class name)
				construct: self simName].
	simFolder exists ifFalse: [simFolder makeDirectory].
	^simFolder! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
simFolder: aFilename
	"Set the simFolder = aFilename"
	
	^simFolder := aFilename! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
simName
	
	^simName ifNil: [simName := '']! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
simName: aName
	
	simName := aName.
	self cormas simName value: 'Sim name: ' , simName! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
simNameStart
	"Return the begining part of each simName (=> 'sim_' )  "
	
	^'sim_'! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
simNumero
	
	^simNumero ifNil: [simNumero := 0]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
simNumero: nb
	
	undoList := nil.
	redoList := nil.
	simNumero := nb.
	self cormas simNum value: 'Sim number: ' , nb printString! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
simRunButton_Pause: bool
	"bool = false => display the run button [ I> II ] 
			otherwise, display as [ II ].
	buttonName = <Symbol> =  #run 
	bool = <Bollean>
		run_offIcon   -      runIcon  "
	
	| aLabel |
	bool
		ifFalse: [aLabel := #runIcon]
		ifTrue: [aLabel := #pauseIcon].
	(self cormas mainBuilder componentAt: #runButton) isNil
		ifFalse:
			[(self cormas mainBuilder componentAt: #runButton)
				label: (Cormas perform: aLabel)]! !

!SimManager methodsFor: 'replay-store/restore' stamp: ' 31/3/15 09:57'!
snapshotCurrentState
	"Snapshot the current simulation state as BOS file. Time is temporary set to 0, in order to use the BOS file as initial state of further simulations"
	
	| finename currentTime text |
	finename := Dialog
		requestNewFileName: 'Save current simulation state as'
		default:
			((Cormas dumpPath: self cormasModel class name)
				construct: (self stepFileNameAtStep: 0)).
	finename isEmpty ifTrue: [^nil].
	currentTime := self currentTime.
	self currentTime: 0.
	self cormasModel dumpOrganizationOnFile: finename asFilename.
	self currentTime: currentTime.
	text := ('	Dump at step ' , currentTime printString) asText.
	text := text , '\	The current simulation state has been saved as ' withCRs
		, (finename asText emphasizeAllWith: #italic).
	text := text
		,
			'\	To reuse it as starting point for the next simulations, write the following instruction into an #init method: \	'
				withCRs.
	text := text
		,
			(('self restoreOrganizationFromFile: ''' , finename , ''' asFilename')
				asText emphasizeAllWith: #bold).
	Dialog warn: text.
	Cormas println: text! !

!SimManager methodsFor: 'replay-backward' stamp: ' 31/3/15 09:57'!
stepBack
	"Replay a step backward using BOS file"
	
	self currentTime <= 0 ifTrue: [^false].
	^self restoreOrganizationAt: self currentTime - 1! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
stepFileNameAtStep: aTimeStep
	"return a string for the file, with its extension. 
	aTimeStep: <Integer>
	Example:   stepFileNameAtStep: 22 =>   'step_22.bos'   "
	
	^self stepNameStart , aTimeStep printString , self class bosExtension! !

!SimManager methodsFor: 'replay-private' stamp: ' 31/3/15 09:57'!
stepNameStart
	"Return the begining part of each stepFilename (=> 'step_' )  "
	"return a string for the file"
	
	^'step_'! !

!SimManager methodsFor: 'undo/redo' stamp: ' 31/3/15 09:57'!
storeBeforeManipulation
	"Store the whole state of the current model as BOS file into the appropriate simFolder . This is done before manipulation from the user, in order to enable the Undo.
The #storeBeforeManipulation is called when the manipulation tool is activated, for 
 - the moving of a figure (Figure isMovedTo: point)
 - the Manipulate Menu on a figure (SpaceController #processManipulateMenuAt:local:forSelectedFigures:localFigures:)
 - and for the Creation Tool (Tool initializeCreateEntityTool)"
	
	| filename |
	filename := self simFolder
		construct:
			self stepNameStart , self currentTime printString , '_'
				, (self undoList size + 1) printString , self class bosExtension.
	self undoList addLast: filename.
	self redoList isEmpty ifFalse: [redoList := nil].
	self cormasModel dumpOrganizationOnFile: filename! !

!SimManager methodsFor: 'replay-store/restore' stamp: ' 31/3/15 09:57'!
storeCurrentStep
	"store the current step into the appropriate Dump folder (store After the step execution)"
	
	| finename |
	finename := self simFolder
		construct: (self stepFileNameAtStep: self currentTime).
	finename exists
		ifTrue:
			[self simFolder: self class newFolder.
			^self storeCurrentStep].
	self cormasModel dumpOrganizationOnFile: finename.
	self traceSize < self currentTime ifTrue: [traceSize := self currentTime]! !

!SimManager methodsFor: 'init' stamp: ' 31/3/15 09:57'!
terminateAllProcesses
	"Terminate all the processes"
	
	processReplayForward isNil
		ifFalse:
			[processReplayForward terminate.
			processReplayForward := nil].
	processReplayBackward isNil
		ifFalse:
			[processReplayBackward terminate.
			processReplayBackward := nil].
	processRun isNil
		ifFalse:
			[processRun terminate.
			processRun := nil]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
traceSize
	
	^traceSize ifNil: [traceSize := 0]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
traceSize: anObject
	
	traceSize := anObject! !

!SimManager methodsFor: 'undo/redo' stamp: ' 31/3/15 09:57'!
undo
	"reload the last BOS File from the undoList"
	
	| filename |
	self undoList isEmpty ifTrue: [^Dialog warn: 'No available Undo'].
	filename := self undoList last.
	self redoList isEmpty
		ifTrue:
			[self storeBeforeManipulation.
			self redoList add: self undoList last.
			self undoList removeLast].
	self undoList removeLast.
	self redoList add: filename.
	(self cormasModel restoreOrganizationFromFile: filename)
		ifFalse: [undoList := nil]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
undoList
	
	^undoList ifNil: [undoList := OrderedCollection new]! !

!SimManager methodsFor: 'accessing' stamp: ' 31/3/15 09:57'!
undoList: anObject
	
	undoList := anObject! !

!SimManager methodsFor: 'simulate' stamp: ' 31/3/15 09:57'!
updateCormasInterface
	
	self cormas displaySimNumber value: self simNumero printString , '/1'! !

UIApplicationModel subclass: #SpaceInterfaceConfig
	instanceVariableNames: 'entitiesList observedEntitiesList manipEntitiesList createEntitiesList spaceInterface configName manipMethods manipMethodsList entitySelected entitiesToAddList methodsToAddList attributes attributesList povMethods povMethodsList infoMethods infoMethodsList probeMethods probeMethodsList defaultPov defaultInfo canBeMoved moveEntityCheckBox manipWholePop manipWholePopCheckBox canChangeValues canChangeValuesCheckBox delimiterSize trackLengthValue trackedAgents defaultTool isManipulateForTabletEnabled isUndoRedoEnabled isSingleDefaultPovShown isSingleDefaultInfoShown siMenuFormat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

SpaceInterfaceConfig class
	instanceVariableNames: 'winAddEntities_title winAddMethods_title'!

!SpaceInterfaceConfig commentStamp: 'SergeStinckwich 4/24/2015 12:12' prior: 0!
Autre définition que nous donne Bourdieu : "L'habitus, système de disposition acquises par l'apprentissage implicite ou explicite qui fonctionne comme un système de schemes générateurs, est générateur de stratégies qui peuvent être objectivement conformes aux intérêts objectifs de leurs auteurs sans en avoir été expressément conçues à cette fin. "

Pour simplifier, l'habitus est un ensemble de manière d'être, d'agir et de penser propre à un individu, fruit d'un apprentissage particulier lié à son groupe d'appartenance, qui diffère selon sa classe sociale, sa disposition en capital, et sa place occupée dans l'espace social. L'habitus structure les comportements et les actions de l'individu, et à la fois, il structure les positions dans l'espace social.
http://fr.wikipedia.org/wiki/Habitus_(sociologie)#L.27habitus_selon_Bourdieu
!

SpaceInterfaceConfig class
	instanceVariableNames: 'winAddEntities_title winAddMethods_title'!

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
apply
	
	^ToolbarIconLibrary visualFor: #modificationApply! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
attributesMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeAttribute)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
createEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #createEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeCreateEntity)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
displayOptionsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #displayOptionsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'Delimitors size' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: '0 pixel' 
			#nameKey: #pixel0 
			#value: #pixel0 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '1 pixel' 
			#nameKey: #pixel1 
			#value: #pixel1 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '2 pixels' 
			#nameKey: #pixel2 
			#value: #pixel2 
			#indication: true 
			#indicationSelector: #delimiterSize) #(MenuItem 
			#rawLabel: '3 pixels' 
			#nameKey: #pixel3 
			#value: #pixel3 
			#indication: true 
			#indicationSelector: #delimiterSize)) #(4) nil)) #(MenuItem 
		#rawLabel: 'Track agents' 
		#nameKey: #trackAgents 
		#indication: false) #(MenuItem 
		#rawLabel: 'Set track length' 
		#value: #setTrackLength) #(MenuItem 
		#rawLabel: 'Default interface tool' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: 'Inspect' 
			#nameKey: #toolInspect 
			#value: #toolInspect 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Manipulate' 
			#nameKey: #toolManipulate 
			#value: #toolManipulate 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Create' 
			#nameKey: #toolCreate 
			#value: #toolCreate 
			#indication: true 
			#indicationSelector: #defaultTool) #(MenuItem 
			#rawLabel: 'Zoom' 
			#nameKey: #toolZoom 
			#value: #toolZoom 
			#indication: true 
			#indicationSelector: #defaultTool)) #(4) nil) 
		#helpText: 'Default tool used when clicking entities in the space interface') #(MenuItem 
		#rawLabel: 'Enable touchpad mode' 
		#nameKey: #toggleTouchpadMode 
		#value: #toggleTouchpadMode 
		#indication: false) #(MenuItem 
		#rawLabel: 'Enable Undo/Redo' 
		#nameKey: #toggleUndoRedo 
		#value: #toggleUndoRedo 
		#indication: true) #(MenuItem 
		#rawLabel: 'Space interface menu bar' 
		#submenu: #(Menu #(#(MenuItem 
			#rawLabel: 'full menu' 
			#nameKey: #siMenuFull 
			#value: #siMenuFull_apply 
			#indication: true 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, track, Habitus' 
			#nameKey: #siMenuLimitedWithHabitus 
			#value: #siMenuLimitedWithHabitus_apply 
			#indication: false 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, track' 
			#nameKey: #siMenuLimited 
			#value: #siMenuLimited_apply 
			#indication: false 
			#indicationSelector: #siMenuFormat) #(MenuItem 
			#rawLabel: 'pov, info, Habitus' 
			#nameKey: #siMenuLimited2WithHabitus 
			#value: #siMenuLimited2WithHabitus_apply) #(MenuItem 
			#rawLabel: 'pov, info' 
			#nameKey: #siMenuLimited2 
			#value: #siMenuLimited2_apply) #(MenuItem 
			#rawLabel: 'none' 
			#nameKey: #siMenuNone 
			#value: #siMenuNone_apply)) #(6) nil)) #(MenuItem 
		#rawLabel: 'Show single default pov in menu' 
		#nameKey: #toggleShowSingleDefaultPov 
		#value: #toggleShowSingleDefaultPov 
		#indication: true) #(MenuItem 
		#rawLabel: 'Show single default info in menu' 
		#nameKey: #toggleShowSingleDefaultInfo 
		#value: #toggleShowSingleDefaultInfo 
		#indication: true)) #(9) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
infoMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #infoMethodsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeInfoMethod) #(MenuItem 
		#rawLabel: 'set as default' 
		#value: #setSelectionAsDefaultInfo) #(MenuItem 
		#rawLabel: 'no default info' 
		#value: #cancelDefaultInfo)) #(2 1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
load
	
	^ToolbarIconLibrary visualFor: #fileOpen! !

!SpaceInterfaceConfig class methodsFor: 'save-load' stamp: 'SergeStinckwich 5/29/2015 14:35'!
loadSIconfig: aConfigSpec in: aSIConfig ofModel: aModel
	
	| stream line aL data collec aClass configElement |
	aSIConfig manipMethods: Dictionary new.
	aSIConfig defaultPov: nil.
	aSIConfig defaultInfo: nil.
	stream := aConfigSpec readStream.
	[stream atEnd]
		whileFalse:
			[line := Cormas splitLine: stream sep: $*.
			configElement := (line first
				copyFrom: 1
				to: line first size - 1) asSymbol.
			configElement = #configName
				ifTrue: [aSIConfig configName value: line last].
			(#(#observedEntitiesList #manipEntitiesList #createEntitiesList)
				refersToLiteral: configElement)
				ifTrue:
					[aL := List new.
					(Cormas
						splitLine: line last readStream
						sep: $,)
						do:
							[:i | 
							aClass := (Cormas stringAsObjectType: i) class.
							aClass ifNotNil: [aL add: aClass]].
					(aSIConfig perform: configElement) setList: aL selecting: ''].
			(#(#manipMethods #povMethods #attributes #infoMethods #probeMethods)
				refersToLiteral: configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: (data collect: [:m | m asSymbol])]].
			(#(#canBeMoved #manipWholePop #canChangeValues) refersToLiteral:
					configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: (Cormas stringAsObjectType: data first)]].
			(#(#defaultPov #defaultInfo) refersToLiteral: configElement)
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aClass := (Cormas stringAsObjectType: data removeFirst) class.
					aClass
						ifNotNil:
							[(aSIConfig perform: configElement)
								at: aClass
								put: data first asSymbol]].
			configElement = #delimiterSize
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					data removeFirst.
					aSIConfig perform: data first asSymbol].
			configElement = #defaultTool
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aSIConfig perform: data first asSymbol].
			configElement = #siMenuFormat
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					aSIConfig perform: data first asSymbol].
			configElement = #isUndoRedoEnabled
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isUndoRedoEnabled: (Cormas stringAsObjectType: data)].
			configElement = #isManipulateForTabletEnabled
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig
						isManipulateForTabletEnabled: (Cormas stringAsObjectType: data)].
			configElement = #isSingleDefaultPovShown
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isSingleDefaultPovShown: (Cormas stringAsObjectType: data)].
			configElement = #isSingleDefaultInfoShown
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection first.
					aSIConfig isSingleDefaultInfoShown: (Cormas stringAsObjectType: data)].
			configElement = #trackLengthValue
				ifTrue:
					[data := (Cormas
						splitLine: line last readStream
						sep: $,) asOrderedCollection.
					data removeFirst.
					aSIConfig
						applyTrackLengthValue: (Cormas stringAsObjectType: data first)].
			configElement = #trackedAgents
				ifTrue:
					[collec := Set new.
					line size = 1
						ifFalse:
							[(Cormas
								splitLine: line last readStream
								sep: $,)
								do: [:i | collec add: (Cormas stringAsObjectType: i) asSymbol]].
					aSIConfig trackedAgents: collec]].
	stream close! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
manipEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeManipEntity)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
manipMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeManipMethod)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
minusIcon
	
	^OpaqueImage
		figure: self removeEntityIconImage
		shape: self removeEntityIconMask! !

!SpaceInterfaceConfig class methodsFor: 'instance creation' stamp: ' 31/3/15 10:00'!
newFor: aSI
	
	| x |
	x := super new.
	x spaceInterface: aSI.
	x prepareSettings.
	^x! !

!SpaceInterfaceConfig class methodsFor: 'instance creation' stamp: ' 31/3/15 10:00'!
newFor: aSI withConfig: aConfigName
	
	| x |
	x := super new.
	x spaceInterface: aSI.
	x prepareSettings.
	x configName value: aConfigName.
	x spaceInterface configName value: aConfigName.
	self
		loadSIconfig:
			(x spaceInterface cormasModelClass
				perform: ('SIconfig_' , aConfigName) asSymbol)
		in: x
		ofModel: aSI cormasModel.
	^x! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
observedEntityMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #observedEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeObservedEntity)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
plusIcon
	
	^SpaceInterface createEntityIcon! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
povMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #povMethodsMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removePovMethod) #(MenuItem 
		#rawLabel: 'set as default' 
		#value: #setSelectionAsDefaultPov) #(MenuItem 
		#rawLabel: 'no default pov' 
		#value: #cancelDefaultPov)) #(2 1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
probeMethodsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #manipEntityMenu"
	
	<resource: #menu>
	^#(Menu #(#(MenuItem 
		#rawLabel: 'remove' 
		#value: #removeProbeMethod)) #(1) nil) decodeAsLiteralArray! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
question
	
	^ToolbarIconLibrary visualFor: #unknownWidget! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
removeEntityIconImage
	"Tools.UIMaskEditor new openOnClass: self andSelector: #removeEntityIconMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 24 @ 14
				depth: 2
				bitsPerPixel: 2
				palette:
					(MappedPalette
						withColors:
							(#(#(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(0 0 0)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(8191 8191 8191)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(1541 1541 1541)) #(ColorValue 
								#scaledRed:scaledGreen:scaledBlue: #(513 513 513)))
								collect:
									[:each | 
									(each at: 1) value
										perform: (each at: 2)
										withArguments: (each at: 3)]))
				usingBits:
					#[85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 96 0 0 37 85 0 0 85 69 85 85 69 85 0 0 85 69 85 85 69 85 0 0 85 69 85 85 69 85 0 0 85 112 0 0 53 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0 85 85 85 85 85 85 0 0])! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
removeEntityIconMask
	"Tools.UIMaskEditor new openOnClass: self andSelector: #removeEntityIconMask"
	
	<resource: #image>
	^CachedImage
		on:
			(Image
				extent: 24 @ 14
				depth: 1
				bitsPerPixel: 1
				palette: CoveragePalette monoMaskPalette
				usingBits:
					#[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 7 255 192 0 7 255 192 0 7 255 192 0 7 255 192 0 7 255 192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0])! !

!SpaceInterfaceConfig class methodsFor: 'resources' stamp: ' 31/3/15 10:00'!
save
	
	^ToolbarIconLibrary visualFor: #fileSave! !

!SpaceInterfaceConfig class methodsFor: 'save-load' stamp: ' 31/3/15 10:00'!
saveSIconfig: aConfig intoClass: modedelClass name: aName
	
	| selector aString |
	aString := 'configName:*' , aName ,
			'
observedEntitiesList:*'.
	aConfig observedEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aString := aString ,
			'
manipEntitiesList:*'.
	aConfig manipEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aString := aString ,
			'
createEntitiesList:*'.
	aConfig createEntitiesList list
		do: [:e | aString := aString , e name printString , ','].
	aConfig manipMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
manipMethods:*' , aClass name asString.
			(aConfig manipMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig povMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
povMethods:*' , aClass name asString.
			(aConfig povMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig attributes keys
		do:
			[:aClass | 
			aString := aString ,
					'
attributes:*' , aClass name asString.
			(aConfig attributes at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig infoMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
infoMethods:*' , aClass name asString.
			(aConfig infoMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig probeMethods keys
		do:
			[:aClass | 
			aString := aString ,
					'
probeMethods:*' , aClass name asString.
			(aConfig probeMethods at: aClass)
				do: [:aM | aString := aString , ',' , aM asString]].
	aConfig canBeMoved keys
		do:
			[:aClass | 
			(aConfig canBeMovedFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
canBeMoved:*' , aClass name asString , ','
						, (aConfig canBeMovedFor: aClass) asString]].
	aConfig manipWholePop keys
		do:
			[:aClass | 
			(aConfig manipWholePopFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
manipWholePop:*' , aClass name asString , ','
						, (aConfig manipWholePopFor: aClass) asString]].
	aConfig canChangeValues keys
		do:
			[:aClass | 
			(aConfig canChangeValuesFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
canChangeValues:*' , aClass name asString , ','
						, (aConfig canChangeValuesFor: aClass) asString]].
	aConfig defaultPov keys
		do:
			[:aClass | 
			(aConfig defaultPovFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
defaultPov:*' , aClass name asString , ','
						, (aConfig defaultPovFor: aClass) asString]].
	aConfig defaultInfo keys
		do:
			[:aClass | 
			(aConfig defaultInfoFor: aClass)
				ifNotNil:
					[aString := aString ,
							'
defaultInfo:*' , aClass name asString , ','
						, (aConfig defaultInfoFor: aClass) asString]].
	aString := aString ,
			'
delimiterSize:*' , 'ESE,' , aConfig delimiterSize value asString ,
			'
defaultTool:*' , aConfig defaultTool value asString ,
			'
siMenuFormat:*' , aConfig siMenuFormat value asString ,
			'
isUndoRedoEnabled:*' , aConfig isUndoRedoEnabled asString ,
			'
isManipulateForTabletEnabled:*'
		, aConfig isManipulateForTabletEnabled asString ,
			'
isSingleDefaultPovShown:*' , aConfig isSingleDefaultPovShown asString ,
			'
isSingleDefaultInfoShown:*' , aConfig isSingleDefaultInfoShown asString ,
			'
trackLengthValue:*' , 'All,' , aConfig trackLengthValue asString ,
			'
trackedAgents:*'.
	aConfig trackedAgents do: [:e | aString := aString , e asString , ','].
	selector := 'SIconfig_' , aName.
	modedelClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of the Spatial Interface configuration named '
				, aName , '"\^''' , aString , '''\') withCRs
		classified: 'SI_config'
		notifying: nil! !

!SpaceInterfaceConfig class methodsFor: 'interface specs' stamp: ' 31/3/15 10:00'!
winAddEntities
	"Tools.UIPainter new openOnClass: self andSelector: #winAddEntities"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #labelFromApplication true) 
			#label: #winAddEntities_title 
			#min: #(Point 224 166) 
			#max: #(Point 350 500) 
			#bounds: #(Rectangle 720 450 944 703) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(SequenceViewSpec 
				#layout: #(Rectangle 9 33 218 209) 
				#model: #entitiesToAddList 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#layout: #(Rectangle 36 218 96 244) 
				#model: #accept 
				#label: #(UserMessage 
					#key: #ok 
					#defaultString: 'Ok') 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 42 8) 
				#label: #(UserMessage 
					#key: #attributesToBeSaved 
					#defaultString: 'Select entities to add')) #(ActionButtonSpec 
				#layout: #(Rectangle 112 218 172 244) 
				#model: #cancel 
				#label: #(UserMessage 
					#key: #cancel 
					#defaultString: 'Cancel') 
				#defaultable: true))))! !

!SpaceInterfaceConfig class methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
winAddEntities_title
	
	^winAddEntities_title ifNil: [winAddEntities_title := 'Entities']! !

!SpaceInterfaceConfig class methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
winAddEntities_title: anObject
	
	winAddEntities_title := anObject! !

!SpaceInterfaceConfig class methodsFor: 'interface specs' stamp: ' 31/3/15 10:00'!
winAddMethods
	"Tools.UIPainter new openOnClass: self andSelector: #winAddMethods"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#properties: #(PropertyListDictionary #labelFromApplication true) 
			#label: #winAddMethods_title 
			#min: #(Point 224 166) 
			#max: #(Point 350 500) 
			#bounds: #(Rectangle 720 450 944 703) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(SequenceViewSpec 
				#layout: #(Rectangle 9 33 218 209) 
				#model: #methodsToAddList 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#layout: #(Rectangle 36 218 96 244) 
				#model: #accept 
				#label: #(UserMessage 
					#key: #ok 
					#defaultString: 'Ok') 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 3 9) 
				#label: #(UserMessage 
					#key: #attributesToBeSaved 
					#defaultString: 'Select available methods for')) #(ActionButtonSpec 
				#layout: #(Rectangle 112 218 172 244) 
				#model: #cancel 
				#label: #(UserMessage 
					#key: #cancel 
					#defaultString: 'Cancel') 
				#defaultable: true) #(InputFieldSpec 
				#layout: #(Rectangle 135 8 220 31) 
				#name: #InputField1 
				#flags: 0 
				#model: #entitySelected 
				#tabable: false 
				#isReadOnly: true))))! !

!SpaceInterfaceConfig class methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
winAddMethods_title
	
	^winAddMethods_title ifNil: [winAddMethods_title := 'Methods']! !

!SpaceInterfaceConfig class methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
winAddMethods_title: anObject
	
	winAddMethods_title := anObject! !

!SpaceInterfaceConfig class methodsFor: 'interface specs' stamp: ' 31/3/15 10:00'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Configure Habitus for view: ' 
			#min: #(Point 502 464) 
			#max: #(Point 502 464) 
			#bounds: #(Rectangle 800 406 1302 870) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 7757 7757 7757))) 
		#component: #(SpecCollection 
			#collection: #(#(TextEditorSpec 
				#layout: #(Rectangle 388 0 475 22) 
				#name: #TextEditor1 
				#flags: 4 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#tabable: false 
				#menu: #displayOptionsMenu 
				#tabRequiresControl: false 
				#isWrapped: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 6 0 30 23) 
				#name: #ActionButton4 
				#flags: 0 
				#model: #loadConfig 
				#helpText: 'Load existing configuration' 
				#label: #load 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(DividerSpec 
				#layout: #(Rectangle 35 0 39 23) 
				#name: #Divider1 
				#orientation: #vertical) #(DividerSpec 
				#layout: #(LayoutFrame 0 0 23 0 0 1.0 27 0) 
				#name: #Divider2) #(LabelSpec 
				#layout: #(LayoutFrame 44 0 2 0 116 0 24 0) 
				#name: #Label3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #blue)) 
				#label: 'Habitus name') #(InputFieldSpec 
				#layout: #(LayoutFrame 118 0 1 0 218 0 22 0) 
				#name: #InputField1 
				#model: #configName 
				#helpText: 'Name it ''default'', to have this configuration loaded when a space window is open for the first time') #(LabelSpec 
				#layout: #(Rectangle 12 26 157 47) 
				#name: #Label5 
				#label: 'Entities that can be observed') #(LabelSpec 
				#layout: #(Rectangle 10 247 168 268) 
				#name: #Label4 
				#label: 'Entities that can be manipulated') #(SequenceViewSpec 
				#layout: #(Rectangle 10 269 165 434) 
				#name: #List6 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #manipEntitiesList 
				#tabable: false 
				#menu: #manipEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(LabelSpec 
				#layout: #(Rectangle 340 247 477 268) 
				#name: #Label1 
				#label: 'Entities that can be created') #(SequenceViewSpec 
				#layout: #(Rectangle 339 269 494 434) 
				#name: #List1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7044 7044 7044)) 
				#model: #createEntitiesList 
				#tabable: false 
				#menu: #createEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 34 437 59 460) 
				#name: #addManip 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #addManipEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 61 437 86 460) 
				#name: #removeManip 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #removeManipEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 367 437 392 460) 
				#name: #ActionButton2 
				#model: #addCreateEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 394 437 419 460) 
				#name: #ActionButton3 
				#model: #removeCreateEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 48 165 214) 
				#name: #List5 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7167 7167 8191)) 
				#model: #observedEntitiesList 
				#tabable: false 
				#menu: #observedEntityMenu 
				#multipleSelections: false 
				#selectionType: #highlight 
				#autoSelect: false) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 33 217 58 240) 
				#name: #ActionButton5 
				#model: #addObservedEntities 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 60 217 85 240) 
				#name: #ActionButton6 
				#model: #removeObservedEntity 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 170 320 333 434) 
				#name: #List2 
				#model: #manipMethodsList 
				#menu: #manipMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(CheckBoxSpec 
				#layout: #(Point 179 272) 
				#name: #moveEntityCheckBox 
				#model: #moveEntityCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setMoveEntity 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can be moved?') #(LabelSpec 
				#layout: #(Point 173 302) 
				#name: #Label2 
				#label: 'authorized methods') #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 212 439 231 458) 
				#name: #ActionButton7 
				#model: #addManipMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 233 439 251 458) 
				#name: #ActionButton8 
				#model: #removeManipMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 171 30) 
				#name: #Label6 
				#label: 'authorized pov') #(LabelSpec 
				#layout: #(Point 171 130) 
				#name: #Label7 
				#label: 'authorized attributes') #(SequenceViewSpec 
				#layout: #(Rectangle 170 47 324 112) 
				#name: #List3 
				#model: #povMethodsList 
				#menu: #povMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(SequenceViewSpec 
				#layout: #(Rectangle 170 147 324 214) 
				#name: #List4 
				#model: #attributesList 
				#menu: #attributesMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 225 216 243 235) 
				#name: #ActionButton9 
				#model: #removeAttribute 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 204 216 223 235) 
				#name: #ActionButton10 
				#model: #addAttribute 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 225 114 243 133) 
				#name: #ActionButton11 
				#model: #removePovMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 204 114 223 133) 
				#name: #ActionButton12 
				#model: #addPovMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 330 30) 
				#name: #Label8 
				#label: 'authorized info') #(LabelSpec 
				#layout: #(Point 330 130) 
				#name: #Label9 
				#label: 'authorized probes') #(SequenceViewSpec 
				#layout: #(Rectangle 329 47 483 112) 
				#name: #List7 
				#model: #infoMethodsList 
				#menu: #infoMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(SequenceViewSpec 
				#layout: #(Rectangle 329 147 483 214) 
				#name: #List8 
				#model: #probeMethodsList 
				#menu: #probeMethodsMenu 
				#multipleSelections: true 
				#useModifierKeys: true 
				#selectionType: #highlight) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 384 216 402 235) 
				#name: #ActionButton13 
				#model: #removeProbeMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 363 216 382 235) 
				#name: #ActionButton14 
				#model: #addProbeMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 384 114 402 133) 
				#name: #ActionButton15 
				#model: #removeInfoMethod 
				#label: #minusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 363 114 382 133) 
				#name: #ActionButton16 
				#model: #addInfoMethods 
				#label: #plusIcon 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 223 0 247 23) 
				#name: #ActionButton17 
				#flags: 0 
				#model: #saveConfig 
				#helpText: 'Save the Habitus with a specific name to reuse later' 
				#label: #save 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 258 0 282 23) 
				#name: #ActionButton1 
				#flags: 0 
				#model: #applyCurrentSettings 
				#helpText: 'Apply current Habitus settings to the associated space interface' 
				#label: #apply 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(DividerSpec 
				#layout: #(Rectangle 251 0 255 23) 
				#name: #Divider3 
				#orientation: #vertical) #(ActionButtonSpec 
				#properties: #(PropertyListDictionary #labelFromApplication true) 
				#layout: #(Rectangle 478 0 502 23) 
				#name: #ActionButton18 
				#flags: 0 
				#model: #explainHabitus 
				#helpText: 'What is Habitus' 
				#label: #question 
				#hasCharacterOrientedLabel: false 
				#defaultable: true) #(CheckBoxSpec 
				#layout: #(Point 179 258) 
				#name: #manipWholePopCheckBox 
				#model: #manipWholePopCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setManipWholePop 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can manipulate whole pop?') #(CheckBoxSpec 
				#layout: #(Point 179 286) 
				#name: #canChangeValuesCheckBox 
				#model: #canChangeValuesCheckBox 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#valueChangeSelector: #setChangeValues 
					#requestFocusInSelector: #manipChekboxValidation) 
				#label: 'can change values?') #(LabelSpec 
				#layout: #(Point 395 0) 
				#name: #Label11 
				#label: 'Display options'))))! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: 'SergeStinckwich 5/31/2015 15:53'!
addAttribute
	
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil:
			[self cormas warn: 'An entity must be selected'.
			^nil].
	self entitySelected value: anEntity name asString.
	aList := ((OrderedCollection
		withAll: (DefaultAttributesSetter attributsFromClass: anEntity))
		- (self attributesFor: anEntity)) asList.
	aList isEmpty
		ifTrue:
			[^self cormas warn: 'No more attributes can be added to this list'].
	methodsToAddList := MultiSelectionInList with: aList sorted.
	self class winAddMethods_title: 'Attributes'.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self attributesList list copy.
	aList addAll: (methodsToAddList selections collect: [:s | s asString]).
	aList sort: [:x :y | x < y].
	self attributesList
		setList: aList
		selecting: Array new.
	self attributes
		at: self observedEntitiesList selection
		put: self attributesList list! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
addCreateEntities
	
	self addEntitiesListName: #createEntitiesList! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
addEntitiesListName: aListName
	
	| aList |
	aList := self entitiesList copy.
	aList removeAll: (self perform: aListName) list.
	aList isEmpty
		ifTrue: [^self cormas warn: 'No more entities can be added to this list'].
	entitiesToAddList := MultiSelectionInList with: aList.
	aListName = #createEntitiesList
		ifTrue: [self class winAddEntities_title: 'Entities to be Created'].
	aListName = #manipEntitiesList
		ifTrue: [self class winAddEntities_title: 'Manipulation Entities'].
	aListName = #observedEntitiesList
		ifTrue: [self class winAddEntities_title: 'Observed Entities'].
	(self openDialogInterface: #winAddEntities) ifFalse: [^nil].
	(self perform: aListName) list addAll: entitiesToAddList selections.
	(self perform: aListName) list sort: [:x :y | x name < y name].
	(self perform: aListName) selection: entitiesToAddList selections first.
	aListName = #manipEntitiesList
		ifTrue:
			[entitiesToAddList selections
				do:
					[:aClass | 
					self canBeMoved at: aClass put: true.
					self manipWholePop at: aClass put: true.
					self canChangeValues at: aClass put: true]]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
addInfoMethods
	
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil:
			[self cormas warn: 'An entity must be selected'.
			^nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity availableInfo asList.
	(aList includes: #nil) ifTrue: [aList remove: #nil].
	aList removeAll: self infoMethodsList_WithoutDefaultSign list.
	aList isEmpty
		ifTrue: [^self cormas warn: 'No more info can be added to this list'].
	methodsToAddList := MultiSelectionInList with: aList.
	self class winAddMethods_title: 'Info Methods'.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self infoMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [:x :y | x < y].
	self infoMethodsList
		setList: aList
		selecting: Array new.
	self infoMethods
		at: self observedEntitiesList selection
		put: self infoMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuInfo! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
addManipEntities
	
	self addEntitiesListName: #manipEntitiesList.
	self displayMethodsAndOptionsForManipEntity! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 12:34'!
addManipMethods
	
	| anEntity aList |
	(anEntity := self manipEntitiesList selection) 
		ifNil: [
			self alertMessage: self translator tSelectEntity.
			^ nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity methodsForControl asOrderedCollection.
	aList removeAll: self manipMethodsList list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMoreMethods ].
	methodsToAddList := self multiSelectionList with: aList.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self manipMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [:x :y | x < y].
	self manipMethodsList
		setList: aList
		selecting: Array new.
	self manipMethods
		at: self manipEntitiesList selection
		put: self manipMethodsList list! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 12:34'!
addObservedEntities
	
	| old new test |
	old := self observedEntitiesList list copy.
	self addEntitiesListName: #observedEntitiesList.
	new := self observedEntitiesList list.
	test := false.
	old size = new size
		ifTrue: [ 
			1
				to: old size
				do: [:i | (old at: i) ~= (new at: i) ifTrue: [test := true]]]
		ifFalse: [test := true].
	test
		ifTrue:
			[(self spaceInterface)
				initMenuPov;
				initMenuInfo;
				initMenuTrack]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: 'HernanMoralesDurand 12/16/2017 12:37'!
addPovMethods
	
	| anEntity aList |
	(anEntity := self observedEntitiesList selection) 
		ifNil: [ 
			self alertMessage: self translator tSelectEntity.
			^ nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity availablePov asOrderedCollection.
	(aList includes: #nil) ifTrue: [aList remove: #nil].
	aList removeAll: self povMethodsList_WithoutDefaultSign list.
	aList isEmpty
		ifTrue: [ ^ self alertMessage: self translator tNoMorPoV ].
	methodsToAddList := self multiSelectionList with: aList.
	self class winAddMethods_title: self translator tPoVMethods.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self povMethodsList list copy.
	aList addAll: methodsToAddList selections.
	aList sort: [:x :y | x < y].
	self povMethodsList
		setList: aList
		selecting: Array new.
	self povMethods
		at: self observedEntitiesList selection
		put: self povMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuPov! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
addProbeMethods
	
	| anEntity aList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil:
			[self cormas warn: 'An entity must be selected'.
			^nil].
	self entitySelected value: anEntity name asString.
	aList := anEntity probes asList.
	aList removeAll: self probeMethodsList list.
	aList isEmpty
		ifTrue: [^self cormas warn: 'No more probe can be added to this list'].
	methodsToAddList := MultiSelectionInList with: aList.
	self class winAddMethods_title: 'Probe Methods'.
	(self openDialogInterface: #winAddMethods) ifFalse: [^nil].
	aList := self probeMethodsList list copy.
	aList addAll: methodsToAddList selections.
	self probeMethodsList
		setList: aList
		selecting: Array new.
	self probeMethods
		at: self observedEntitiesList selection
		put: self probeMethodsList list! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
applyCurrentSettings
	
	self spaceInterface initMenuPov.
	self spaceInterface initMenuInfo.
	self applyDefaultPovs.
	self applyDefaultInfos.
	self perform: self delimiterSize value! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'SergeStinckwich 5/29/2015 14:31'!
applyDefaultInfos
	
	| cellClass CSCs occupantClassses dicoInfo |
	(self spaceInterface infoMethodDico select: [:v | v ~= #nil])
		keysDo:
			[:aClass | 
			self spaceInterface
				changeInfo: #nil
				ofEntity: aClass class].
	dicoInfo := self defaultInfo copy select: [:v | v isNil not].
	cellClass := self spaceInterface cormasModelClass cellClass.
	CSCs := self spaceInterface cormasModelClass compoundSpatialClasses.
	occupantClassses := self spaceInterface cormasModelClass occupantClasses.
	(self defaultInfoFor: cellClass) isNil not
		ifTrue:
			[self spaceInterface
				changeInfo: ((self defaultInfoFor: cellClass) ifNil: [#nil])
				ofEntity: cellClass.	"ifNotNil:[]"
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					((CSCs includes: aClass) and: [defInfo = #delimitors])
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]].
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]]]
		ifFalse:
			[dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					((CSCs includes: aClass) and: [defInfo isNil not])
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]].
			dicoInfo
				keysAndValuesDo:
					[:aClass :defInfo | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changeInfo: defInfo ofEntity: aClass]]]! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: 'SergeStinckwich 5/29/2015 14:31'!
applyDefaultPovs
	
	| dicoPov cellClass CSCs occupantClassses |
	(self spaceInterface povMethodDico select: [:v | v ~= #nil])
		keysDo:
			[:aClass | 
			self spaceInterface
				changePov: #nil
				ofEntity: aClass class].
	dicoPov := self defaultPov copy select: [:v | v isNil not].
	cellClass := self spaceInterface cormasModelClass cellClass.
	CSCs := self spaceInterface cormasModelClass compoundSpatialClasses.
	occupantClassses := self spaceInterface cormasModelClass occupantClasses.
	(self defaultPovFor: cellClass) isNil not
		ifTrue:
			[self spaceInterface
				changePov: ((self defaultPovFor: cellClass) ifNil: [#nil])
				ofEntity: cellClass.
			dicoPov
				keysAndValuesDo:
					[:aClass :defPov | 
					((CSCs includes: aClass) and: [defPov = #delimitors])
						ifTrue: [self spaceInterface changePov: defPov ofEntity: aClass]].
			dicoPov
				keysAndValuesDo:
					[:aClass :defPov | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changePov: defPov ofEntity: aClass]]]
		ifFalse:
			[dicoPov
				keysAndValuesDo:
					[:aClass :defPov | 
					((CSCs includes: aClass)
						and: [defPov isNil not and: [defPov ~= #delimitors]])
						ifTrue: [self spaceInterface changePov: defPov ofEntity: aClass]].
			dicoPov
				keysAndValuesDo:
					[:aClass :defPov | 
					((CSCs includes: aClass) and: [defPov = #delimitors])
						ifTrue: [self spaceInterface changePov: defPov ofEntity: aClass]].
			dicoPov
				keysAndValuesDo:
					[:aClass :defPov | 
					(occupantClassses includes: aClass)
						ifTrue: [self spaceInterface changePov: defPov ofEntity: aClass]]]! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'SergeStinckwich 5/29/2015 14:31'!
applyTrackLengthValue: value
	
	| aClass |
	value = 'nil' ifTrue: [^nil].
	TrackFigure maxSize: value.
	self spaceInterface trackedFigureTypes
		do:
			[:symbol | 
			aClass := symbol class.
			(self spaceInterface drawing entityFiguresAt: aClass)
				do:
					[:fig | 
					(fig dependents select: [:tf | tf isKindOf: TrackFigure])
						do:
							[:track | 
							track testAndRemoveOrigine.
							track invalidate]]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
attributes
	
	^attributes ifNil: [attributes := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
attributes: anObject
	
	attributes := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
attributesFor: aClass
	
	(self attributes keys includes: aClass)
		ifFalse:
			[self attributes
				at: aClass
				put: (DefaultAttributesSetter attributsFromClass: aClass) sorted].
	^self attributes at: aClass! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
attributesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^attributesList isNil
		ifTrue: [attributesList := MultiSelectionInList new]
		ifFalse: [attributesList]! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
buildManipulationMenu: aMenuBuilder forEntity: aClass
	" Add to the menu the set of methods defined into 'methodsForManipulation' method. 
	The key will appear as the menu item. The selected method will be executed by the agent if the item is selected."
	
	(self manipMethodsFor: aClass)
		do: [:aSymbol | aMenuBuilder add: aSymbol asString -> aSymbol].
	^aMenuBuilder! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
canBeMoved
	
	^canBeMoved ifNil: [canBeMoved := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
canBeMoved: anObject
	
	canBeMoved := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
canBeMovedFor: aClass
	
	(self canBeMoved keys includes: aClass)
		ifFalse:
			[self canBeMoved
				at: aClass
				put: aClass isSituatedClass].
	^self canBeMoved at: aClass! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
canChangeValues
	
	^canChangeValues ifNil: [canChangeValues := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
canChangeValues: anObject
	
	canChangeValues := anObject! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
canChangeValuesCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^canChangeValuesCheckBox isNil
		ifTrue: [canChangeValuesCheckBox := false asValue]
		ifFalse: [canChangeValuesCheckBox]! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
canChangeValuesFor: aClass
	
	(self canChangeValues keys includes: aClass)
		ifFalse: [self canChangeValues at: aClass put: true].
	^self canChangeValues at: aClass! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
cancelDefaultInfo
	
	self infoMethodsList
		setList: self infoMethodsList_WithoutDefaultSign copy
		selecting: Array new.
	self defaultInfo
		at: self observedEntitiesList selection
		put: nil.
	self displayMethodsForObservedEntity! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
cancelDefaultPov
	
	self povMethodsList
		setList: self povMethodsList_WithoutDefaultSign copy
		selecting: Array new.
	self defaultPov
		at: self observedEntitiesList selection
		put: nil.
	self displayMethodsForObservedEntity! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: ' 31/3/15 10:00'!
checkClassAndMethodsExist
	
	self checkHabitusList: #observedEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'observed entities'.
	self checkHabitusList: #manipEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'manipulated entities'.
	self checkHabitusList: #createEntitiesList existsIn: #entitiesList
		dialogConfirmTypeName: 'created entities'.
	self checkMethods: #povMethods exists_dialogConfirmTypeName: 'pov methods'.
	self checkMethods: #manipMethods exists_dialogConfirmTypeName:
			'manip methods'.
	self checkMethods: #attributes exists_dialogConfirmTypeName: 'attributes'.
	self checkMethods: #infoMethods exists_dialogConfirmTypeName:
			'info methods'.
	self checkMethods: #probeMethods exists_dialogConfirmTypeName: 'probes'.
	self checkDefaultValue: #defaultPov exists_dialogConfirmTypeName:
			'default pov'.
	self checkDefaultValue: #defaultInfo exists_dialogConfirmTypeName:
			'default info'! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 12:40'!
checkDefaultValue: methodsList exists_dialogConfirmTypeName: defaultListName
	| defValue |
	(self perform: methodsList) keys
		do: [ :aClass | 
			defValue := (self perform: methodsList) at: aClass.
			defValue
				ifNil: [ (self perform: methodsList) removeKey: aClass ]
				ifNotNil: [ (aClass allInstanceSelectors includes: defValue)
						ifFalse: [ (self
								confirm: (self confirmRemove: defValue list: aClass class: defaultListName))
								ifTrue: [ (self perform: methodsList) remove: aClass ] ] ] ]! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: ' 31/3/15 10:00'!
checkHabitusList: aHabitusMethodList existsIn: modelList dialogConfirmTypeName: typeName
	
	| undefined |
	undefined := Set new.
	(self perform: aHabitusMethodList) list
		do:
			[:e | ((self perform: modelList) includes: e) ifFalse: [undefined add: e]].
	undefined isEmpty
		ifFalse:
			[(Dialog
				confirm:
					'The ' , typeName , ' ' , undefined printString ,
							' defined in the Habitus do not exist in the model.
Do you want to remove them (recommended)?

If you accept, even if the obsolete ' , typeName ,
							' are removed, you need to reopen the Habitus interface to see the changes appear')
				ifTrue: [(self perform: aHabitusMethodList) removeAll: undefined]]! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: ' 31/3/15 10:00'!
checkMethods: methodsList exists_dialogConfirmTypeName: methodsName
	
	| undefined |
	methodsList = #defaultPov ifTrue: [self halt].
	(self perform: methodsList) keys
		do:
			[:aClass | 
			undefined := Set new.
			((self perform: methodsList) at: aClass)
				do:
					[:aM | 
					(aClass allInstanceSelectors includes: aM asSymbol)
						ifFalse: [undefined add: aM]].
			undefined isEmpty
				ifFalse:
					[(Dialog
						confirm:
							'The ' , methodsName , ' ' , undefined printString , ' of class '
								, aClass name ,
									' defined in the Habitus do not exist in the model.
Do you want to remove them (recommended)?

If you accept, even if the obsolete ' , methodsName ,
									' are removed, you need to re-display the ' , methodsName ,
									' list, to see the changes appear')
						ifTrue:
							[((self perform: methodsList) at: aClass) removeAll: undefined]]]! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
classesForDelimitorMenuInheritingFrom: aClass
	
	^self observedEntitiesList list select: [:c | c inheritsFrom: aClass]! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
classesForInfoMenuInheritingFrom: aClass
	
	| list infolist |
	list := OrderedCollection new.
	(self observedEntitiesList list select: [:c | c inheritsFrom: aClass])
		do:
			[:c | 
			infolist := self infoMethodsFor: c.
			infolist isEmpty
				ifFalse:
					[(self isSingleDefaultInfoShown not
						and:
							[infolist size = 1 and: [(infolist at: 1) = (self defaultInfoFor: c)]])
						ifFalse: [list add: c]]].
	^list! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
classesForPovMenuInheritingFrom: aClass
	
	| list povlist |
	list := OrderedCollection new.
	(self observedEntitiesList list select: [:c | c inheritsFrom: aClass])
		do:
			[:c | 
			povlist := self povMethodsFor: c.
			povlist isEmpty
				ifFalse:
					[(self isSingleDefaultPovShown not
						and:
							[povlist size = 1 and: [(povlist at: 1) = (self defaultPovFor: c)]])
						ifFalse: [list add: c]]].
	^list! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
classesForTrackMenuInheritingFrom: aClass
	
	^self observedEntitiesList list select: [:c | c inheritsFrom: aClass]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
configName
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^configName isNil
		ifTrue: [configName := String new asValue]
		ifFalse: [configName]! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: 'HernanMoralesDurand 12/16/2017 12:40'!
confirmRemove: defValue list: aClass class: defaultListName
	^ 'The ' , defaultListName , ' ' , defValue , ' of class '
		, aClass name
		,
			' defined in the Habitus does not exist in the model.
Do you want to remove it (recommended)?

If you accept, even if the obsolete ' , defaultListName
		, ' is removed, you need to re-display the ' , defaultListName
		, ' list, to see the changes appear'! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
cormas
	
	^Cormas current! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
createEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^createEntitiesList isNil
		ifTrue: [createEntitiesList := SelectionInList new]
		ifFalse: [createEntitiesList]! !

!SpaceInterfaceConfig methodsFor: 'debuging' stamp: ' 31/3/15 10:00'!
debugPovNameDefault
	
	self povMethods values
		do:
			[:c | c do: [:v | ('* ->D' match: v ignoreCase: false) ifTrue: [self halt]]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
defaultInfo
	
	^defaultInfo ifNil: [defaultInfo := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
defaultInfo: anObject
	
	defaultInfo := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
defaultInfoFor: aClass
	
	(self defaultInfo keys includes: aClass)
		ifFalse: [self defaultInfo at: aClass put: nil].
	^self defaultInfo at: aClass! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
defaultPov
	
	^defaultPov ifNil: [defaultPov := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
defaultPov: anObject
	
	defaultPov := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
defaultPovFor: aClass
	
	(self defaultPov keys includes: aClass)
		ifFalse: [self defaultPov at: aClass put: nil].
	^self defaultPov at: aClass! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
defaultTool
	
	^defaultTool isNil
		ifTrue: [defaultTool := #toolInspect asValue]
		ifFalse: [defaultTool]! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
delimiterSize
	
	^delimiterSize isNil
		ifTrue:
			[delimiterSize := self spaceInterface
				ifNotNil: [:si | si delimiterSize]
				ifNil: [#pixel1 asValue]]
		ifFalse: [delimiterSize]! !

!SpaceInterfaceConfig methodsFor: 'refresh display methods' stamp: ' 31/3/15 10:00'!
displayMethodsAndOptionsForManipEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity
		ifNil:
			[self moveEntityCheckBox value: false.
			self manipWholePopCheckBox value: false.
			self canChangeValuesCheckBox value: false.
			^self manipMethodsList
				setList: List new
				selecting: Array new].
	self manipMethodsList
		setList: (self manipMethodsFor: anEntity)
		selecting: Array new.
	anEntity isSituatedClass
		ifTrue:
			[(self builder namedComponents at: #moveEntityCheckBox)
				enable;
				isVisible: true.
			self moveEntityCheckBox value: (self canBeMovedFor: anEntity)]
		ifFalse:
			[(self builder namedComponents at: #moveEntityCheckBox)
				disable;
				isVisible: false].
	self manipWholePopCheckBox value: (self manipWholePopFor: anEntity).
	self canChangeValuesCheckBox value: (self canChangeValuesFor: anEntity)! !

!SpaceInterfaceConfig methodsFor: 'refresh display methods' stamp: ' 31/3/15 10:00'!
displayMethodsForObservedEntity
	
	| anEntity aPovList aInfoList |
	anEntity := self observedEntitiesList selection.
	anEntity
		ifNil:
			[self povMethodsList
				setList: List new
				selecting: Array new.
			self attributesList
				setList: List new
				selecting: Array new.
			self infoMethodsList
				setList: List new
				selecting: Array new.
			^self probeMethodsList
				setList: List new
				selecting: Array new].	"Prepare list for pov methods which will  include a specific sign for the default pov"
	aPovList := (self povMethodsFor: anEntity) copy.
	(self defaultPovFor: anEntity)
		ifNotNil:
			[aPovList remove: (self defaultPovFor: anEntity).
			aPovList add: (self defaultPov at: anEntity) , ' ->D'.
			aPovList sort: [:x :y | x < y]].	"Prepare list for info  methods which will  include a specific sign for the default info"
	aInfoList := (self infoMethodsFor: anEntity) copy.
	(self defaultInfoFor: anEntity)
		ifNotNil:
			[aInfoList remove: (self defaultInfoFor: anEntity).
			aInfoList add: (self defaultInfo at: anEntity) , ' ->D'.
			aInfoList sort: [:x :y | x < y]].
	self povMethodsList
		setList: aPovList
		selecting: Array new.
	self attributesList
		setList: (self attributesFor: anEntity)
		selecting: Array new.
	self infoMethodsList
		setList: aInfoList
		selecting: Array new.
	self probeMethodsList
		setList: (self probeMethodsFor: anEntity)
		selecting: Array new! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
displayOptionsValidation
	
	^true! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
entitiesList
	
	^entitiesList! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
entitiesList: anObject
	
	entitiesList := anObject! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
entitiesToAddList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entitiesToAddList isNil
		ifTrue: [entitiesToAddList := MultiSelectionInList new]
		ifFalse: [entitiesToAddList]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
entitySelected
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^entitySelected isNil
		ifTrue: [entitySelected := String new asValue]
		ifFalse: [entitySelected]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
explainHabitus
	
	| text |
	text := 'L''habitus est un syst√®me de disposition acquises par l''apprentissage implicite ou explicite qui fonctionne comme un syst√®me de sch√®mes g√©n√©rateurs. L''habitus est g√©n√©rateur de strat√©gies qui peuvent √™tre objectivement conformes aux int√©r√™ts objectifs de leurs auteurs sans en avoir √©t√© express√©ment con√ßues √† cette fin. (Bourdieu 1972)
Autre d√©finition : L''habitus est un ensemble de mani√®re d''√™tre, d''agir et de penser propre √† un individu, fruit d''un apprentissage particulier li√© √† son groupe d''appartenance, qui diff√®re selon sa classe sociale, sa disposition en capital, et sa place occup√©e dans l''espace social. L''habitus structure les comportements et les actions de l''individu, et √† la fois, structure les positions dans l''espace social.'
		asValue.
	ComposedTextView
		open: text
		label: 'Habitus from Bourdieu'
		icon: (Icon constantNamed: #workspace)
		extent: 500 @ 260! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
forceSItoApplyConfigTrackAgents
	
	(entitiesList
		sorted: [:a :b | a name asString first > b name asString first])
		do:
			[:agentClass | 
			(agentClass isSituatedClass and: [agentClass inheritsFrom: Agent])
				ifTrue: [self forceSItrackAgents: agentClass]]! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
forceSItrackAgents: aClass
	
	| menuSI agentFigures |
	menuSI := (self spaceInterface menuHolder value atNameKey: #trackAgents)
		submenu
		menuItemLabeled: aClass name asString
		ifNone: [nil].
	(((self trackedAgents includes: aClass name) and: [menuSI isOn not])
		or:
			[(self trackedAgents includes: aClass name) not
				and: [menuSI isNil not and: [menuSI isOn]]])
		ifTrue:
			[agentFigures := #().
			(self spaceInterface drawing entityFigures
				at: aClass
				ifAbsent: [nil])
				ifNotNil:
					[agentFigures := (self spaceInterface drawing entityFigures at: aClass)
						values].
			menuSI isOn
				ifTrue:
					[menuSI beOff.
					self spaceInterface trackedFigureTypes
						remove: aClass name
						ifAbsent: [nil].
					agentFigures do: [:af | af untrack]]
				ifFalse:
					[menuSI beOn.
					(self spaceInterface trackedFigureTypes includes: aClass name)
						ifFalse: [self spaceInterface trackedFigureTypes add: aClass name].
					agentFigures do: [:af | af track]]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
infoMethods
	
	^infoMethods ifNil: [infoMethods := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
infoMethods: anObject
	
	infoMethods := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
infoMethodsFor: aClass
	
	| aSet |
	(self infoMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass availableInfo.
			aSet remove: #nil.
			self infoMethods
				at: aClass
				put: aSet sorted].
	^self infoMethods at: aClass! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
infoMethodsForSIMenu: aClass
	
	| infoList |
	infoList := (self infoMethodsFor: aClass) copy.
	infoList addFirst: #nil.
	^infoList! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
infoMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^infoMethodsList isNil
		ifTrue: [infoMethodsList := MultiSelectionInList new]
		ifFalse: [infoMethodsList]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
infoMethodsList_WithoutDefaultSign
	
	| aList aDefInfoWithSign |
	aList := self infoMethodsList list copy.
	aDefInfoWithSign := aList
		detect: [:m | self isItDefault: m]
		ifNone: [^self infoMethodsList copy].
	aList remove: aDefInfoWithSign.
	aList add: (self defaultInfo at: self observedEntitiesList selection).
	aList sort: [:x :y | x < y].
	^MultiSelectionInList with: aList! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
initDisplayOptionsMenu
	
	| menuDyn agentClasses menuAgents |
	agentClasses := List new.
	agentClasses
		addAll:
			(entitiesList select: [:e | e isSituatedClass and: [e inheritsFrom: Agent]]).
	menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
			#trackAgents.
	menuAgents := Menu new.
	1
		to: agentClasses size
		do:
			[:i | 
			| aClass |
			aClass := agentClasses at: i.
			menuAgents
				addItemLabel: aClass name
				value: [self trackAgents: aClass]].
	menuDyn submenu: menuAgents! !

!SpaceInterfaceConfig methodsFor: 'testing' stamp: ' 31/3/15 10:00'!
isItDefault: aSymbolOrString
	
	^'* ->D' match: aSymbolOrString! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isManipulateForTabletEnabled
	
	^isManipulateForTabletEnabled
		ifNil:
			[isManipulateForTabletEnabled := ((builder menuAt: #displayOptionsMenu)
				value atNameKey: #toggleTouchpadMode) isOn]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isManipulateForTabletEnabled: aBoolean
	
	| menuDyn |
	isManipulateForTabletEnabled := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleTouchpadMode.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	self spaceInterface isManipulateForTabletEnabled = aBoolean
		ifFalse: [self spaceInterface isManipulateForTabletEnabled: aBoolean]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isSingleDefaultInfoShown
	
	^isSingleDefaultInfoShown
		ifNil:
			[isSingleDefaultInfoShown := builder
				ifNil: [true]
				ifNotNil:
					[:b | 
					((b menuAt: #displayOptionsMenu) value atNameKey:
							#toggleShowSingleDefaultInfo) isOn]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isSingleDefaultInfoShown: aBoolean
	
	| menuDyn |
	isSingleDefaultInfoShown := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultInfo.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isSingleDefaultPovShown
	
	^isSingleDefaultPovShown
		ifNil:
			[isSingleDefaultPovShown := builder
				ifNil: [true]
				ifNotNil:
					[:b | 
					((b menuAt: #displayOptionsMenu) value atNameKey:
							#toggleShowSingleDefaultPov) isOn]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isSingleDefaultPovShown: aBoolean
	
	| menuDyn |
	isSingleDefaultPovShown := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultPov.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isUndoRedoEnabled
	
	^isUndoRedoEnabled
		ifNil:
			[isUndoRedoEnabled := ((builder menuAt: #displayOptionsMenu) value
				atNameKey: #toggleUndoRedo) isOn]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
isUndoRedoEnabled: aBoolean
	
	| menuDyn |
	isUndoRedoEnabled := aBoolean.
	builder
		ifNotNil:
			[:b | 
			menuDyn := (b menuAt: #displayOptionsMenu) value atNameKey: #toggleUndoRedo.
			aBoolean
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	self spaceInterface enableUndo = aBoolean
		ifFalse: [self spaceInterface enableUndoOption]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
loadConfig
	
	| collec choice |
	collec := self spaceInterface cormasModel habitusNames.
	choice := Dialog
		choose: 'Choose a configuration'
		fromList: collec
		values: collec
		lines: 8
		cancel: [nil].
	choice ifNil: [^nil].
	self loadConfigName: choice! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
loadConfigName: aName
	
	self configName value: aName.
	self spaceInterface configName value: aName.
	self class
		loadSIconfig:
			(self spaceInterface cormasModelClass
				perform: ('SIconfig_' , aName) asSymbol)
		in: self
		ofModel: self spaceInterface cormasModel.
	self applyCurrentSettings.
	self setCheckMarksForDisplayOptionsMenu.
	self forceSItoApplyConfigTrackAgents! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
manipChekboxValidation
	
	^self manipEntitiesList selection isNil not! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
manipEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipEntitiesList isNil
		ifTrue: [manipEntitiesList := SelectionInList new]
		ifFalse: [manipEntitiesList]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
manipMethods
	
	^manipMethods ifNil: [manipMethods := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
manipMethods: anObject
	
	manipMethods := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
manipMethodsFor: aClass
	
	(self manipMethods keys includes: aClass)
		ifFalse:
			[self manipMethods
				at: aClass
				put: aClass methodsForControl].
	^self manipMethods at: aClass! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
manipMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipMethodsList isNil
		ifTrue: [manipMethodsList := MultiSelectionInList new]
		ifFalse: [manipMethodsList]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
manipWholePop
	
	^manipWholePop ifNil: [manipWholePop := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
manipWholePop: anObject
	
	manipWholePop := anObject! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
manipWholePopCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^manipWholePopCheckBox isNil
		ifTrue: [manipWholePopCheckBox := false asValue]
		ifFalse: [manipWholePopCheckBox]! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
manipWholePopFor: aClass
	
	(self manipWholePop keys includes: aClass)
		ifFalse: [self manipWholePop at: aClass put: true].
	^self manipWholePop at: aClass! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
manipulationMenuItemsForEntityType: aClass
	" Returns the set of methods defined in the habitus for manipulating the selected entity"
	
	(self manipEntitiesList list includes: aClass)
		ifTrue:
			[^(self manipMethodsFor: aClass)
				collect: [:aSymbol | aSymbol asString -> (aClass -> aSymbol)]]
		ifFalse: [^Array new]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
methodsToAddList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^methodsToAddList isNil
		ifTrue: [methodsToAddList := MultiSelectionInList new]
		ifFalse: [methodsToAddList]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
moveEntityCheckBox
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^moveEntityCheckBox isNil
		ifTrue: [moveEntityCheckBox := false asValue]
		ifFalse: [moveEntityCheckBox]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
observedEntitiesList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^observedEntitiesList isNil
		ifTrue: [observedEntitiesList := SelectionInList new]
		ifFalse: [observedEntitiesList]! !

!SpaceInterfaceConfig methodsFor: 'interface opening' stamp: ' 31/3/15 10:00'!
open
	
	self dependents isEmpty
		ifTrue:
			[builder := self allButOpenInterface: #windowSpec.
			builder window
				label:
					builder window label , self spaceInterface basicTitle printString.
			self initDisplayOptionsMenu.
			self setCheckMarksForDisplayOptionsMenu.
			^builder window open]
		ifFalse: [self mainWindow raise]! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
pixel0
	
	self delimiterSize value: #pixel0.
	self spaceInterface pixel0! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
pixel1
	
	self delimiterSize value: #pixel1.
	self spaceInterface pixel1! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
pixel2
	
	self delimiterSize value: #pixel2.
	self spaceInterface pixel2! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
pixel3
	
	self delimiterSize value: #pixel3.
	self spaceInterface pixel3! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
povMethods
	
	^povMethods ifNil: [povMethods := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
povMethods: anObject
	
	povMethods := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
povMethodsFor: aClass
	
	| aSet |
	(self povMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass availablePov.
			aSet remove: #nil.
			self povMethods
				at: aClass
				put: aSet sorted].
	^self povMethods at: aClass! !

!SpaceInterfaceConfig methodsFor: 'overwrite spaceInterface' stamp: ' 31/3/15 10:00'!
povMethodsForSIMenu: aClass
	
	| povList |
	povList := (self povMethodsFor: aClass) copy.
	povList addFirst: #nil.
	^povList! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
povMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^povMethodsList isNil
		ifTrue: [povMethodsList := MultiSelectionInList new]
		ifFalse: [povMethodsList]! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
povMethodsList_WithoutDefaultSign
	
	| aList aDefPovWithSign |
	aList := self povMethodsList list copy.
	aDefPovWithSign := aList
		detect: [:m | self isItDefault: m]
		ifNone: [^self povMethodsList copy].
	aList remove: aDefPovWithSign.
	aList add: (self defaultPov at: self observedEntitiesList selection).
	aList sort: [:x :y | x < y].
	^MultiSelectionInList with: aList! !

!SpaceInterfaceConfig methodsFor: 'initialize-release' stamp: ' 31/3/15 10:00'!
prepareSettings
	
	self
		entitiesList:
			(self spaceInterface cormasModelClass visualizableClasses
				sort: [:x :y | x name < y name]) asList.
	self observedEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self manipEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self createEntitiesList
		setList: self entitiesList copy
		selecting: nil.
	self manipEntitiesList selectionHolder onChangeSend:
			#displayMethodsAndOptionsForManipEntity to: self.
	self observedEntitiesList selectionHolder onChangeSend:
			#displayMethodsForObservedEntity to: self! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
probeMethods
	
	^probeMethods ifNil: [probeMethods := Dictionary new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
probeMethods: anObject
	
	probeMethods := anObject! !

!SpaceInterfaceConfig methodsFor: 'access methods' stamp: ' 31/3/15 10:00'!
probeMethodsFor: aClass
	
	| aSet |
	(self probeMethods keys includes: aClass)
		ifFalse:
			[aSet := aClass probes.
			self probeMethods at: aClass put: aSet].
	^self probeMethods at: aClass! !

!SpaceInterfaceConfig methodsFor: 'aspects' stamp: ' 31/3/15 10:00'!
probeMethodsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^probeMethodsList isNil
		ifTrue: [probeMethodsList := MultiSelectionInList new]
		ifFalse: [probeMethodsList]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeAttribute
	
	| aList |
	self attributesList selections isEmpty
		ifTrue: [^self cormas warn: 'No attribute selected'].
	aList := self attributesList list copy.
	aList removeAll: self attributesList selections.
	self attributesList
		setList: aList
		selecting: Array new.
	self attributes
		at: self observedEntitiesList selection
		put: self attributesList list	"	self spaceInterface initMenuInfo."! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeCreateEntity
	
	self removeEntityListName: #createEntitiesList! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeEntityListName: aSymbol
	
	| x |
	(self perform: aSymbol) selection
		ifNil: [^self cormas warn: 'No entity selected'].
	x := (self perform: aSymbol) selectionIndex.
	(self perform: aSymbol) list remove: (self perform: aSymbol) selection.
	(self perform: aSymbol)
		selectionIndex: (x min: (self perform: aSymbol) list size)! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeInfoMethod
	
	| aList |
	self infoMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No method selected'].
	self infoMethodsList selections
		do:
			[:m | 
			(self isItDefault: m)
				ifTrue:
					[self defaultInfo
						at: self observedEntitiesList selection
						put: nil]].
	aList := self infoMethodsList list copy.
	aList removeAll: self infoMethodsList selections.
	self infoMethodsList
		setList: aList
		selecting: Array new.
	self infoMethods
		at: self observedEntitiesList selection
		put: self infoMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuInfo! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeManipEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	self removeEntityListName: #manipEntitiesList.
	(anEntity isNil not and: [self canBeMoved keys includes: anEntity])
		ifTrue: [self canBeMoved at: anEntity put: false].
	(anEntity isNil not and: [self manipWholePop keys includes: anEntity])
		ifTrue: [self manipWholePop at: anEntity put: false].
	(anEntity isNil not and: [self canChangeValues keys includes: anEntity])
		ifTrue: [self canChangeValues at: anEntity put: false]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeManipMethod
	
	| aList |
	self manipMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No method selected'].
	aList := self manipMethodsList list copy.
	aList removeAll: self manipMethodsList selections.
	self manipMethodsList
		setList: aList
		selecting: Array new.
	self manipMethods
		at: self manipEntitiesList selection
		put: self manipMethodsList list! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeObservedEntity
	
	| old new test |
	old := self observedEntitiesList list copy.
	self removeEntityListName: #observedEntitiesList.
	new := self observedEntitiesList list.
	test := false.
	old
		do:
			[:aClass | 
			(new includes: aClass)
				ifFalse:
					[test := true.
					(self defaultPov keys includes: aClass)
						ifTrue: [self defaultPov removeKey: aClass]]].
	test
		ifTrue:
			[(self spaceInterface)
				initMenuPov;
				initMenuInfo;
				initMenuTrack]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removePovMethod
	
	| aList |
	self povMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No method selected'].
	self povMethodsList selections
		do:
			[:m | 
			(self isItDefault: m)
				ifTrue:
					[self defaultPov
						at: self observedEntitiesList selection
						put: nil]].
	aList := self povMethodsList list copy.
	aList removeAll: self povMethodsList selections.
	self povMethodsList
		setList: aList
		selecting: Array new.
	self povMethods
		at: self observedEntitiesList selection
		put: self povMethodsList_WithoutDefaultSign list.
	self spaceInterface initMenuPov! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
removeProbeMethod
	
	| aList |
	self probeMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No method selected'].
	aList := self probeMethodsList list copy.
	aList removeAll: self probeMethodsList selections.
	self probeMethodsList
		setList: aList
		selecting: Array new.
	self probeMethods
		at: self observedEntitiesList selection
		put: self probeMethodsList list! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
reopenSI
	
	| oldSI newSI |
	oldSI := self spaceInterface.
	newSI := self spaceInterface reopenWithSameHabitus.
	oldSI siConfig: nil.
	oldSI closeRequest.
	^newSI! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
saveConfig
	
	self configName value isEmpty
		ifTrue:
			[^self cormas warn: 'Please enter a title for that configuration'].
	(self configName value includes: $ )
		ifTrue:
			[(self cormas confirm:
					'Space characters are not allowed for Habitus names. Do you want to replace by ''_'' character ?')
				ifTrue:
					[self configName value: (self configName value replaceAll: $  with: $_)]
				ifFalse: [^nil]].
	self checkClassAndMethodsExist.
	self class
		saveSIconfig: self
		intoClass: self spaceInterface cormasModelClass
		name: self configName value.
	self spaceInterface configName value: self configName value! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
setChangeValues
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self canChangeValues
		at: anEntity
		put: self canChangeValuesCheckBox value! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
setCheckMarksForDisplayOptionsMenu
	
	| menu menuDyn |
	entitiesList
		do:
			[:agentClass | 
			(agentClass isSituatedClass and: [agentClass inheritsFrom: Agent])
				ifTrue:
					[menu := ((builder menuAt: #displayOptionsMenu) value atNameKey:
							#trackAgents) submenu menuItemLabeled: agentClass name asString.
					(self trackedAgents includes: agentClass name)
						ifFalse: [menu beOff]
						ifTrue: [menu beOn]]].
	isManipulateForTabletEnabled
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleTouchpadMode.
			isManipulateForTabletEnabled
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]
		ifNil:
			[self
				isManipulateForTabletEnabled:
					self spaceInterface isManipulateForTabletEnabled].
	isUndoRedoEnabled
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleUndoRedo.
			isUndoRedoEnabled
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]
		ifNil: [self isUndoRedoEnabled: self spaceInterface enableUndo].
	isSingleDefaultPovShown
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultPov.
			isSingleDefaultPovShown
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]].
	isSingleDefaultInfoShown
		ifNotNil:
			[menuDyn := (builder menuAt: #displayOptionsMenu) value atNameKey:
					#toggleShowSingleDefaultInfo.
			isSingleDefaultInfoShown
				ifTrue: [menuDyn beOn]
				ifFalse: [menuDyn beOff]]! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
setManipWholePop
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self manipWholePop
		at: anEntity
		put: self manipWholePopCheckBox value! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
setMoveEntity
	
	| anEntity |
	anEntity := self manipEntitiesList selection.
	anEntity ifNil: [^nil].
	self canBeMoved
		at: anEntity
		put: self moveEntityCheckBox value! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
setSelectionAsDefaultInfo
	
	| aList anEntity |
	self infoMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No info selected'].
	anEntity := self observedEntitiesList selection.
	self infoMethodsList selections size > 1
		ifTrue: [^self cormas warn: 'Only one info can be set as default'].
	(self isItDefault: self infoMethodsList selections first)
		ifTrue: [^self cormas warn: 'This info is already set as default'].
	aList := self infoMethodsList_WithoutDefaultSign list copy.
	self defaultInfo
		at: anEntity
		put: self infoMethodsList selections first.
	aList remove: (self defaultInfo at: anEntity).
	aList add: (self defaultInfo at: anEntity) , ' ->D'.
	aList sort: [:x :y | x < y].
	self infoMethodsList
		setList: aList
		selecting: (Array with: (self defaultInfo at: anEntity) , ' ->D')! !

!SpaceInterfaceConfig methodsFor: 'actions' stamp: ' 31/3/15 10:00'!
setSelectionAsDefaultPov
	
	| aList anEntity |
	self povMethodsList selections isEmpty
		ifTrue: [^self cormas warn: 'No pov selected'].
	anEntity := self observedEntitiesList selection.
	self povMethodsList selections size > 1
		ifTrue: [^self cormas warn: 'Only one pov can be set as default'].
	(self isItDefault: self povMethodsList selections first)
		ifTrue: [^self cormas warn: 'This pov is already set as default'].
	aList := self povMethodsList_WithoutDefaultSign list copy.
	self defaultPov
		at: anEntity
		put: self povMethodsList selections first.
	aList remove: (self defaultPov at: anEntity).
	aList add: (self defaultPov at: anEntity) , ' ->D'.
	aList sort: [:x :y | x < y].
	self povMethodsList
		setList: aList
		selecting: (Array with: (self defaultPov at: anEntity) , ' ->D')! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 14:54'!
setTrackLength
	"set the maximum size of the figures' tracks"
	
	(self 
		requestFrom: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20)
		message: self translator tAgentTracksSize
		title: 'CORMAS')
			ifNil: [ ^ self ]
			ifNotNil: [ : selectedItem |
				self trackLengthValue: selectedItem.
				self applyTrackLengthValue: selectedItem ]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
siMenuFormat
	
	^siMenuFormat isNil
		ifTrue: [siMenuFormat := #siMenuFull asValue]
		ifFalse: [siMenuFormat]! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuFull
	
	self siMenuFormat value: #siMenuFull! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuFull_apply
	
	self siMenuFull.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited
	
	self siMenuFormat value: #siMenuLimited! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited2
	
	self siMenuFormat value: #siMenuLimited2! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited2WithHabitus
	
	self siMenuFormat value: #siMenuLimited2WithHabitus! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited2WithHabitus_apply
	
	self siMenuLimited2WithHabitus.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited2_apply
	
	self siMenuLimited2.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimitedWithHabitus
	
	self siMenuFormat value: #siMenuLimitedWithHabitus! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimitedWithHabitus_apply
	
	self siMenuLimitedWithHabitus.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuLimited_apply
	
	self siMenuLimited.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuNone
	
	self siMenuFormat value: #siMenuNone! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
siMenuNone_apply
	
	self siMenuNone.
	self reopenSI openSIconfig! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
spaceInterface
	
	^spaceInterface! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
spaceInterface: anObject
	
	spaceInterface := anObject! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toggleShowSingleDefaultInfo
	
	self isSingleDefaultInfoShown: self isSingleDefaultInfoShown not! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toggleShowSingleDefaultPov
	
	self isSingleDefaultPovShown: self isSingleDefaultPovShown not! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toggleTouchpadMode
	
	self isManipulateForTabletEnabled: self isManipulateForTabletEnabled not! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toggleUndoRedo
	
	self isUndoRedoEnabled: self isUndoRedoEnabled not! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toolCreate
	
	self defaultTool value: #toolCreate.
	self spaceInterface activateCreateEntityTool! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toolInspect
	
	self defaultTool value: #toolInspect.
	self spaceInterface activateInspectTool! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toolManipulate
	
	self defaultTool value: #toolManipulate.
	self spaceInterface activateManipulateTool! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: ' 31/3/15 10:00'!
toolZoom
	
	self defaultTool value: #toolZoom.
	self spaceInterface activateZoomTool! !

!SpaceInterfaceConfig methodsFor: 'menu-display options' stamp: 'HernanMoralesDurand 12/16/2017 12:43'!
trackAgents: agentClass
	
	| menu menuSubclass builder |
	menu := ((builder menuAt: #displayOptionsMenu) value atNameKey:
			#trackAgents) submenu menuItemLabeled: agentClass name asString.
	menu isOn
		ifTrue:
			[menu beOff.
			(self trackedAgents includes: agentClass name)
				ifTrue: [self trackedAgents remove: agentClass name]]
		ifFalse:
			[(self observedEntitiesList list includes: agentClass)
				ifFalse:
					[^ self alertMessage: 'The entity ' , agentClass name , ' can not be observed in the current configuration'].
			menu beOn.
			(self trackedAgents includes: agentClass name)
				ifFalse: [self trackedAgents add: agentClass name]].
	self forceSItrackAgents: agentClass.
	agentClass subclasses
		do:
			[:aClass | 
			menuSubclass := ((builder menuAt: #displayOptionsMenu) value atNameKey:
					#trackAgents) submenu menuItemLabeled: aClass name asString.
			menu isOn
				ifTrue:
					[menuSubclass beOn.
					(self trackedAgents includes: aClass name)
						ifFalse: [self trackedAgents add: aClass name]]
				ifFalse:
					[menuSubclass beOff.
					(self trackedAgents includes: aClass name)
						ifTrue: [self trackedAgents remove: aClass name]].
			self forceSItrackAgents: aClass]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
trackLengthValue
	
	^trackLengthValue! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
trackLengthValue: anObject
	
	trackLengthValue := anObject! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
trackedAgents
	
	^trackedAgents ifNil: [trackedAgents := Set new]! !

!SpaceInterfaceConfig methodsFor: 'accessing' stamp: ' 31/3/15 10:00'!
trackedAgents: anObject
	
	trackedAgents := anObject! !

PovSetter subclass: #PovSetter_Arc
	instanceVariableNames: 'startAnnotation widthChoices stopAnnotation lineWidth stopPosition startPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!PovSetter_Arc class methodsFor: 'interface specs' stamp: ' 31/3/15 09:46'!
windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: #(UserMessage 
				#key: #observationOfEntity 
				#defaultString: 'Observation of ArcEntity') 
			#min: #(Point 672 423) 
			#max: #(Point 414 423) 
			#bounds: #(Rectangle 720 450 1357 856) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 8191 5119 2048)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(RegionSpec 
				#layout: #(Rectangle 375 285 458 368) 
				#name: #Region1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(ArbitraryComponentSpec 
				#layout: #(LayoutSizedOrigin 373 0 283 0 87 87) 
				#name: #imageOS 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#component: #imageOS) #(RegionSpec 
				#layout: #(Rectangle 5 175 274 370) 
				#name: #Region3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue #white)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 176 275 371) 
				#name: #Region4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 424 11 631 161) 
				#name: #Region6 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(RegionSpec 
				#layout: #(Rectangle 7 12 383 161) 
				#name: #Region2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7700 7700 7700)) 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 5 3 385 163) 
				#name: #GroupBox3 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue 7700 7700 7700) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #povDefinition 
					#defaultString: ' PoV definition ')) #(LabelSpec 
				#layout: #(Point 247 17) 
				#label: #(UserMessage 
					#key: #associatedSymbols 
					#defaultString: 'Associated Symbols') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 221 36 378 155) 
				#name: #pov 
				#model: #listSymbols 
				#menu: #menuSymbolePDV 
				#multipleSelections: false) #(ActionButtonSpec 
				#layout: #(Rectangle 117 376 222 403) 
				#name: #boutonAppliquer 
				#flags: 40 
				#model: #validate 
				#label: #(UserMessage 
					#key: #apply 
					#defaultString: 'Apply') 
				#isDefault: false 
				#defaultable: true) #(SequenceViewSpec 
				#layout: #(Rectangle 10 36 205 154) 
				#name: #listMethods 
				#model: #listMethods 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyPov) 
				#menu: #menuPDV 
				#multipleSelections: false) #(LabelSpec 
				#layout: #(Point 11 17) 
				#label: #(UserMessage 
					#key: #methodesreturningPoV 
					#defaultString: 'Methodes returning a Color or a Symbol') 
				#style: #pixelDefault) #(SequenceViewSpec 
				#layout: #(Rectangle 431 36 625 152) 
				#name: #List1 
				#model: #listInfo 
				#callbacksSpec: #(UIEventCallbackSubSpec 
					#doubleClickSelector: #modifyInfo) 
				#menu: #menuInfo 
				#useModifierKeys: true 
				#selectionType: #highlight) #(GroupBoxSpec 
				#layout: #(Rectangle 423 3 633 162) 
				#name: #GroupBox2 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #informationToBeDisplay 
					#defaultString: ' Information to be displayed ')) #(LabelSpec 
				#layout: #(Point 449 17) 
				#name: #Label1 
				#label: #(UserMessage 
					#key: #methodesreturningString 
					#defaultString: 'Methodes returning a String') 
				#style: #pixelDefault) #(CheckBoxSpec 
				#layout: #(Point 488 324) 
				#name: #startAnnotation 
				#model: #startAnnotation 
				#label: 'start annotation') #(CheckBoxSpec 
				#layout: #(Point 488 349) 
				#name: #stopAnnotation 
				#model: #stopAnnotation 
				#label: 'stop annotation') #(LabelSpec 
				#layout: #(Point 488 291) 
				#name: #Label2 
				#label: 'Line width:') #(ComboBoxSpec 
				#layout: #(Rectangle 552 291 595 312) 
				#name: #ComboBox1 
				#model: #lineWidth 
				#type: #number 
				#formatString: '0' 
				#comboList: #widthChoices) #(LabelSpec 
				#layout: #(Point 601 291) 
				#name: #Label3 
				#label: 'pixels') #(LabelSpec 
				#layout: #(Point 13 255) 
				#name: #Label4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #red) 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #red 
					#defaultString: 'Red')) #(LabelSpec 
				#layout: #(Point 13 282) 
				#name: #Label5 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #green 
					#defaultString: 'Green')) #(LabelSpec 
				#layout: #(Point 13 308) 
				#name: #Label6 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #blue 
					#defaultString: 'Blue')) #(GroupBoxSpec 
				#layout: #(Rectangle 6 167 277 373) 
				#name: #GroupBox1 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 6054 3027 0)) 
				#label: #(UserMessage 
					#key: #color 
					#defaultString: ' Set the Color ')) #(SubCanvasSpec 
				#layout: #(Rectangle 9 188 272 238) 
				#name: #Subcanvas1 
				#flags: 0 
				#majorKey: PovSetter 
				#minorKey: #palette) #(InputFieldSpec 
				#layout: #(Rectangle 179 254 219 273) 
				#name: #InputField1 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #redSlider 
				#tabable: true 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179.0 281 217.0 301) 
				#name: #InputField2 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #greenSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 307 215 329) 
				#name: #InputField3 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #blueSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(InputFieldSpec 
				#layout: #(Rectangle 179 339 214 360) 
				#name: #InputField4 
				#flags: 0 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #brightnessSlider 
				#style: #pixelDefault 
				#type: #number 
				#formatString: '0.00') #(LabelSpec 
				#layout: #(Point 13 340) 
				#name: #Label7 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#label: #(UserMessage 
					#key: #brightness 
					#defaultString: 'Brightness')) #(SliderSpec 
				#layout: #(Rectangle 77 342 177 358) 
				#name: #Slider4 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #brightnessSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 310 177 328) 
				#name: #Slider3 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #blueSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 283 177 301) 
				#name: #Slider1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #greenSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(SliderSpec 
				#layout: #(Rectangle 77 255 177 273) 
				#name: #Slider2 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 5734 5734 5734)) 
				#model: #redSlider 
				#orientation: #horizontal 
				#start: 0 
				#stop: 1 
				#step: 0.01) #(RadioButtonSpec 
				#layout: #(Point 301 183) 
				#name: #RadioButton1 
				#model: #startPosition 
				#helpText: 'Put the entity image randomly on its cell' 
				#label: #(UserMessage 
					#key: #randomly 
					#defaultString: 'randomly') 
				#select: #random) #(GroupBoxSpec 
				#layout: #(Rectangle 282 167 411 278) 
				#name: #GroupBox5 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: 'Start position on the cell ')) #(RadioButtonSpec 
				#layout: #(Point 328 213) 
				#name: #RadioButton6 
				#model: #startPosition 
				#select: #topLeft) #(RadioButtonSpec 
				#layout: #(Point 328 229) 
				#name: #RadioButton2 
				#model: #startPosition 
				#select: #leftCenter) #(RadioButtonSpec 
				#layout: #(Point 328 245) 
				#name: #RadioButton7 
				#model: #startPosition 
				#select: #bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 343 245) 
				#name: #RadioButton4 
				#model: #startPosition 
				#select: #bottomCenter) #(RadioButtonSpec 
				#layout: #(Point 343 229) 
				#name: #RadioButton8 
				#model: #startPosition 
				#select: #center) #(RadioButtonSpec 
				#layout: #(Point 343 213) 
				#name: #RadioButton19 
				#model: #startPosition 
				#select: #topCenter) #(RadioButtonSpec 
				#layout: #(Point 358 213) 
				#name: #RadioButton10 
				#model: #startPosition 
				#select: #topRight) #(RadioButtonSpec 
				#layout: #(Point 358 229) 
				#name: #RadioButton5 
				#model: #startPosition 
				#select: #rightCenter) #(RadioButtonSpec 
				#layout: #(Point 358 245) 
				#name: #RadioButton9 
				#model: #startPosition 
				#select: #bottomRight) #(RadioButtonSpec 
				#layout: #(Point 314 200) 
				#name: #RadioButton3 
				#model: #startPosition 
				#select: #border_topLeft) #(RadioButtonSpec 
				#layout: #(Point 314 229) 
				#name: #RadioButton11 
				#model: #startPosition 
				#select: #border_leftCenter) #(RadioButtonSpec 
				#layout: #(Point 314 258) 
				#name: #RadioButton12 
				#model: #startPosition 
				#select: #border_bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 372 258) 
				#name: #RadioButton13 
				#model: #startPosition 
				#select: #border_bottomRight) #(RadioButtonSpec 
				#layout: #(Point 372 229) 
				#name: #RadioButton14 
				#model: #startPosition 
				#select: #border_rightCenter) #(RadioButtonSpec 
				#layout: #(Point 372 200) 
				#name: #RadioButton15 
				#model: #startPosition 
				#select: #border_topRight) #(RadioButtonSpec 
				#layout: #(Point 343 200) 
				#name: #RadioButton16 
				#model: #startPosition 
				#select: #border_topCenter) #(RadioButtonSpec 
				#layout: #(Point 343 258) 
				#name: #RadioButton17 
				#model: #startPosition 
				#select: #border_bottomCenter) #(RegionSpec 
				#layout: #(Rectangle 320 208 378 267) 
				#name: #Region5 
				#lineWidth: 1) #(RadioButtonSpec 
				#layout: #(Point 438 183) 
				#name: #RadioButton18 
				#model: #stopPosition 
				#helpText: 'Put the entity image randomly on its cell' 
				#label: #(UserMessage 
					#key: #randomly 
					#defaultString: 'randomly') 
				#select: #random) #(RadioButtonSpec 
				#layout: #(Point 465 213) 
				#name: #RadioButton20 
				#model: #stopPosition 
				#select: #topLeft) #(RadioButtonSpec 
				#layout: #(Point 465 229) 
				#name: #RadioButton21 
				#model: #stopPosition 
				#select: #leftCenter) #(RadioButtonSpec 
				#layout: #(Point 465 245) 
				#name: #RadioButton22 
				#model: #stopPosition 
				#select: #bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 480 245) 
				#name: #RadioButton23 
				#model: #stopPosition 
				#select: #bottomCenter) #(RadioButtonSpec 
				#layout: #(Point 480 229) 
				#name: #RadioButton24 
				#model: #stopPosition 
				#select: #center) #(RadioButtonSpec 
				#layout: #(Point 480 213) 
				#name: #RadioButton25 
				#model: #stopPosition 
				#select: #topCenter) #(RadioButtonSpec 
				#layout: #(Point 495 213) 
				#name: #RadioButton26 
				#model: #stopPosition 
				#select: #topRight) #(RadioButtonSpec 
				#layout: #(Point 495 229) 
				#name: #RadioButton27 
				#model: #stopPosition 
				#select: #rightCenter) #(RadioButtonSpec 
				#layout: #(Point 495 245) 
				#name: #RadioButton28 
				#model: #stopPosition 
				#select: #bottomRight) #(RadioButtonSpec 
				#layout: #(Point 451 200) 
				#name: #RadioButton29 
				#model: #stopPosition 
				#select: #border_topLeft) #(RadioButtonSpec 
				#layout: #(Point 451 229) 
				#name: #RadioButton30 
				#model: #stopPosition 
				#select: #border_leftCenter) #(RadioButtonSpec 
				#layout: #(Point 451 258) 
				#name: #RadioButton31 
				#model: #stopPosition 
				#select: #border_bottomLeft) #(RadioButtonSpec 
				#layout: #(Point 509 258) 
				#name: #RadioButton32 
				#model: #stopPosition 
				#select: #border_bottomRight) #(RadioButtonSpec 
				#layout: #(Point 509 229) 
				#name: #RadioButton33 
				#model: #stopPosition 
				#select: #border_rightCenter) #(RadioButtonSpec 
				#layout: #(Point 509 200) 
				#name: #RadioButton34 
				#model: #stopPosition 
				#select: #border_topRight) #(RadioButtonSpec 
				#layout: #(Point 480 200) 
				#name: #RadioButton35 
				#model: #stopPosition 
				#select: #border_topCenter) #(RadioButtonSpec 
				#layout: #(Point 480 258) 
				#name: #RadioButton36 
				#model: #stopPosition 
				#select: #border_bottomCenter) #(RegionSpec 
				#layout: #(Rectangle 457 208 515 267) 
				#name: #Region7 
				#lineWidth: 1) #(GroupBoxSpec 
				#layout: #(Rectangle 419 167 548 278) 
				#name: #GroupBox6 
				#colors: #(LookPreferences 
					#setForegroundColor: #(ColorValue #white) 
					#setBackgroundColor: #(ColorValue 3072 3072 8191)) 
				#label: #(UserMessage 
					#key: #createimage 
					#defaultString: 'Stop position on the cell ')))))! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
colorChanged
	
	| color |
	color := super colorChanged.
	self imageOS model lineColor: color.
	imageOS figure lineColor: color.
	imageOS invalidate! !

!PovSetter_Arc methodsFor: 'initialize-release' stamp: ' 31/3/15 09:46'!
initialize
	
	super initialize.
	self lineWidth onChangeSend: #setLineWidth to: self.
	self startAnnotation onChangeSend: #setStartAnnotation to: self.
	self stopAnnotation onChangeSend: #setStopAnnotation to: self.
	self startPosition onChangeSend: #startPositionChanged to: self.
	self stopPosition onChangeSend: #stopPositionChanged to: self! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
lineWidth
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^lineWidth isNil
		ifTrue: [lineWidth := 1 asValue]
		ifFalse: [lineWidth]! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
listSymbolsChanged
	
	| anImage |
	self listSymbols selection ifNil: [^nil].
	anImage := selectedClass imageAtPov: listSymbols selection asSymbol.
	imageOS model: anImage copy.
	imageOS figure: imageOS model asFigure.
	couleur := super listSymbolsChanged.
	imageOS model color: couleur.
	self startAnnotation value: anImage startAnnotation.
	self stopAnnotation value: anImage stopAnnotation.
	self lineWidth value: anImage lineWidth.
	imageOS invalidate! !

!PovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:46'!
removeClassMethodForSymbol: aSymbol
	
	selectedClass class removeSelector: ('ArcPOV_' , aSymbol) asSymbol! !

!PovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:46'!
saveArcPOV: aPOV intoClass: aClass symbol: aSymbol
	
	| selector |
	selector := 'ArcPOV_' , aSymbol.
	aClass class
		compile:
			(selector ,
					'\"Returns an array containing the settings of a Arc entity pov symbol in the following order:\(lineColor red) (lineColor green) (lineColor blue) lineWidth startAnnotation stopAnnotation startPosition stopPosition"\^#('
				, aPOV lineColor red printString , ' '
				, aPOV lineColor green printString , ' '
				, aPOV lineColor blue printString , ' ' , aPOV lineWidth printString ,
					' ' , aPOV startAnnotation printString , ' '
				, aPOV stopAnnotation printString , aPOV startPosition printString ,
					' ' , aPOV stopPosition printString , ' ' , ')') withCRs
		classified: 'pov symbols'
		notifying: nil! !

!PovSetter_Arc methodsFor: 'saving&removing pov symbols' stamp: ' 31/3/15 09:46'!
savePOVsymbol: aSymbol
	
	self
		saveArcPOV: imageOS model copy
		intoClass: selectedClass
		symbol: aSymbol! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
setLineWidth
	
	self imageOS model lineWidth: self lineWidth value.
	imageOS figure lineWidth: self lineWidth value.
	imageOS invalidate.
	(self builder componentAt: #boutonAppliquer) enable! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
setStartAnnotation
	
	self startAnnotation value
		ifTrue: [imageOS figure addCircleStart]
		ifFalse: [imageOS figure removeCircle].
	imageOS invalidate.
	self imageOS model startAnnotation: self startAnnotation value.
	(self builder componentAt: #boutonAppliquer) enable! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
setStopAnnotation
	
	self stopAnnotation value
		ifTrue: [imageOS figure addStopArrow]
		ifFalse: [imageOS figure removeArrow].
	imageOS invalidate.
	self imageOS model stopAnnotation: self stopAnnotation value.
	(self builder componentAt: #boutonAppliquer) enable! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
startAnnotation
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startAnnotation isNil
		ifTrue: [startAnnotation := false asValue]
		ifFalse: [startAnnotation]! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
startPosition
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^startPosition isNil
		ifTrue: [startPosition := #center asValue]
		ifFalse: [startPosition]! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
startPositionChanged
	"Display the figure at the right position on the virtualCell"
	
	imageOS model startPosition: startPosition value	"	self builder ifNil: [^self].
	(self builder componentAt: #virtualCell) bounds.
	(self builder componentAt: #boutonAppliquer) enable."	"figurePosition := imageOS figure calculateNewPositionOnPatchBounds: ((self builder componentAt: #virtualCell) bounds moveTo: -17 @ -19)."	"startPosition value = #topLeft ifTrue: [figurePosition := -17 @ -17].
	startPosition value = #leftCenter ifTrue: [figurePosition := -17 @ 0].
	startPosition value = #bottomLeft ifTrue: [figurePosition := -17 @ 17].
	startPosition value = #topRight ifTrue: [figurePosition := 17 @ -17].
	startPosition value = #rightCenter ifTrue: [figurePosition := 17 @ 0].
	startPosition value = #bottomRight ifTrue: [figurePosition := 17 @ 17].
	startPosition value = #topCenter ifTrue: [figurePosition := 0 @ -17].
	startPosition value = #center ifTrue: [figurePosition := 0 @ 0].
	startPosition value = #bottomCenter ifTrue: [figurePosition := 0 @ 17].
	startPosition value = #random ifTrue: [figurePosition := 4 @ 6].

	startPosition value = #border_topLeft ifTrue: [figurePosition := -25 @ -25].
	startPosition value = #border_leftCenter ifTrue: [figurePosition := -25 @ 0].
	startPosition value = #border_bottomLeft ifTrue: [figurePosition := -25 @ 25].
	startPosition value = #border_topRight ifTrue: [figurePosition := 25 @ -25].
	startPosition value = #border_rightCenter ifTrue: [figurePosition := 25 @ 0].
	startPosition value = #border_bottomRight ifTrue: [figurePosition := 25 @ 25].
	startPosition value = #border_topCenter ifTrue: [figurePosition := 0 @ -25].
	startPosition value = #border_bottomCenter ifTrue: [figurePosition := 0 @ 25].

	imageOS figure translateTo: figurePosition - (imageOS figure bounds extent / 2).
	imageOS invalidate"! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
stopAnnotation
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopAnnotation isNil
		ifTrue: [stopAnnotation := true asValue]
		ifFalse: [stopAnnotation]! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
stopPosition
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^stopPosition isNil
		ifTrue: [stopPosition := #center asValue]
		ifFalse: [stopPosition]! !

!PovSetter_Arc methodsFor: 'changed' stamp: ' 31/3/15 09:46'!
stopPositionChanged
	"Display the figure at the right position on the virtualCell"
	
	imageOS model stopPosition: stopPosition value	"	self builder ifNil: [^self].
	(self builder componentAt: #virtualCell) bounds.
	(self builder componentAt: #boutonAppliquer) enable."	"figurePosition := imageOS figure calculateNewPositionOnPatchBounds: ((self builder componentAt: #virtualCell) bounds moveTo: -17 @ -19)."	"startPosition value = #topLeft ifTrue: [figurePosition := -17 @ -17].
	startPosition value = #leftCenter ifTrue: [figurePosition := -17 @ 0].
	startPosition value = #bottomLeft ifTrue: [figurePosition := -17 @ 17].
	startPosition value = #topRight ifTrue: [figurePosition := 17 @ -17].
	startPosition value = #rightCenter ifTrue: [figurePosition := 17 @ 0].
	startPosition value = #bottomRight ifTrue: [figurePosition := 17 @ 17].
	startPosition value = #topCenter ifTrue: [figurePosition := 0 @ -17].
	startPosition value = #center ifTrue: [figurePosition := 0 @ 0].
	startPosition value = #bottomCenter ifTrue: [figurePosition := 0 @ 17].
	startPosition value = #random ifTrue: [figurePosition := 4 @ 6].

	startPosition value = #border_topLeft ifTrue: [figurePosition := -25 @ -25].
	startPosition value = #border_leftCenter ifTrue: [figurePosition := -25 @ 0].
	startPosition value = #border_bottomLeft ifTrue: [figurePosition := -25 @ 25].
	startPosition value = #border_topRight ifTrue: [figurePosition := 25 @ -25].
	startPosition value = #border_rightCenter ifTrue: [figurePosition := 25 @ 0].
	startPosition value = #border_bottomRight ifTrue: [figurePosition := 25 @ 25].
	startPosition value = #border_topCenter ifTrue: [figurePosition := 0 @ -25].
	startPosition value = #border_bottomCenter ifTrue: [figurePosition := 0 @ 25].

	imageOS figure translateTo: figurePosition - (imageOS figure bounds extent / 2).
	imageOS invalidate"! !

!PovSetter_Arc methodsFor: 'action' stamp: ' 31/3/15 09:46'!
validate
	
	| selectedSymbol aPOV |
	listSymbols selection
		ifNil:
			[^Dialog
				warn:
					(UserMessage defaultString: 'Select a pov symbol' key: #selectPovMethod)
						asString]
		ifNotNil: [:aSelec | selectedSymbol := aSelec asSymbol].
	aPOV := imageOS model copy.
	selectedClass povDict at: selectedSymbol put: aPOV.	"on met √† jour le dico povDict"
	self savePOVsymbol: selectedSymbol.	"on sauvegarde au niveau de la classe de l''entit√©"	""	"on fait oublier aux agents leur visualState pour ce pov"
	self cormas currentSimulation
		ifNotNil:
			[:sim | 
			(sim allTheEntities: selectedClass)
				do:
					[:entity | 
					sim
						registerEntityChange: #povSymbolChanged
						with: selectedSymbol
						from: (EntityReference on: entity)]	"entity replacePovAtSymbol: selectedSymbol]"]! !

!PovSetter_Arc methodsFor: 'aspects' stamp: ' 31/3/15 09:46'!
widthChoices
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^widthChoices isNil
		ifTrue: [widthChoices := (List withAll: #(1 2 3 4 5)) asValue]
		ifFalse: [widthChoices]! !

CMAgent subclass: #AgentComm
	instanceVariableNames: 'mailBox channel agentObs acquaintances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!AgentComm commentStamp: '<historical>' prior: 0!
AgentComm is a class which subclasses will be able to exchange messages. 

Instance Variables:
	acquaintances	<IndexedSet>	is a set of other communicating entities to communicate with.
	agentObs	<AgentObs>	is an instance of the interface agent (on the observer)
	channel	<Channel>	is used to receive, store and deliver messages processed by communication agents
	mailBox	<OrderedCollection>	an orderedCollection to store the received messages.

Methods

messageFromChannel: will receive as argument an instance of a subclass of Msg. It will be stored in the mailBox at last position.
nextMessage returns the first message in the mailBox and remove it from the mailBox.
sendMessage Synchronously: will ask the channel to store the message. It will be delivered at the end of the current time step.
sendmessageSynchrounously: will ask the channel to deliver the message immediately.

!

!AgentComm class methodsFor: '- testing' stamp: ' 26/3/15 15:24'!
isAgentCommClass
	
	^true! !

!AgentComm methodsFor: '+ accessing' stamp: 'SergeStinckwich 5/31/2015 15:47'!
acquaintances
	
	^acquaintances ifNil: [acquaintances := OrderedCollection new]! !

!AgentComm methodsFor: '+ accessing' stamp: ' 26/3/15 15:24'!
acquaintances: x
	
	acquaintances := x! !

!AgentComm methodsFor: '- accessing' stamp: ' 26/3/15 15:24'!
agentObs
	
	^agentObs! !

!AgentComm methodsFor: '- accessing' stamp: ' 26/3/15 15:24'!
agentObs: unAgent
	
	agentObs := unAgent! !

!AgentComm methodsFor: '- accessing' stamp: ' 26/3/15 15:24'!
channel
	
	^channel! !

!AgentComm methodsFor: '- accessing' stamp: ' 26/3/15 15:24'!
channel: val
	
	channel := val! !

!AgentComm methodsFor: '+ testing' stamp: ' 26/3/15 15:24'!
isAgentComm
	
	^true! !

!AgentComm methodsFor: '- deprecated' stamp: ' 26/3/15 15:24'!
lastMessage
	"DEPRECATED"
	
	^self latestMessage! !

!AgentComm methodsFor: '+ accessing' stamp: ' 26/3/15 15:24'!
latestMessage
	"Purpose: picks the latest message received in the mailbox, removes it from the mailbox and returns it
Return value: <Msg>"
	
	| aMsg |
	mailBox isEmpty ifTrue: [^nil].
	aMsg := mailBox last.
	mailBox removeLast.
	^aMsg! !

!AgentComm methodsFor: '+ accessing' stamp: ' 26/3/15 15:24'!
mailBox
	
	^mailBox ifNil: [mailBox := OrderedCollection new]! !

!AgentComm methodsFor: '+ accessing' stamp: ' 26/3/15 15:24'!
mailBox: anOrderedCollection
	
	mailBox := anOrderedCollection! !

!AgentComm methodsFor: '- utilities' stamp: ' 26/3/15 15:24'!
messageFromChannel: aMsg
	"used by channel"
	
	self mailBox addLast: aMsg! !

!AgentComm methodsFor: '- deprecated' stamp: ' 26/3/15 15:24'!
nextMessage
	"DEPRECATED"
	
	^self oldestMessage! !

!AgentComm methodsFor: '+ accessing' stamp: ' 26/3/15 15:24'!
oldestMessage
	"Purpose: picks the oldest message still stored in the mailbox, removes it from the mailbox and returns it
Return value: <Msg>"
	
	| aMsg |
	mailBox isEmpty ifTrue: [^nil].
	aMsg := mailBox first.
	mailBox removeFirst.
	^aMsg! !

!AgentComm methodsFor: '+ initialize - release' stamp: ' 26/3/15 15:24'!
reset
	"Purpose: resets inherited and specific attributes"
	
	super reset.
	self mailBox: OrderedCollection new.
	self acquaintances: Set new! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendAsynchronouslyMsgTo: anAgent topic: aSymbol
	"Purpose: sends and delivers IMMEDIATELY a message (with a topic) 
Arguments: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
Example: self sendAsynchronouslyMsgTo: self myFriend topic  #hello)"
	
	| aMsg |
	aMsg := Msg from: self to: anAgent topic: aSymbol.
	self channel transmit: aMsg! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendAsynchronouslyMsgTo: anAgent topic: aSymbol content: anObject
	"Purpose: sends and delivers IMMEDIATELY a message (with a topic and a content)
Arguments: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
			anObject = <anObject>
Example: self sendAsynchronouslyMsgTo: self myFriend topic  #wantToBuy content: aLand )"
	
	| aMsg |
	aMsg := Msg from: self to: anAgent topic: aSymbol.
	self channel transmit: aMsg! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendAsynchronouslyMsgToAll: aCollection topic: aSymbol
	"Purpose: sends and delivers IMMEDIATLY to many agents a same message (with a topic)
Arguments: aCollection =  <a collection of AgentComm or AgentCommLocation>
			aSymbol = <anObject>
Example: self sendAsynchronouslyMsgToAll: self acquaintances  topic  #hello)"
	
	| aMsg |
	aCollection
		do:
			[:anAgent | 
			aMsg := Msg from: self to: anAgent topic: aSymbol.
			self channel transmit: aMsg]! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendAsynchronouslyMsgToAll: aCollection topic: aSymbol content: anObject
	"Purpose: sends and delivers IMMEDIATLY to many agents a same message (with a topic and a content)
Arguments: anAgent = aCollection =  <a collection of AgentComm or AgentCommLocation>
			aSymbol = <anObject>
			anObject = <anObject>
Example: self sendAsynchronouslyMsgToAll: self acquaintances topic  #fireHere content: aCell )"
	
	| aMsg |
	aCollection
		do:
			[:anAgent | 
			aMsg := Msg from: self to: anAgent topic: aSymbol content: anObject.
			self channel transmit: aMsg]! !

!AgentComm methodsFor: '+ control' stamp: ' 26/3/15 15:24'!
sendMessageAsynchronously: aMsg
	"Purpose: sends and delivers IMMEDIATELY a given message
Argument: aMsg = <Msg>
Example: self sendMessageAsynchronously: (Msg to: self myFriend topic: #hello)"
	
	aMsg sender: self.
	self channel transmit: aMsg! !

!AgentComm methodsFor: '+ control' stamp: ' 26/3/15 15:24'!
sendMessageSynchronously: aMsg
	"Purpose: sends and delivers a given message at the end of the simulation timestep 
Argument: aMsg = <Msg>
Example: self sendMessageSynchronously: (Msg to: self myFriend topic  #hello)"
	
	aMsg sender: self.
	self channel stock: aMsg! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendSynchronouslyMsgTo: anAgent topic: aSymbol
	"Purpose: sends and delivers a message (with a topic) at the end of the simulation timestep 
Arguments: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
Example: self sendSynchronouslyMsgTo: self myFriend topic  #hello)"
	
	| aMsg |
	aMsg := Msg from: self to: anAgent topic: aSymbol.
	self channel stock: aMsg! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendSynchronouslyMsgTo: anAgent topic: aSymbol content: anObject
	"Purpose: sends and delivers  a message (with a topic and a content) at the end of the simulation timestep 
Arguments: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
			anObject = <anObject>
Example: self sendSynchronouslyMsgTo: self myFriend topic  #wantToBuy content: aLand )"
	
	| aMsg |
	aMsg := Msg from: self to: anAgent topic: aSymbol.
	self channel stock: aMsg! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendSynchronouslyMsgToAll: aCollection topic: aSymbol
	"Purpose: sends and delivers to many agents a same message (with a topic) at the end of the simulation timestep 
Arguments: aCollection =  <a collection of AgentComm or AgentCommLocation>
			aSymbol = <anObject>
Example: self sendSynchronouslyMsgToAll: self acquaintances  topic  #hello)"
	
	| aMsg |
	aCollection
		do:
			[:anAgent | 
			aMsg := Msg from: self to: anAgent topic: aSymbol.
			self channel stock: aMsg]! !

!AgentComm methodsFor: '+ control - communication' stamp: ' 26/3/15 15:24'!
sendSynchronouslyMsgToAll: aCollection topic: aSymbol content: anObject
	"Purpose: sends and delivers to many agents a same message (with a topic and a content) at the end of the simulation timestep 
Arguments: anAgent = aCollection =  <a collection of AgentComm or AgentCommLocation>
			aSymbol = <anObject>
			anObject = <anObject>
Example: self sendSynchronouslyMsgToAll: self acquaintances topic  #fireHere content: aCell )"
	
	| aMsg |
	aCollection
		do:
			[:anAgent | 
			aMsg := Msg from: self to: anAgent topic: aSymbol content: anObject.
			self channel stock: aMsg]! !

CMAgent subclass: #AgentLocation
	instanceVariableNames: 'patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!AgentLocation commentStamp: '<historical>' prior: 0!
Please note the following possible problems:
	In the description of ordre, type is not a class name.

Please note the following possible problems:
	The value of the class instance variable ordre is nil, which does not match the declared types >.

Instance Variables:
	patch	<SpatialEntity>  the location of the agent as a reference to a spatial entity. Symetrically, the spatial entity records the agents located there in its "theOccupants" attribute, a dictionary of collections of located entities.

Class Instance Variables:
	ordre	<type>  comment
!

!AgentLocation class methodsFor: '- testing' stamp: ' 26/3/15 15:45'!
isSituatedClass
	
	^true! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
aggregates: aClassOrClassName withinRadius: range
	"Purpose: returns an OrderedCollection of ComponentSpatialEntities (aggregate or not connex) located within a given radius of the current position of the agent.
Argument: range = <Integer>
Argument:  aClassOrClassName can be an entity class or the name of an entity <ByteSymbol>
Return value: <OrderedCollection(SpatialEntity) | nil>"
	
	^(self locationsWithinRadius: range) asOrderedCollection
		collect: [:c | c myCSE: aClassOrClassName]! !

!AgentLocation methodsFor: '- displaying' stamp: ' 26/3/15 15:45'!
center
	
	^patch isNil
		ifTrue: [nil]
		ifFalse: [patch center]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
colocatedEntities: locatedEntityName
	"Purpose: returns all entities (except the sender) of a given type located in the same location as the receiver. (all locatedEntityName subclasses are considered).
Argument: 	locatedEntityName = <Symbol | Class>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self colocatedEntities: #Predator"
	
	| collec |
	self patch ifNil: [^nil].
	collec := self patch occupantsAt: locatedEntityName.
	(collec includes: self) ifTrue: [collec remove: self].
	^collec! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
colocatedEntities: locatedEntityName verifying: aBlock
	"Purpose: returns all entities of a given type located in the same location as the receiver and verifying a specified condition.
Arguments: 	locatedEntityName = <Symbol | Class>
			aBlock = <BlockClosure>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self colocatedEntities: #Prey verifying: [:p | p isWeak]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[(self colocatedEntities: locatedEntityName) select: [:a | aBlock value: a]]! !

!AgentLocation methodsFor: '+ environment - picking - agents' stamp: 'SergeStinckwich 4/2/2015 20:40'!
colocatedEntity: locatedEntityName
	"Purpose: picks RANDOMLY one among the co-located entities of a given type. 
If none: returns nil; if more than one: random selection
Argument: aCondition = <BlockClosure>
Return value: <AgentLocation | ObjectLocation | nil>
Example: self colocatedEntity: #Prey"
	
	| candidates |
	candidates := self colocatedEntities: locatedEntityName.
	^(candidates isNil or: [candidates isEmpty])
		ifTrue: [nil]
		ifFalse: [Cormas selectRandomlyFrom: candidates]! !

!AgentLocation methodsFor: '+ environment - picking - agents' stamp: 'SergeStinckwich 4/2/2015 20:41'!
colocatedEntity: locatedEntityName verifying: aCondition
	"Purpose: picks RANDOMLY one among the co-located entities of a given type verifying a specified condition. 
If none: returns nil; if more than one: random selection
Argument: aCondition = <BlockClosure>
Return value: <AgentLocation | ObjectLocation | nil>
Example: self colocatedEntity: #Prey verifying: [:a | a isWeak]"
	
	| candidates |
	candidates := self colocatedEntities: locatedEntityName verifying:
			aCondition.
	^(candidates isNil or: [candidates isEmpty])
		ifTrue: [nil]
		ifFalse: [Cormas selectRandomlyFrom: candidates]! !

!AgentLocation methodsFor: '+ environment - picking - agents' stamp: 'SergeStinckwich 4/2/2015 20:41'!
colocatedSimilarAgent
	"Purpose: picks RANDOMLY one among the co-located receiver-like entities. 
If none: returns nil; if more than one: random selection
Return value: <AgentLocation | nil>"
	
	| candidates |
	candidates := self colocatedSimilarAgents.
	^(candidates isNil or: [candidates isEmpty])
		ifTrue: [nil]
		ifFalse: [Cormas selectRandomlyFrom: candidates]! !

!AgentLocation methodsFor: '+ environment - picking - agents' stamp: 'SergeStinckwich 4/2/2015 20:41'!
colocatedSimilarAgentVerifying: aCondition
	"Purpose: picks RANDOMLY one among the co-located receiver-like entities verifying a specified condition. 
If none: returns nil; if more than one: random selection
Argument: aCondition = <BlockClosure>
Return value: <AgentLocation | nil>
Example: self colocatedSimilarAgentVerifying: [:a | a sex ~= self sex]"
	
	| candidates |
	candidates := self colocatedSimilarAgentsVerifying: aCondition.
	^(candidates isNil or: [candidates isEmpty])
		ifTrue: [nil]
		ifFalse: [Cormas selectRandomlyFrom: candidates]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
colocatedSimilarAgents
	"Purpose: returns all receiver-like entities located in the same location as the receiver.
Return value: <Collection(AgentLocation)>"
	
	^self colocatedEntities: self class! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
colocatedSimilarAgentsVerifying: aBlock
	"Purpose: returns all receiver-like entities located in the same location as the receiver and verifying a specified condition.
Argument: aBlock = <BlockClosure>
Return value: <Collection(AgentLocation)>
Example: self colocatedSimilarAgentsVerifying: [:a | a sex ~= self sex] "
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self colocatedSimilarAgents select: [:a | aBlock value: a]]! !

!AgentLocation methodsFor: 'star control' stamp: 'SergeStinckwich 6/3/2015 09:20'!
delete
"Purpose: gets rid of this object. The collectGarbage is IMMEDIATELY performed  (ie. the receiver of class X is removed from 'theXXXs' collection)"

	self leave.
	super delete! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
displayOn: aGC
	
	self halt.
	self
		displayOn: aGC
		at: self center! !

!AgentLocation methodsFor: '+ environment - distance' stamp: ' 26/3/15 15:45'!
distanceTo: aSpatialEntityOrSituatedEntity
	"Purpose: returns the Manhattan distance (in cells) between the patch of the agent and aSpatialEntityOrSituatedEntity
If it is the distance to a situatedEntity, returrns the distance to the patch of this entity.
Argument: aSpatialEntityOrSituatedEntity = <SpatialEntity> or <AgentLocation> or <ObjectLocation>
Return value: <Integer>"
	
	self isSituated ifFalse: [^nil].
	aSpatialEntityOrSituatedEntity isSituated
		ifTrue: [^self patch distanceTo: aSpatialEntityOrSituatedEntity patch].
	aSpatialEntityOrSituatedEntity isSpatialEntity
		ifTrue: [^self patch distanceTo: aSpatialEntityOrSituatedEntity]! !

!AgentLocation methodsFor: '+ testing' stamp: ' 26/3/15 15:45'!
isClassLocation
	"Answer if the entity is a kind of AgentLocation or of ObjectLocation"
	
	^true! !

!AgentLocation methodsFor: 'star testing' stamp: 'SergeStinckwich 6/3/2015 09:22'!
isSituated
"Purpose: tests the location somewhere in the spatial grid"
	^patch notNil! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
leave
"Purpose: moves the agent away from the spatial grid (sets his patch attribute to nil): the situated agent is not located any more, but it is still 'alive'  "
	self leaveWhileMoving: false.! !

!AgentLocation methodsFor: '- moving' stamp: ' 26/3/15 15:45'!
leaveWhileMoving: isMoving
	"isMoving = <Boolean>"
	
	self patch isNil ifTrue: [^self].
	isMoving
		ifFalse:
			["The situated agent doesn't move; it is not located any more. But it is still 'alive'  "
			self currentSimulation spaceModel ifNil: [^nil].
			self currentSimulation spaceModel logLeaveOf: self from: patch.
			self currentSimulation
				registerEntityChange: #leavingOccupant
				from: (EntityReference on: self)].
	(self patch theOccupants at: self class name)
		remove: self
		ifAbsent: [].
	self patch: nil! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
locatedEntities: locatedEntityName verifying: aBlock withinRadius: range
	"Purpose: returns all located entities of a given type withing a given radius of the current location and fulfilling a specified contraint.
Arguments: 	locatedEntityName = <Symbol | Class>
			aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self locatedEntities: #Predator verifying: [:a | a isHungry] withinRadius: self perceptionRangePredators"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[(self locatedEntities: locatedEntityName withinRadius: range)
				select: [:a | aBlock value: a]]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
locatedEntities: locatedEntityName withinRadius: range
	"Purpose: returns all located entities of a given type withing a given radius of the current location (all locatedEntityName subclasses are considered).
Arguments: 	locatedEntityName = <Symbol | Class>
			range = <Integer>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self locatedEntities: #Predator withinRadius: self perceptionRangePredators"
	
	| collec |
	self patch ifNil: [^nil].
	collec := OrderedCollection new.
	(self locationsWithinRadius: range)
		do: [:c | collec addAll: (c occupantsAt: locatedEntityName)].
	(collec includes: self) ifTrue: [collec remove: self].
	^collec! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
locationsVerifying: aBlock withinRadius: range
	"Purpose: returns the spatial entities within a given radius of the receiver current location and verifying the condition specified in aBlock. 
The current location is considered
Arguments: 	aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self locationsVerifying: [:c | c isClosed not] withinRadius: 5"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch recursiveNeighbourhood: range verifying: aBlock]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
locationsWithinRadius: range
	"Purpose: returns a collection a cells within a given radius of the current position
The current location is considered
Argument: range = <Integer>
Return value: <Collection(SpatialEntity) | nil>"
	
	^self patch isNil
		ifTrue: [#()]
		ifFalse: [self patch recursiveNeighbourhood: range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
locationsWithoutAny: locatedEntityName withinRadius: range
	"Purpose: returns the spatial entities in a given range without any occupant of a given type. 
The current location is considered
Arguments: 	locatedEntityName = <Symbol | Class>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self locationsWithoutAny: Predator withinRadius: self perceptionRangePredators"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch recursiveNeighbourhood: range withoutAny: locatedEntityName]! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
menu
	
	| aMenuBuilder |
	self halt.
	aMenuBuilder := MenuBuilder new.
	aMenuBuilder add: 'Edition' -> [self inspect].
	^aMenuBuilder menu! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
moveAndTrackTo: aPatch
	"Move to aPatch and display a line from origin center to aPatch center"
	"Deprecated"
	
	self moveTo: aPatch! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveE
"Purpose: moves eastward if neighbourE exists (raster grid), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourE notNil])
		ifTrue: [self moveTo: self patch neighbourE]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveN
"Purpose: moves northward if neighbourN exists (raster grid with square cells), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourN notNil])
		ifTrue: [self moveTo: self patch neighbourN]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveNE
"Purpose: moves northeastward if neighbourNE exists (raster grid with hexagons or 8-neighbours squares), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourNE notNil])
		ifTrue: [self moveTo: self patch neighbourNE]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveNW
"Purpose: moves northwestward if neighbourNW exists (raster grid with hexagons or 8-neighbours squares), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourNW notNil])
		ifTrue: [self moveTo: self patch neighbourNW]! !

!AgentLocation methodsFor: '+ moving' stamp: ' 26/3/15 15:45'!
moveNcells: n towards: aCell
	"Purpose: moves n cells in direction of a given location.
Argument: aCell = <SpatialEntityElement>
n = <positive Integer>
Example: self moveNcells: 5 towards: self house patch"
	
	| path |
	self isSituated
		ifTrue:
			[self patch = aCell
				ifFalse:
					[path := self patch wayTo: aCell.
					path size < n
						ifTrue: [self moveTo: aCell]
						ifFalse: [self moveTo: (path at: n)]]]! !

!AgentLocation methodsFor: '+ moving' stamp: ' 26/3/15 15:45'!
moveNcells: n towards: aCell constraintOnPath: aBlock
	"Purpose: moves n cells in direction of a given location, taking a specified constraint on each cell of the path to destination.
Argument: aCell = <SpatialEntityElement>
n = <positive Integer>
Example: self moveNcells: 3 towards: self house patch constraintOnPath: [:c | c isClosed not]"
	
	| path |
	self isSituated
		ifTrue:
			[self patch = aCell
				ifFalse:
					[path := self patch wayTo: aCell constraint: aBlock.
					path size < n
						ifTrue: [self moveTo: aCell]
						ifFalse: [self moveTo: (path at: n)]]]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveS
"Purpose: moves southward if neighbourS exists (raster grid with square cells), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourS notNil])
		ifTrue: [self moveTo: self patch neighbourS]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveSE
"Purpose: moves southeastward if neighbourSE exists (raster grid with hexagons or 8-neighbours squares), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourSE notNil])
		ifTrue: [self moveTo: self patch neighbourSE]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveSW
"Purpose: moves southwestward if neighbourSW exists (raster grid with hexagons or 8-neighbours squares), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourSW notNil])
		ifTrue: [self moveTo: self patch neighbourSW]! !

!AgentLocation methodsFor: '+ moving' stamp: 'nbecu 6/3/2015 09:55'!
moveTo: aSpatialEntity
	"Purpose: moves to a given location.
Argument: aSpatialEntity = <SpatialEntity>
Example: self moveTo: self patch neighbourN"
	
	| alreadySituated |
	aSpatialEntity isSpatialEntity ifFalse: [^nil].
	alreadySituated := self isSituated.	"Log the movement"	"aSpatialEntity spaceModel 
		logMovementOf: self
		from: patch
		to: aSpatialEntity.   temporary inactivated"
	self leaveWhileMoving: true.
	self patch: aSpatialEntity.
	(self patch occupants: self class name) add: self.
	"alreadySituated
		ifFalse:
			[""the agent is arriving on the grid for the first time, the SpaceInterfaces should be aware""
			self currentSimulation
				registerEntityChange: #newOccupant
				with: (EntityReference on: aSpatialEntity)
				from: (EntityReference on: self)]
		ifTrue:
			[self currentSimulation
				registerEntityChange: #movingOccupant
				with: (EntityReference on: aSpatialEntity)
				from: (EntityReference on: self)]"! !

!AgentLocation methodsFor: '+ moving' stamp: ' 26/3/15 15:45'!
moveTowards: aCell
	"Purpose: moves one cell in direction of a given location.
Argument: aCell = <SpatialEntityElement>
Example: self moveTowards: self house patch"
	
	self isSituated
		ifTrue:
			[self patch = aCell ifFalse: [self moveTo: (self patch wayTo: aCell) first]]! !

!AgentLocation methodsFor: '+ moving' stamp: ' 26/3/15 15:45'!
moveTowards: aCell constraintOnPath: aBlock
	"Purpose: moves one cell in direction of a given location, taking a specified constraint on each cell of the path to destination.
Argument: aCell = <SpatialEntityElement>
Example: self moveTowards: self house patch constraintOnPath: [:c | c isClosed not]"
	
	self isSituated
		ifTrue:
			[self patch = aCell
				ifFalse:
					[self moveTo: (self patch wayTo: aCell constraint: aBlock) first]]! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
moveW
"Purpose: moves westward if neighbourW exists (raster grid), do not move otherwise"
	
	(self patch notNil and: [self patch neighbourW notNil])
		ifTrue: [self moveTo: self patch neighbourW]! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestEmptyLocation
	"Purpose: returns the nearest spatial entity with no occupant of any kind. 
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Return value: <SpatialEntity | nil>"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestEmptyCell]! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
nearestEmptyLocation: range
	"DEPRECATED"
	
	^self nearestEmptyLocationWithinRadius: range! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestEmptyLocationWithinRadius: range
	"Purpose: returns the nearest spatial entity within a given radius of the current location and with no occupant of any kind. 
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Argument: range = <Integer>
Return value: <SpatialEntity | nil>"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestEmptyNeighborWithinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestEmptyLocations
	"Purpose: returns the nearest spatial entities with no occupant of any kind.
The current location is NOT considered
Return value: <Collection(SpatialEntity) | nil>"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestEmptyCells]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestEmptyLocationsWithinRadius: range
	"Purpose: returns the nearest spatial entities with no occupant of any kind and within a given radius of the current location.
The current location is NOT considered
Argument: range = <Integer>
Return value: <Collection(SpatialEntity) | nil>"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestEmptyNeighborsWithinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
nearestLocatedEntities: locatedEntityName verifying: aBlock withinRadius: range
	"Purpose: returns the nearest located entities of a given type withing a given radius of the current location and fulfilling a specified contraint.
Arguments: 	locatedEntityName = <Symbol | Class>
			aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(AgentLocation | ObjectLocation) | nil>
Example: self nearestLocatedEntities: #Predator verifying: [:a | a isHungry] withinRadius: self perceptionRangePredators"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[(self nearestLocatedEntities: locatedEntityName withinRadius: range)
				select: [:e | aBlock value: e]]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
nearestLocatedEntities: locatedEntityName withinRadius: range
	"Purpose: returns the nearest located entities of a given type withing a given radius of the current location.
Arguments: 	locatedEntityName = <Symbol | Class>
			range = <Integer>
Return value: <Collection(AgentLocation | ObjectLocation) | nil>
Example: self nearestLocatedEntities: #Predator withinRadius: self perceptionRangePredators"
	
	| entities n |
	self patch ifNil: [^nil].
	entities := OrderedCollection new.
	n := 0.
	[entities isEmpty and: [n <= range]]
		whileTrue:
			[entities := self locatedEntities: locatedEntityName withinRadius: n.
			n := n + 1].
	^entities! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestLocationVerifying: aBlock
	"Purpose: returns the nearest spatial entity fulfilling the constraint specified in aBlock. 
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Return value: <SpatialEntity | nil>
Example: self nearestLocationVerifying: [:c | c isClosed not]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestCellVerifying: aBlock]! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestLocationVerifying: aBlock withinRadius: range
	"Purpose: returns the nearest spatial entity within a given radius of the current location and fulfilling the constraint specified in aBlock. 
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Arguments: 	aBlock = <BlockClosure>
			range = <Integer>
Return value: <SpatialEntity | nil>
Example: self nearestLocationVerifying: [:c | c isClosed not] withinRadius: 5"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborVerifying: aBlock withinRadius: range]! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestLocationWithoutAny: locatedEntityName
	"Purpose: returns the nearest spatial entity without any occupant of a given type.
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Arguments: locatedEntityName = <Symbol | Class>
Return value: <SpatialEntityElement | nil>
Example: self nearestLocationWithoutAny: #Predator"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestCellWithoutAny: locatedEntityName]! !

!AgentLocation methodsFor: '+ environment - picking - space' stamp: ' 26/3/15 15:45'!
nearestLocationWithoutAny: locatedEntityName withinRadius: range
	"Purpose: returns the nearest spatial entity in a given range without any occupant of a given type. 
The current location is NOT considered
If none: returns nil; if more than one at the minimum radius: random selection
Arguments: 	locatedEntityName = <Symbol | Class>
			range = <Integer>
Return value: <SpatialEntity | nil>
Example: self nearestLocationWithoutAny: #Predator withinRadius: self perceptionRangePredators "
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborWithoutAny: locatedEntityName withinRadius:
					range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsVerifying: aBlock
	"Purpose: returns the nearest spatial entities fulfilling the constraint specified in aBlock.
The current location is NOT considered
Return value: <Collection(SpatialEntity) | nil>
Example: self nearestLocationsVerifying: [:c | c isClosed not]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestCellsVerifying: aBlock]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsVerifying: aCondition withMaxOf: aMagnitudeName withinRadius: range
	"Purpose: returns the nearest spatial entities within a given radius of the current location with the maximum value of a given magnitude and verifying a specified condition . 
The current location is NOT considered
Arguments: aMagnitudeName = <ByteSymbol>
			aCondition = <BlockClosure>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self nearestLocationsWithMaxOf: #water verifying: [:c | c isPolluted not] withinRadius: 5"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborsVerifying: aCondition withMaxOf: aMagnitudeName
				withinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsVerifying: aBlock withinRadius: range
	"Purpose: returns the nearest spatial entities within a given radius of the current location and fulfilling the constraint specified in aBlock. 
The current location is NOT considered
Arguments: aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self nearestLocationsVerifying: [:c | c isClosed not] withinRadius: 5"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborsVerifying: aBlock withinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsWithMaxOf: aMagnitudeName withinRadius: range
	"Purpose: returns the nearest spatial entities within a given radius of the current location with the maximum value of a given magnitude. 
The current location is NOT considered
Arguments: aMagnitudeName = <ByteSymbol>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self nearestLocationsWithMaxOf: #water verifying: [:c | c isPolluted not] withinRadius: 5"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborsWithMaxOf: aMagnitudeName withinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsWithoutAny: locatedEntityName
	"Purpose: returns the nearest spatial entities without any occupant of a given type.
The current location is NOT considered
Arguments: locatedEntityName = <Symbol | Class>
Return value: <Collection(SpatialEntityElement) | nil>
Example: self nearestLocationsWithoutAny: #Predator"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch nearestCellsWithoutAny: locatedEntityName]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
nearestLocationsWithoutAny: locatedEntityName withinRadius: range
	"Purpose: returns the nearest spatial entity in a given range without any occupant of a given type. 
The current location is NOT considered
Arguments: 	locatedEntityName = <Symbol | Class>
			range = <Integer>
Return value: <Collection(SpatialEntity) | nil>
Example: self nearestLocationsWithoutAny: #Predator withinRadius: self perceptionRangePredators "
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self patch nearestNeighborsWithoutAny: locatedEntityName withinRadius:
					range]! !

!AgentLocation methodsFor: '+ environment - picking - agents' stamp: 'SergeStinckwich 4/2/2015 20:43'!
nearestSimilarAgentWithingRadius: range
	"Purpose: picks RANDOMLY one among the nearest receiver-like entities located withing a given radius of the receiver current location.
If none: returns nil; if more than one: random selection
Argument: 	range = <Integer>
Return value: <AgentLocation | nil>
Example: self nearestSimilarAgentWithinRadius: 2"
	
	| candidates |
	candidates := self nearestSimilarAgentsWithinRadius: range.
	^(candidates isNil or: [candidates isEmpty])
		ifTrue: [nil]
		ifFalse: [Cormas selectRandomlyFrom: candidates]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
nearestSimilarAgentsVerifying: aBlock withinRadius: range
	"Purpose: returns the nearest receiver-like instances located withing a given radius of the receiver location and fulfilling a specified constraint
Arguments: aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(AgentLocation)>
Example: self nearestSimilarAgentsVerifying: [:a | a sex ~= self sex] withinRadius: self pheromonePerceptionRange"
	
	^self
		nearestLocatedEntities: self class name
		verifying: aBlock
		withinRadius: range! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
nearestSimilarAgentsWithinRadius: range
	"Purpose: returns the nearest receiver-like entities located withing a given radius of the receiver current location.
Argument: 	lrange = <Integer>
Return value: <Collection(AgentLocation) | nil>
Example: self nearestSimilarAgentsWithinRadius: 2"
	
	^self
		nearestLocatedEntities: self class name
		withinRadius: range! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
neighboringLocations
	"Purpose: return direct neighbours of current location
The current location is NOT considered
Return value: <Collection(SpatialEntity) | nil>"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch neighbourhood]! !

!AgentLocation methodsFor: '+ environment - sensing - space' stamp: ' 26/3/15 15:45'!
neighboringLocationsVerifying: aBlock
	"Purpose: returns direct neighbours of current location fulfilling the constraint specified in aBlock. 
The current location is NOT considered
Argument: aBlock = <BlockClosure>
Return value: <Collection(SpatialEntity) | nil>
Example: self neighboringLocationsVerifying: [:c | c isClosed not]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse: [self patch neighbourhood select: [:c | aBlock value: c]]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
neighbouringLocatedEntities: locatedEntityName
	"Purpose: returns all entities of a given type located in the direct neighbourhood of the receiver current location.
The co-located entities are not considered here (for that, use locatedEntities: locatedEntityName withinRadius: 1)
Arguments: 	locatedEntityName = <Symbol | Class>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self neighbouringLocatedEntities: #Predator"
	
	| collec |
	self patch ifNil: [^nil].
	collec := OrderedCollection new.
	self patch neighbourhood
		do: [:c | collec addAll: (c occupantsAt: locatedEntityName)].
	^collec! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
neighbouringLocatedEntities: locatedEntityName verifying: aCondition
	"Purpose: returns all entities of a given type located in the direct neighbourhood of the receiver current location and verifying a specified condition.
The co-located entities are not considered here (for that, use locatedEntities: locatedEntityName verifying: aCondition withinRadius: 1)
Arguments: 	locatedEntityName = <Symbol | Class>
			aCondition = <BlockClosure>
Return value: <Collection(AgentLocation | ObjectLocation)>
Example: self neighbouringLocatedEntities: #Prey verifying: [:p | p isWeak]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[(self neighbouringLocatedEntities: locatedEntityName)
				select: [:e | aCondition value: e]]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
neighbouringSimilarAgents
	"Purpose: returns all receiver-like entities located in the direct neighbourhood of the receiver current location.
The co-located entities are not considered here (#neighbouringSimilarAgents is equivalent to #similarAgentsWithinRadius: 1)
Return value: <Collection(AgentLocation)>"
	
	^self neighbouringLocatedEntities: self class name! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
neighbouringSimilarAgentsVerifying: aCondition
	"Purpose: returns all receiver-like entities located in the direct neighbourhood of the receiver current location and verifying a specified condition.
The co-located entities are not considered here (#neighbouringSimilarAgentsVerifying: aCondition is equivalent to #similarAgentsVerifying: aCondition withinRadius: 1)
Argument: aCondition = <BlockClosure>
Return value: <Collection(AgentLocation)>
Example: self neighbouringSimilarAgentsVerifying: [:a | a sex ~= self sex]"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self neighbouringSimilarAgents select: [:e | aCondition value: e]]! !

!AgentLocation methodsFor: '+ accessing' stamp: ' 26/3/15 15:45'!
patch
	
	^patch! !

!AgentLocation methodsFor: '+ accessing' stamp: ' 26/3/15 15:45'!
patch: unPatch
	
	patch := unPatch! !

!AgentLocation methodsFor: '+ accessing' stamp: ' 26/3/15 15:45'!
patchID
	"Purpose: returns ID of patch
Return value: <Integer>"
	
	self patch ifNil: [^0].
	^self patch id! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
perceivedCellsWithinRange: anInteger
	"DEPRECATED"
	
	^self locationsWithinRadius: anInteger! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
perceivedEntities: locatedEntityName withinRange: range
	"DEPRECATED"
	
	^self locatedEntities: locatedEntityName withinRadius: range! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
perceivedSimilarAgentsWithinRange: aRayon
	"DEPRECATED"
	
	^self similarAgentsWithinRadius: aRayon! !

!AgentLocation methodsFor: '- deprecated' stamp: ' 26/3/15 15:45'!
perception: aRayon
	"Return a collection of cells belonging to aRayon (it contains also its current patch)"
	
	^self locationsWithinRadius: aRayon! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:21'!
randomJump
"Purpose: moves to a spatial entity randomly picked from the whole grid "

	"patch ifNil: [^nil]."
	self moveTo: (Cormas selectRandomlyFrom: patch grid)! !

!AgentLocation methodsFor: 'star moving' stamp: 'SergeStinckwich 6/3/2015 09:22'!
randomWalk
"Purpose: moves to a spatial entity randomly picked from the direct neighbourhood (relative distance = 1) of the current location "
| destination |
	patch ifNil: [^nil].
	( patch neighbourhood isNil or: [ patch neighbourhood isEmpty])
		ifTrue: [self halt].
	destination := Cormas selectRandomlyFrom: patch neighbourhood.
	self moveTo: destination! !

!AgentLocation methodsFor: '+ moving' stamp: 'SergeStinckwich 4/2/2015 20:39'!
randomWalk: radius
	"Purpose: moves to aSpatialEntityElement randomly picked among a radius.
Argument: radius = <positive Integer>
Example: self randomWalk: 2 "
	
	self
		moveTo:
			(Cormas selectRandomlyFrom: (self patch recursiveNeighbourhood: radius))! !

!AgentLocation methodsFor: '+ moving' stamp: 'SergeStinckwich 4/2/2015 20:39'!
randomWalkConstrainedBy: aBlock
	"Purpose: moves to aSpatialEntityElement randomly picked among the direct neighbours (relative distance = 1) fulfilling the constraint specified in aBlock. 
If there is no neighbouring cells fulfilling the constraint, the agent does not move.
Argument: aBlock = <BlockClosure>
Example: self randomWalkConstrainedBy: [:c | c noOccupant]"
	
	| destination destinations |
	patch ifNil: [^nil].
	destinations := patch neighbourhood select: [:c | aBlock value: c].
	destinations isEmpty
		ifFalse:
			[destination := Cormas selectRandomlyFrom: destinations.
			self moveTo: destination]! !

!AgentLocation methodsFor: '- utilities - binary storage' stamp: ' 26/3/15 15:45'!
representBinaryOn33: aBOSSWriter
	"This method is called from CormasModel #saveBOS: aCollection into: aFileName to save a collection of agents using BOSS. Thus, each class to be saved must redefine this method.
The basic approach is to create an instance method named representBinaryOn: in the class whose BOSS representation you want to customize. The method typically returns a MessageSend, which is created by sending a receiver:selector:arguments: message to that class. The receiver argument identifies the class that is to create an instance, typically the object's class. The selector argument is the name of the instance-creation method that is to be used when the data is read by BOSS. The arguments argument is a collection of data values, typically the values of the object's instance variables.
Exemple of redefinition: we want to save the attributs 'name' and 'cashbox' of an agent :
representBinaryOn: aBOSSWriter
	| msg | 
	msg := super representBinaryOn: aBOSSWriter.
	msg arguments first add: self name; add: self cashbox.
	^msg

To load Boss object, boss will call a class method: #newBoss:. 
To redefine newBoss: it could be as following:
newBoss: attributList 
	| ag |
	ag := super newBoss: (attributList copyFrom: 1 to: 3).
	3 timesRepeat: [attributList removeFirst].
	attributList with: #(#name: #cashbox:)
		do: [:array1Element :array2Element | ag perform: array2Element with: array1Element].
"
	
	| msg |
	msg := super representBinaryOn: aBOSSWriter.
	self patch isNil
		ifTrue: [msg arguments first add: nil]
		ifFalse: [msg arguments first add: self patch id].
	^msg! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
similarAgentsVerifying: aBlock withinRadius: range
	"Purpose: returns the receiver-like instances located withing a given radius of the receiver location and fulfilling a specified constraint
Arguments: aBlock = <BlockClosure>
			range = <Integer>
Return value: <Collection(AgentLocation)>
Example: self similarAgentsVerifying: [:a | a sex ~= self sex] withinRadius: self pheromonePerceptionRange"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self
				locatedEntities: self class name
				verifying: aBlock
				withinRadius: range]! !

!AgentLocation methodsFor: '+ environment - sensing - agents' stamp: ' 26/3/15 15:45'!
similarAgentsWithinRadius: range
	"Purpose: returns the receiver-like instances located withing a given radius of the receiver location
Argument: range = <Integer>
Return value: <Collection(AgentLocation)>
Example: self similarAgentsWithinRadius: 3"
	
	^self patch isNil
		ifTrue: [nil]
		ifFalse:
			[self
				locatedEntities: self class name
				withinRadius: range]! !

!AgentLocation methodsFor: '+ moving' stamp: 'SergeStinckwich 4/2/2015 20:39'!
walkToMaxOf: aSymbol
	"Purpose: moves to the spatial entity in the direct neighbourhood (relative distance = 1) with the higher value for a given magnitude.
In case several destinations share the same maximum value, the tie is randomly broken.
Argument: aSymbol = <Symbol>, most commoly the name of an attribute, it can also be the name of any function returning a magniture
Example: self walkToMaxOf: #sugar"
	
	| destination destinations |
	destinations := self patch neighbourhood
		select: [:c | (c perform: aSymbol) respondsTo: #>].
	destinations isEmpty
		ifFalse:
			[destinations := self patch neighbourhood
				asSortedCollection:
					[:i :j | (i perform: aSymbol) > (j perform: aSymbol)].
			destinations := destinations
				select:
					[:c | (c perform: aSymbol) = (destinations first perform: aSymbol)].
			destination := Cormas selectRandomlyFrom: destinations.
			self moveTo: destination]! !

!AgentLocation methodsFor: '+ moving' stamp: 'SergeStinckwich 4/2/2015 20:39'!
walkToMaxOf: aSymbol constrainedBy: aBlock
	"Purpose: moves to the spatial entity in the direct neighbourhood (relative distance = 1) with the higher value for a given magnitude and fulfilling the constraint specified in aBlock.
In case several possible destinations share the same maximum value, the tie is randomly broken.
Arguments:	aSymbol = <Symbol>, most commoly the name of an attribute, it can also be the name of any function returning a magniture
			aBlock = <BlockClosure>
Example: self walkToMaxOf: #sugar constrainedBy: [:c | c noOccupant]"
	
	| destination destinations |
	destinations := self patch neighbourhood
		select:
			[:c | ((c perform: aSymbol) respondsTo: #>) and: [aBlock value: c]].
	destinations isEmpty
		ifFalse:
			[destinations := destinations
				asSortedCollection:
					[:i :j | (i perform: aSymbol) > (j perform: aSymbol)].
			destinations := destinations
				select:
					[:c | (c perform: aSymbol) = (destinations first perform: aSymbol)].
			destination := Cormas selectRandomlyFrom: destinations.
			self moveTo: destination]! !

Object subclass: #Channel
	instanceVariableNames: 'population listeFonctionObs messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!Channel commentStamp: '<historical>' prior: 0!
Channel is the object in charge of receiving the messages from a sender and deliver them to the receivers. They can be delivered synchronously ( sent immediately) or asynchronousley (they are stored in the messages collection)

Instance Variables:
	listeFonctionObs	<(Collection of: FonctionObs)>	In Cormas there is an interface to observe the exchanges of messages.  Instances of object FonctionObs is in charge of establishing a linkage between the Chaneel and the interface
. 	messages	<(Collection of: (LensAbsentee | Object))>	a collection of messages
	population	<LensAbsentee | Object>	the population of agents registered. Automatically any instace of AgentComm, GroupComm, AgentCommLocation and GroupCommLocation is registered.

Methods

stock: will record the receiving argument which is supposed to be an instance of subclass of Msg in the
messages attribute.
transmit: will immediately deliver the message to the receiver of the message. 
flush will transmit the set of messages in the message collection to the receivers.!

!Channel class methodsFor: 'instance creation' stamp: ' 26/3/15 16:15'!
new
	
	^super new initialize! !

!Channel methodsFor: 'observer' stamp: ' 26/3/15 16:15'!
addFonctionObs: uneFObs
	
	uneFObs addCanal: self.
	listeFonctionObs add: uneFObs! !

!Channel methodsFor: 'procedures' stamp: ' 26/3/15 16:15'!
flush
	"flush will transmit the set of messages in the message collection to the receivers."
	
	self messages do: [:a | self transmit: a].
	messages := OrderedCollection new! !

!Channel methodsFor: 'initialization' stamp: ' 26/3/15 16:15'!
initialize
	
	listeFonctionObs := OrderedCollection new.
	messages := OrderedCollection new! !

!Channel methodsFor: 'accessing' stamp: ' 26/3/15 16:15'!
listeFonctionObs
	
	^listeFonctionObs! !

!Channel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 12:04'!
messages
	^ messages! !

!Channel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 12:05'!
population
	^ population! !

!Channel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 12:05'!
population: anArray
	
	population := anArray.
	listeFonctionObs do: [:fobs | fobs populationSource: anArray]! !

!Channel methodsFor: 'observer' stamp: ' 26/3/15 16:15'!
removeFonctionObs: uneFObs
	
	listeFonctionObs isEmpty ifFalse: [listeFonctionObs remove: uneFObs]! !

!Channel methodsFor: 'procedures' stamp: ' 26/3/15 16:15'!
stock: aMsg
	"will record the receiving argument which is supposed to be an instance of subclass of Msg in the
messages attribute."
	
	self messages add: aMsg! !

!Channel methodsFor: 'procedures' stamp: ' 26/3/15 16:15'!
transmit: aMsg
	"will immediately deliver the message to the receiver of the message. "
	
	aMsg receiver messageFromChannel: aMsg.
	listeFonctionObs do: [:fobs | fobs message: aMsg]! !

Object subclass: #ClassManipulationMethod
	instanceVariableNames: 'targetClass methodName isControl isTesting isInit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ClassManipulationMethod methodsFor: 'As yet unclassified' stamp: ' 26/3/15 16:22'!
classNameAsString
	
	^self targetClass name asString! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isControl
	
	^isControl! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isControl: anObject
	
	isControl := anObject! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isInit
	
	^isInit! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isInit: anObject
	
	isInit := anObject! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isTesting
	
	^isTesting! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
isTesting: anObject
	
	isTesting := anObject! !

!ClassManipulationMethod methodsFor: 'As yet unclassified' stamp: ' 26/3/15 16:22'!
methodAsString
	
	^self methodName! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
methodName
	
	^methodName! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
methodName: anObject
	
	methodName := anObject! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
targetClass
	
	^targetClass! !

!ClassManipulationMethod methodsFor: 'accessing' stamp: ' 26/3/15 16:22'!
targetClass: anObject
	
	targetClass := anObject! !

Object subclass: #CommentInterface
	instanceVariableNames: 'modelName creationDate modelComments authorMailList selectedRow authorName cormasComments previousComments newComments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!CommentInterface commentStamp: '<historical>' prior: 0!
CommentInterface is an interface to add some Comments to Cormas versions or to Model versions.

Instance Variables:
	authorMailList	<SelectionInList>	description of authorMailList
	authorName	<ValueHolder>	description of authorName
	cormasComments	<ValueHolder>	description of cormasComments
	creationDate	<ValueHolder>	description of creationDate
	modelComments	<ValueHolder>	description of modelComments
	modelName	<ValueHolder>	description of modelName
	newComments	<ValueHolder>	description of newComments
	previousComments	<ValueHolder>	description of previousComments
	selectedRow	<ValueModel>	description of selectedRow

!

!CommentInterface class methodsFor: 'interface specs' stamp: ' 26/3/15 16:27'!
commentsCormasWindow
	"Tools.UIPainter new openOnClass: self andSelector: #commentsCormasWindow"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Cormas Version Comments' 
			#min: #(Point 651 411) 
			#max: #(Point 651 411) 
			#bounds: #(Rectangle 719 449 1370 860) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 8191 8191 6479)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(LabelSpec 
				#layout: #(Point 9 10) 
				#name: #Label3 
				#label: 'Cormas Versions' 
				#style: #large) #(ActionButtonSpec 
				#layout: #(Rectangle 303 371 375 397) 
				#name: #CormasVersionOk 
				#isOpaque: true 
				#model: #closeRequest 
				#label: 'OK' 
				#defaultable: true) #(InputFieldSpec 
				#layout: #(Rectangle 339 12 502 35) 
				#name: #InputField1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #authorName 
				#isReadOnly: false) #(TextEditorSpec 
				#layout: #(Rectangle 15 82 633 362) 
				#name: #TextEditor3 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #cormasComments 
				#helpText: 'Write here the comments and purpose of this new version of Cormas' 
				#tabRequiresControl: true) #(LabelSpec 
				#layout: #(Point 223 15) 
				#name: #DeveloperName 
				#label: 'Developer''s Name') #(LabelSpec 
				#layout: #(Point 16 57) 
				#name: #Label1 
				#label: 'Some comments on this Cormas version'))))! !

!CommentInterface class methodsFor: 'interface specs' stamp: ' 26/3/15 16:27'!
commentsModelWindow
	"Tools.UIPainter new openOnClass: self andSelector: #commentsModelWindow"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Model Version Comments' 
			#min: #(Point 651 411) 
			#max: #(Point 651 411) 
			#bounds: #(Rectangle 720 450 1364 861) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 8191 8191 6479)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(LabelSpec 
				#layout: #(Point 15 6) 
				#name: #Label3 
				#label: 'Model Versions' 
				#style: #large) #(ActionButtonSpec 
				#layout: #(Rectangle 213 383 316 409) 
				#name: #CormasVersionOk 
				#isOpaque: true 
				#model: #closeAccept 
				#label: 'Add comments' 
				#defaultable: true) #(InputFieldSpec 
				#layout: #(Rectangle 345 6.5 508 29.5) 
				#name: #InputField1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #authorName 
				#isReadOnly: false) #(TextEditorSpec 
				#layout: #(Rectangle 15 214 632 379) 
				#name: #TextEditor3 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue #white)) 
				#model: #newComments 
				#helpText: 'Write here the comments and purpose of this new version of Cormas' 
				#tabRequiresControl: true) #(LabelSpec 
				#layout: #(Point 229 9) 
				#name: #DeveloperName 
				#label: 'Developer''s Name') #(LabelSpec 
				#layout: #(Point 16 35) 
				#name: #Label1 
				#label: 'Previous versions'' comments') #(ActionButtonSpec 
				#layout: #(Rectangle 355 383 458 409) 
				#name: #ActionButton2 
				#model: #closeCancel 
				#label: 'No comment' 
				#defaultable: true) #(TextEditorSpec 
				#layout: #(Rectangle 15 52 632 192) 
				#name: #TextEditor1 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 7044 7044 7044)) 
				#model: #previousComments 
				#tabRequiresControl: true) #(LabelSpec 
				#layout: #(Point 16 196) 
				#name: #Label2 
				#label: 'Some comments on this version'))))! !

!CommentInterface class methodsFor: 'interface specs' stamp: ' 26/3/15 16:27'!
commentsWindow
	"Tools.UIPainter new openOnClass: self andSelector: #commentsWindow"
	
	<resource: #canvas>
	^#(FullSpec 
		#window: #(WindowSpec 
			#label: 'Model Comments' 
			#min: #(Point 651 411) 
			#max: #(Point 651 411) 
			#bounds: #(Rectangle 373 357 1024 768) 
			#colors: #(LookPreferences 
				#setBackgroundColor: #(ColorValue 8191 8191 6479)) 
			#isEventDriven: true) 
		#component: #(SpecCollection 
			#collection: #(#(InputFieldSpec 
				#layout: #(Rectangle 503 16 630 39) 
				#name: #creationDate 
				#model: #creationDate) #(LabelSpec 
				#layout: #(Point 9 10) 
				#name: #Label3 
				#label: 'Version' 
				#style: #large) #(ActionButtonSpec 
				#layout: #(Rectangle 303 371 375 397) 
				#name: #ok 
				#isOpaque: true 
				#model: #closeRequest 
				#label: 'OK' 
				#defaultable: true) #(LabelSpec 
				#layout: #(Point 419 17) 
				#name: #Label4 
				#label: #(UserMessage 
					#key: #creationDate 
					#defaultString: 'creation date')) #(LabelSpec 
				#layout: #(Point 9 46) 
				#name: #Label5 
				#label: #(UserMessage 
					#key: #authors 
					#defaultString: 'Authors') 
				#style: #large) #(LabelSpec 
				#layout: #(Point 97 17) 
				#name: #Label1 
				#label: #(UserMessage 
					#key: #name 
					#defaultString: 'Name')) #(InputFieldSpec 
				#layout: #(Rectangle 132 16 232 39) 
				#name: #InputField1 
				#isOpaque: true 
				#colors: #(LookPreferences 
					#setBackgroundColor: #(ColorValue 6553 6553 6553)) 
				#model: #modelName 
				#isReadOnly: true) #(LabelSpec 
				#layout: #(Point 9 167) 
				#name: #Label7 
				#label: #(UserMessage 
					#key: #modelComments 
					#defaultString: 'Model comments') 
				#style: #large) #(TextEditorSpec 
				#layout: #(Rectangle 95 199 633 362) 
				#name: #TextEditor3 
				#model: #modelComments 
				#helpText: 'Write here the comments and purpose of the model' 
				#tabRequiresControl: true) #(DataSetSpec 
				#properties: #(PropertyListDictionary #showHorizontalLines true #allowColumnResizing true #showVerticalLines true #allowColumnReordering false) 
				#layout: #(Rectangle 96 55 631 165) 
				#name: #Dataset1 
				#model: #authorMailList 
				#columns: #(#(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #labelFromApplication false #allowSorting false #allowResizing true) 
					#model: #'selectedRow name' 
					#label: #(UserMessage 
						#key: #name 
						#defaultString: 'Name') 
					#labelIsImage: false 
					#width: 200 
					#editorType: #InputField 
					#noScroll: false 
					#labelsAsButtons: true) #(DataSetColumnSpec 
					#properties: #(PropertyListDictionary #allowSorting false #labelFromApplication false) 
					#model: #'selectedRow email' 
					#label: 'e-mail' 
					#labelIsImage: false 
					#width: 315 
					#editorType: #InputField 
					#noScroll: false 
					#labelsAsButtons: true)) 
				#labelsAsButtons: true) #(ActionButtonSpec 
				#layout: #(Rectangle 10 139 85 163) 
				#name: #ActionButton1 
				#model: #addRow 
				#label: #(UserMessage 
					#key: #addRow 
					#defaultString: 'Add Row') 
				#defaultable: true))))! !

!CommentInterface class methodsFor: 'finalizing' stamp: ' 26/3/15 16:27'!
finalizationRegistry
	" *** This method was defined by Object as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!CommentInterface class methodsFor: 'finalizing' stamp: ' 26/3/15 16:27'!
notifyWhenFinalizable: anObject
	" *** This method was defined by Object as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!CommentInterface methodsFor: 'actions' stamp: 'SergeStinckwich 4/1/2016 19:16'!
addRow
	
	authorMailList list add: CMAuthor new.
	^self! !

!CommentInterface methodsFor: 'aspects' stamp: ' 26/3/15 16:27'!
authorMailList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^authorMailList isNil
		ifTrue:
			[authorMailList := SelectionInList new.
			authorMailList selectionIndexHolder
				compute: [:v | self selectedRow value: authorMailList selection].
			authorMailList]
		ifFalse: [authorMailList]! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
authorName
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^authorName isNil
		ifTrue: [authorName := String new asValue]
		ifFalse: [authorName]! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
authorName: anObject
	
	authorName := anObject! !

!CommentInterface methodsFor: 'asList' stamp: 'SergeStinckwich 4/2/2015 20:42'!
authorsAsList
	
	^Cormas textAsList: self authorList value! !

!CommentInterface methodsFor: 'actions' stamp: ' 26/3/15 16:27'!
closeAccept
	"Allow the window to close if requestForWindowClose 
	answers true."
	
	self accept setValue: true.
	self cancel setValue: false.
	self close! !

!CommentInterface methodsFor: 'actions' stamp: ' 26/3/15 16:27'!
closeCancel
	"Allow the window to close.  Do not send requestForWindowClose."
	
	self accept setValue: false.
	self cancel setValue: true.
	self close! !

!CommentInterface methodsFor: 'interface closing' stamp: ' 26/3/15 16:27'!
closeRequest
	
	super closeRequest! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
cormasComments
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^cormasComments isNil
		ifTrue: [cormasComments := String new asValue]
		ifFalse: [cormasComments]! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
cormasComments: anObject
	
	cormasComments := anObject! !

!CommentInterface methodsFor: 'aspects' stamp: ' 26/3/15 16:27'!
creationDate
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^creationDate isNil
		ifTrue: [creationDate := String new asValue]
		ifFalse: [creationDate]! !

!CommentInterface methodsFor: 'finalizing' stamp: ' 26/3/15 16:27'!
finalizationRegistry
	" *** This method was defined by Object as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!CommentInterface methodsFor: 'initialize-release' stamp: ' 26/3/15 16:27'!
initOn: aModelClass
	"modelName creationDate eMailList authorList modelComments"
	
	modelName := aModelClass name asString asValue.
	aModelClass creationDate = ' '
		ifTrue: [creationDate := Date today printString asValue]
		ifFalse: [creationDate := aModelClass creationDate asValue].
	aModelClass getAuthors
		do: [:author | self authorMailList list add: author].
	aModelClass comments = 'Not yet commented...'
		ifFalse: [modelComments := aModelClass comments asValue]! !

!CommentInterface methodsFor: 'initialize-release' stamp: ' 26/3/15 16:27'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self authorMailList list: List new.
	super initialize.
	^self! !

!CommentInterface methodsFor: 'asList' stamp: 'SergeStinckwich 4/2/2015 20:42'!
mailAsList
	
	^Cormas textAsList: self eMailList value! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
modelComments
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^modelComments isNil
		ifTrue: [modelComments := String new asValue]
		ifFalse: [modelComments]! !

!CommentInterface methodsFor: 'aspects' stamp: ' 26/3/15 16:27'!
modelName
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^modelName isNil
		ifTrue: [modelName := String new asValue]
		ifFalse: [modelName]! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
newComments
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^newComments isNil
		ifTrue: [newComments := String new asValue]
		ifFalse: [newComments]! !

!CommentInterface methodsFor: 'finalizing' stamp: ' 26/3/15 16:27'!
notifyWhenFinalizable: anObject
	" *** This method was defined by Object as a subclass responsibility.
	Replace its body with a proper implementation. *** "
	
	self error: 'Subclass responsibility stub not reimplemented'! !

!CommentInterface methodsFor: 'accessing' stamp: ' 26/3/15 16:27'!
previousComments
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^previousComments isNil
		ifTrue: [previousComments := String new asValue]
		ifFalse: [previousComments]! !

!CommentInterface methodsFor: 'aspects' stamp: ' 26/3/15 16:27'!
selectedRow
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."
	
	^selectedRow isNil
		ifTrue: [selectedRow := nil asValue]
		ifFalse: [selectedRow]! !

Object subclass: #CormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!CormasHelper commentStamp: '<historical>' prior: 0!
a class for helping about type tests
usefull for #isKindOf: elimination!

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
arrayFrom: anElementOrArray
	"return an array for the argument"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
arrayOrNilFrom: anElementOrArray
	"return an array or a nil for the argument"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'unit tests' stamp: ' 26/3/15 16:36'!
assert: aValue equals: expectedValue
	
	aValue = expectedValue
		ifFalse:
			[self
				error:
					('<1p> was not the expected value <2p>' expandMacrosWith: aValue with:
							expectedValue)]! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
colorFrom: aSymbolOrColorValue
	"return a color value for the argument"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
colorOrBlackFrom: aColorValueOrElse
	"return either the argument if it is a colorValue or a black colorValue"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
elementsOf: collec1 equalElemenstOf: collec2
	"cheks if the elements of a collection or of a dictionnary are the same in both objects"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
isTypeArray
	"test if the helped objet is an Array (and not a String)"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeArrayNotChars
	"test if the helped objet is anArray and not a CharacterArray"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
isTypeBoolean
	"test if the helped objet is a Boolean"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeCollectionNotChars
	"test if the helped objet is a Collection and not a CharacterArray"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeColorValue
	"test if the helped objet is a ColorValue"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeDictionary
	"test if the helped objet is a dictionary"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeEntity
	"test if the helped object is an entity"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeEntityClass
	"test if the helped class is Entity"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
isTypeNumber
	"test if the helped objet is a Number"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:36'!
isTypeSet
	"test if the helped objet is a set"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
isTypeString
	"test if the helped objet is a String or Symbol"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
isTypeSymbol
	"test if the helped objet is a Symbol"
	
	^self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
nullValue
	"return the nullValue for the type"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:36'!
valueFrom: anObjectOrMenuItemOrValueHolder
	"return either the value of the argument or the argument itself "
	
	self subclassResponsibility! !

!CormasHelper class methodsFor: 'unit tests' stamp: ' 26/3/15 16:36'!
verify
	"
	self verify
	"
	
	self
		assert: 'abc' cormasHelper isTypeString
		equals: true.
	self
		assert: 'abc' cormasHelper isTypeArray
		equals: false.
	self
		assert: #(#abc) cormasHelper isTypeArray
		equals: true.
	self
		assert: #abc cormasHelper isTypeString
		equals: true.
	self
		assert: 123 cormasHelper isTypeNumber
		equals: true.
	self
		assert: 123 cormasHelper isTypeString
		equals: false.
	self
		assert: 'abc' cormasHelper nullValue
		equals: ''.
	self
		assert: #abc cormasHelper nullValue
		equals: #?.
	self
		assert: true cormasHelper nullValue
		equals: false.
	self
		assert: 123 cormasHelper nullValue
		equals: 0.
	Dialog warn: 'all tests success'! !

CormasHelper subclass: #ObjectCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ObjectCormasHelper commentStamp: '<historical>' prior: 0!
the helperClass for objects!

ObjectCormasHelper subclass: #BooleanCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!BooleanCormasHelper commentStamp: '<historical>' prior: 0!
helper class for booleans!

!BooleanCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 07:00'!
isTypeBoolean
	"test if the helped objet is a Boolean"
	
	^ true! !

!BooleanCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 07:00'!
nullValue
	"return the nullValue for the type"
	
	^ false! !

!BooleanCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:59'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	^ aDefaultValue asString! !

ObjectCormasHelper subclass: #CollectionCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!CollectionCormasHelper commentStamp: '<historical>' prior: 0!
helper class for collections!

CollectionCormasHelper subclass: #ArrayCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ArrayCormasHelper commentStamp: '<historical>' prior: 0!
helper class for arrays!

!ArrayCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 15:48'!
arrayFrom: anElementOrArray
	"return an array for the argument"
	
	^anElementOrArray! !

!ArrayCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 15:48'!
arrayOrNilFrom: anElementOrArray
	"return an array or a nil for the argument"
	
	^anElementOrArray! !

!ArrayCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 15:48'!
isTypeArray
	"test if the helped objet is an Array (and not aString)"
	
	^true! !

!ArrayCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 15:48'!
isTypeArrayNotChars
	"test if the helped objet is anArray and not a CharacterArray"
	
	^true! !

!ArrayCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 15:48'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	^'Array withAll: ' , aDefaultValue asString! !

ArrayCormasHelper subclass: #CharacterArrayCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!CharacterArrayCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:24'!
isTypeArray
	"test if the helped objet is an Array (and not aString)"
	
	^false! !

!CharacterArrayCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:24'!
isTypeArrayNotChars
	"test if the helped objet is anArray and not a CharacterArray"
	
	^false! !

!CharacterArrayCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:24'!
isTypeCollectionNotChars
	"test if the helped objet is a Collection and not a CharacterArray"
	
	^false! !

!CharacterArrayCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:24'!
isTypeString
	"test if the helped objet is a String or Symbol"
	
	^true! !

CharacterArrayCormasHelper subclass: #StringCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!StringCormasHelper commentStamp: '<historical>' prior: 0!
the helper class for strings!

!StringCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
isTypeString
	"test if the helped objet is a String or Symbol"
	
	^true! !

!StringCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
nullValue
	"return the nullValue for the type"
	
	^''! !

!StringCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	^aDefaultValue printString! !

StringCormasHelper subclass: #SymbolCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!SymbolCormasHelper commentStamp: '<historical>' prior: 0!
the helper class for symbols!

!SymbolCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
colorFrom: aColorOrSymbol
	"return a color value for the argument"
	
	^(ColorValue constantNames includes: aColorOrSymbol)
		ifTrue: [ColorValue perform: aColorOrSymbol]
		ifFalse: [ColorValue navy]! !

!SymbolCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
isTypeSymbol
	"test if the helped objet is a Symbol"
	
	^true! !

!SymbolCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:30'!
nullValue
	"return the nullValue for the type"
	
	^#?! !

!CollectionCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 07:04'!
elementsOf: collec1 equalElemenstOf: collec2
	
	^ collec1 hasEqualElements: collec2! !

!CollectionCormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:23'!
isTypeCollection
	"test if the helped objet is a collection "
	
	^true! !

!CollectionCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:23'!
isTypeCollectionNotChars
	"test if the helped objet is a Collection and not a CharacterArray"
	
	^true! !

!CollectionCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 07:04'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	| defaultString coll |
	aDefaultValue isEmpty
		ifTrue: [ defaultString := aDefaultValue class name asString , ' new' ]
		ifFalse: [ 
			defaultString := ''.
			coll := aDefaultValue asString substrings asOrderedCollection.
			coll add: 'withAll:' beforeIndex: 2.
			coll do: [ : sub | defaultString := defaultString , sub , ' ' ] ].
	^ defaultString! !

CollectionCormasHelper subclass: #SetCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!SetCormasHelper commentStamp: '<historical>' prior: 0!
helper class for sets!

!SetCormasHelper class methodsFor: 'testing type' stamp: ' 31/3/15 09:57'!
isTypeSet
	"test if the helped objet is a set"
	
	^true! !

ObjectCormasHelper subclass: #ColorValueCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ColorValueCormasHelper commentStamp: '<historical>' prior: 0!
helper class for colorValues!

!ColorValueCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:26'!
colorFrom: aColorOrSymbol
	"return a color value for the argument"
	
	^aColorOrSymbol! !

!ColorValueCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 16:26'!
colorOrBlackFrom: aColorValueOrElse
	"return either the argument if it is a colorValue or a black colorValue"
	
	^aColorValueOrElse! !

!ColorValueCormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 16:26'!
isTypeColorValue
	"test if the helped objet is a ColorValue"
	
	^true! !

ObjectCormasHelper subclass: #EntityClassCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!EntityClassCormasHelper commentStamp: '<historical>' prior: 0!
helper class for entity classes!

!EntityClassCormasHelper class methodsFor: 'testing type' stamp: ' 30/3/15 11:26'!
isTypeEntityClass
	"test if the helped class is Entity"
	
	^true! !

ObjectCormasHelper subclass: #EntityCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!EntityCormasHelper commentStamp: '<historical>' prior: 0!
helper class for entities!

!EntityCormasHelper class methodsFor: 'testing type' stamp: ' 30/3/15 15:32'!
isTypeEntity
	"test if the helped object is an entity"
	
	^true! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:58'!
arrayFrom: anElementOrArray
	" return an array for the argument "

	 ^ anElementOrArray isArray
			ifTrue: [ anElementOrArray ]
			ifFalse: [	Array with: anElementOrArray ]! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:58'!
arrayOrNilFrom: anElementOrArray
	"return an array or a nil for the argument"
	
	^ Array with: anElementOrArray! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:58'!
colorFrom: aColorOrSymbol
	"return a color value for the argument"
	
	^ Color colorFrom: aColorOrSymbol! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:58'!
colorOrBlackFrom: aColorValueOrElse
	"return either the argument if it is a colorValue or a black colorValue"
	
	^ Color black! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeArray
	"test if the helped objet is an Array (and not aString)"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeArrayNotChars
	"test if the helped objet is anArray and not a CharacterArray"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeBoolean
	"test if the helped objet is a Boolean"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeCollection
	"test if the helped objet is a collection "
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeCollectionNotChars
	"test if the helped objet is a Collection and not a CharacterArray"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeColorValue
	"test if the helped objet is a ColorValue"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeDictionary
	"test if the helped objet is a dictionary"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeEntity
	"test if the helped object is an entity"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeEntityClass
	"test if the helped class is Entity"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeNumber
	"test if the helped objet is a Number"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'testing type' stamp: ' 1/4/15 16:16'!
isTypeSet
	"test if the helped objet is a set"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeString
	"test if the helped objet is a String or Symbol"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: ' 1/4/15 16:16'!
isTypeSymbol
	"test if the helped objet is a Symbol"
	
	^false! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:58'!
nullValue
	"return the nullValue for the type"
	
	^ nil! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:59'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	^ aDefaultValue asString! !

!ObjectCormasHelper class methodsFor: 'helping' stamp: 'HernanMoralesDurand 12/12/2017 06:59'!
valueFrom: anObjectOrMenuItemOrValueHolder
	"return either the value of the argument if it is a MenuItem or a ValueHolder or the argument itself "
	
	^ anObjectOrMenuItemOrValueHolder! !

ObjectCormasHelper subclass: #UndefinedObjectCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!UndefinedObjectCormasHelper commentStamp: '<historical>' prior: 0!
helper class for nil!

!UndefinedObjectCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:34'!
arrayFrom: anElementOrArray
	"return an array for the argument"
	
	^#()! !

!UndefinedObjectCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:34'!
arrayOrNilFrom: anElementOrArray
	"return an array or a nil for the argument"
	
	^nil! !

!UndefinedObjectCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:34'!
colorFrom: aColorOrSymbol
	"return a color value for the argument"
	
	^nil! !

!UndefinedObjectCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:34'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	^'nil'! !

ObjectCormasHelper subclass: #ValueHolderCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!ValueHolderCormasHelper commentStamp: '<historical>' prior: 0!
helper class for value holders!

!ValueHolderCormasHelper class methodsFor: 'helping' stamp: ' 31/3/15 13:35'!
valueFrom: anObjectOrMenuItemOrValueHolder
	"return either the value of the argument if it is a MenuItem or a ValueHolder or the argument itself "
	
	^anObjectOrMenuItemOrValueHolder value! !

Object subclass: #DictionaryCormasHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

!DictionaryCormasHelper commentStamp: '<historical>' prior: 0!
helper class for dictionaries
!

!DictionaryCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 17:46'!
elementsOf: dico1 equalElemenstOf: dico2
	
	^dico1 contentsEquals: dico2! !

!DictionaryCormasHelper class methodsFor: 'testing type' stamp: ' 26/3/15 17:46'!
isTypeDictionary
	"test if the helped objet is a dictionary"
	
	^true! !

!DictionaryCormasHelper class methodsFor: 'helping' stamp: ' 26/3/15 17:46'!
stringForDefaultValue: aDefaultValue
	"return a string that is used to save a default value depending on its type"
	
	aDefaultValue isEmpty
		ifTrue: [^aDefaultValue class name asString , ' new']
		ifFalse: [self halt]! !

Object subclass: #Msg
	instanceVariableNames: 'sender receiver topic content symbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-VW-Ported'!

Msg class
	instanceVariableNames: 'isObserved'!

!Msg commentStamp: '<historical>' prior: 0!
Msg is an Object that will serve for communication. Any agents which needs to send a Msg will create an instance of a subclass of Msg and fulfil it. The message will have at least three attributes listed below. It is up to the modeller to create new instance variables to be used for the exchanges modelled.

Instance Variables:
	receiver	<LensAbsentee | Object>	description of receiver : it is an instance of a class inheriting from AgentComm or AgentCommLocation or GroupComm or GroupCommLocation. It means that the receiver has a mailbox and will be automatically registered by the channel.
	sender	<LensAbsentee | Object>	description of sender. Usually it is the instance of the entity sending the message. But the entity sending the message can leave it blank ( for anonymous message) or even fulfill it with another agent adress. 
	symbol	<Object>					content of the message to be fufilled to give some sense to the conversation. It can be anything. The undelying idea is to use it for meta-information on the conversation (indicating if it is a proposal, an acceptance, a denial, etc.).

Methods :
from: and from: to: are two methods to fulfill the sender and receiver attributes.

methods in the protocol pov are methods which output must be true or false. These pov methods are cretaed through Cormas interface (Model-> Define the observation->Communication). When selected at the interface of the observer it will be applied on each message transmitted by the channle. If the output is true a line betwwen the sender and the receiver will be displayed. By default always and never are proposed. They can be copied at the level of the subclass.

Class methods.

isObserved set the active pov.



!

Msg class
	instanceVariableNames: 'isObserved'!

!Msg class methodsFor: 'instance creation' stamp: ' 30/3/15 16:33'!
from: unAgent
	
	^super new from: unAgent! !

!Msg class methodsFor: 'instance creation' stamp: ' 30/3/15 16:33'!
from: unAgent to: unAutre
	"Purpose: Creates a message with a sender and a receiver. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: aSymbol = <anObject>
			anObject = <anObject>
Example: Msg topic: #comeHere content: aSpatialEntity)"
	
	^super new from: unAgent to: unAutre! !

!Msg class methodsFor: 'deprecated' stamp: 'SergeStinckwich 4/24/2015 11:57'!
from: anAgent to: anotherOne content: anObject
	"Purpose: Creates a message with a sender, a receiver and a content. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			anotherOne = <AgentComm or AgentCommLocation	
			anObject = <anObject>
Example: Msg from: anAgent1 to: anAgent2 content: aGift)"
	
	self deprecated: 'Deprecated during Pharo 4.0 migration'.
	^super new from: anAgent to: anotherOne content: anObject! !

!Msg class methodsFor: '+ communication' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne topic: anObject
	"Purpose: Creates a message with a sender, a receiver and a topic. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			anotherOne = <AgentComm or AgentCommLocation	
			anObject = <anObject>
Example: Msg from: anAgent1 to: anAgent2 topic: #hello)"
	
	^super new from: anAgent to: anotherOne topic: anObject! !

!Msg class methodsFor: '+ communication' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne topic: aSymbol content: anObject
	"Purpose: Creates a message with a sender, a receiver, a topic and a content. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			anotherOne = <AgentComm or AgentCommLocation	
			aSymbol = <anObject>
			anObject = <anObject>
Example: Msg from: anAgent1 to: anAgent2 topic: #comeHere content: aSpatialEntity)"
	
	^super new from: anAgent to: anotherOne topic: aSymbol content: anObject! !

!Msg class methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
isObserved
	
	^isObserved! !

!Msg class methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
isObserved: aSymbol
	
	isObserved := aSymbol! !

!Msg class methodsFor: 'testing' stamp: ' 30/3/15 16:33'!
isSituatedClass
	
	^false! !

!Msg class methodsFor: 'instance creation' stamp: ' 30/3/15 16:33'!
new: x
	
	^self new! !

!Msg class methodsFor: 'printing' stamp: ' 30/3/15 16:33'!
printHierarchy
	"Answer a description containing the names of all of the subclasses and superclasses of the receiver."
	
	| s |
	s := WriteStream on: (String new: 16).
	self printSubclassesOn: s level: 0.
	^s contents! !

!Msg class methodsFor: 'accessing class hierarchy' stamp: ' 30/3/15 16:33'!
printSubclassesOn: aStream level: level
	"As part of the algorithm for printing a description of the receiver, print the
	subclass on the file stream, aStream, indenting level times."
	
	| subs |
	level isZero
		ifFalse:
			[aStream cr.
			2 * level timesRepeat: [aStream space]].	"aStream print: self name asString."
	aStream nextPutAll: self name asString.	"aStream space; nextPut: $(.
	self instVarNames
		do: [:aName | aStream print: aName]
		separatedBy: [aStream space].
	aStream nextPut: $)."
	subs := self subclasses.	"self == Class ifTrue:
		[aStream crtab: level+1; nextPutAll: (#AllTheMetaclasses << #dialogs >> '... all the Metaclasses ...') asString.
		subs := subs reject: [:sub | sub isMeta]]."	"Print subclasses in alphabetical order"
	(subs
		asSortedStrings:
			[:p :x :y | 
			| collation |
			(collation := p
				collate: x name
				to: y name) < 0
				or:
					[collation = 0
						and:
							[x == y
								or:
									[(p
										collate: x printString
										to: y printString) <= 0]]]])
		do:
			[:sub | 
			sub
				printSubclassesOn: aStream
				level: level + 1]! !

!Msg class methodsFor: '- activityEditor' stamp: ' 30/3/15 16:33'!
superClassesUntil: aSuperClass
	"Return the super classes of the class sender until aSuperClass"
	
	| coll |
	coll := self withAllSuperclasses
		select: [:aClass | aClass inheritsFrom: aSuperClass].
	coll add: aSuperClass.
	^coll! !

!Msg class methodsFor: '+ util' stamp: ' 30/3/15 16:33'!
superClassesUntilEntity
	"Return the super classes of the class sender until Msg"
	
	^self superClassesUntil: Msg! !

!Msg class methodsFor: 'deprecated' stamp: 'SergeStinckwich 4/24/2015 11:57'!
to: anAgent content: anObject
	"Purpose: Creates a message with a receiver and a content. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			aContent = <anObject>
Example: Msg to: anAgent content: aGift)"
	
	self deprecated: 'Deprecated during Pharo 4.0 migration'.
	^super new to: anAgent content: anObject! !

!Msg class methodsFor: '+ communication' stamp: ' 30/3/15 16:33'!
to: anotherOne topic: aSymbol
	"Purpose: Creates a message with a receiver and a topic. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
Example: Msg to: anAgent topic: #hello)"
	
	^super new to: anotherOne topic: aSymbol! !

!Msg class methodsFor: '+ communication' stamp: ' 30/3/15 16:33'!
to: anotherOne topic: aSymbol content: anObject
	"Purpose: Creates a message with a receiver, a topic and a content. The message can be sent by a communicant agent using the method sendMessageSynchronously:  or sendMessageAsynchronously:
Argument: anAgent = <AgentComm or AgentCommLocation
			aSymbol = <anObject>
			anObject = <anObject>
Example: Msg to: anAgent topic: #comeHere content: aSpatialEntity)"
	
	^super new to: anotherOne topic: aSymbol content: anObject! !

!Msg methodsFor: 'pov' stamp: ' 30/3/15 16:33'!
always
	
	^true! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
content
	
	^self content! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
content: aValue
	
	content := aValue! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
from: anAgent
	"method to fulfill the sender attribute"
	
	self sender: anAgent! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne
	"method to fulfill the sender and receiver attributes"
	
	self sender: anAgent.
	self receiver: anotherOne! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne content: anObject
	"method to fulfill the sender and receiver attributes"
	
	self sender: anAgent.
	self receiver: anotherOne.
	self content: anObject! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne topic: aSymbol
	"method to fulfill the sender and receiver attributes"
	
	self sender: anAgent.
	self receiver: anotherOne.
	self topic: aSymbol! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
from: anAgent to: anotherOne topic: aSymbol content: anObject
	"method to fulfill the sender and receiver attributes"
	
	self sender: anAgent.
	self receiver: anotherOne.
	self topic: aSymbol.
	self content: anObject! !

!Msg methodsFor: 'pov' stamp: ' 30/3/15 16:33'!
never
	
	^false! !

!Msg methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 11:40'!
receiver
	^ receiver! !

!Msg methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 11:41'!
receiver: aReceiver
	receiver := aReceiver! !

!Msg methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 11:41'!
sender
	^ sender! !

!Msg methodsFor: 'accessing' stamp: 'SergeStinckwich 4/24/2015 11:41'!
sender: aSender
	sender := aSender! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
symbol
	
	^symbol! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
symbol: aSymbol
	
	symbol := aSymbol! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
to: anAgent content: aSymbol
	"method to fulfill the sender and receiver attributes"
	
	self receiver: anAgent.
	self content: aSymbol! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
to: anotherOne topic: aSymbol
	"method to fulfill the sender and receiver attributes"
	
	self receiver: anotherOne.
	self topic: aSymbol! !

!Msg methodsFor: 'private' stamp: ' 30/3/15 16:33'!
to: anotherOne topic: aSymbol content: anObject
	"method to fulfill the sender and receiver attributes"
	
	self receiver: anotherOne.
	self topic: aSymbol.
	self content: anObject! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
topic
	
	^topic! !

!Msg methodsFor: 'accessing' stamp: ' 30/3/15 16:33'!
topic: anObject
	
	topic := anObject! !
